/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('ngx-weui/core'), require('@angular/animations'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/actionsheet', ['exports', '@angular/common', '@angular/core', 'ngx-weui/core', '@angular/animations', 'rxjs'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].actionsheet = {}), global.ng.common, global.ng.core, global['ngx-weui'].core, global.ng.animations, global.rxjs));
}(this, (function (exports, i1, i0, core, animations, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: actionsheet.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetConfig = /** @class */ (function () {
        function ActionSheetConfig() {
            /**
             * 样式，默认：`ios`
             */
            this.skin = 'ios';
            /**
             * 取消文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        return ActionSheetConfig;
    }());
    ActionSheetConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ ActionSheetConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function ActionSheetConfig_Factory() { return new ActionSheetConfig(); }, token: ActionSheetConfig, providedIn: "root" });
    if (false) {
        /**
         * 样式，默认：`ios`
         * @type {?}
         */
        ActionSheetConfig.prototype.skin;
        /**
         * 标题
         * @type {?}
         */
        ActionSheetConfig.prototype.title;
        /**
         * 取消文本，默认：`取消`
         * @type {?}
         */
        ActionSheetConfig.prototype.cancel;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        ActionSheetConfig.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: actionsheet.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         * @param {?} cdr
         */
        function ActionSheetComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            this.destroied = false;
            this._shown = false;
            /**
             * 动画状态码
             */
            this._shownAnt = false;
            /**
             * 菜单内容
             */
            this.menus = [];
            /**
             * 关闭回调
             */
            this.close = new i0.EventEmitter();
        }
        Object.defineProperty(ActionSheetComponent.prototype, "_visibility", {
            /**
             * @return {?}
             */
            get: function () {
                return this._shownAnt ? 'show' : 'hide';
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        ActionSheetComponent.prototype.detectChanges = function () {
            if (this.destroied) {
                return;
            }
            this.cdr.detectChanges();
        };
        /**
         * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
         * @return {?}
         */
        ActionSheetComponent.prototype.show = function () {
            var _this = this;
            this.config = Object.assign(Object.assign({ backdrop: true, skin: 'auto' }, this.DEF), this.config);
            if (this.config.skin === 'auto') {
                this.config.skin = core.isAndroid() ? 'android' : 'ios';
            }
            this._shown = true;
            setTimeout(( /**
             * @return {?}
             */function () {
                _this._shownAnt = true;
                _this.detectChanges();
            }), 10);
            return new rxjs.Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否从背景上点击
         * @return {?}
         */
        ActionSheetComponent.prototype.hide = function (is_backdrop) {
            var _this = this;
            if (is_backdrop === true && this.config.backdrop === false) {
                return;
            }
            this._shownAnt = false;
            this.detectChanges();
            setTimeout(( /**
             * @return {?}
             */function () {
                _this._shown = false;
                _this.close.emit();
            }), this.config.skin === 'android' ? 200 : 300);
        };
        /**
         * 选择动作
         * @param {?} menu
         * @return {?}
         */
        ActionSheetComponent.prototype._onSelect = function (menu) {
            this.observer.next(menu);
            this.observer.complete();
            this.hide();
        };
        /**
         * @return {?}
         */
        ActionSheetComponent.prototype.ngOnDestroy = function () {
            this.destroied = true;
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                (( /** @type {?} */(this.observer))).unsubscribe();
            }
        };
        return ActionSheetComponent;
    }());
    ActionSheetComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-actionsheet',
                    exportAs: 'weuiActionsheet',
                    template: "<div class=\"weui-mask\" [@visibility]=\"_visibility\" (click)=\"hide(true)\"></div>\n<div class=\"weui-actionsheet\" [ngClass]=\"{ 'weui-actionsheet_toggle': _shownAnt && config.skin === 'ios' }\">\n  <div class=\"weui-actionsheet__title\" *ngIf=\"config.skin === 'ios' && config.title\">\n    <p class=\"weui-actionsheet__title-text\">{{ config.title }}</p>\n  </div>\n  <div class=\"weui-actionsheet__menu\">\n    <div class=\"weui-actionsheet__cell\" *ngFor=\"let item of menus\" (click)=\"_onSelect(item)\" [class.weui-actionsheet__cell_warn]=\"item.type === 'warn'\">\n      {{ item.text }}\n    </div>\n  </div>\n  <div class=\"weui-actionsheet__action\" style=\"color: var(--weui-FG-0);\" *ngIf=\"config.skin === 'ios' && config.cancel\">\n    <div class=\"weui-actionsheet__cell\" (click)=\"hide()\">{{ config.cancel }}</div>\n  </div>\n</div>\n",
                    animations: [
                        animations.trigger('visibility', [
                            animations.state('show', animations.style({ opacity: 1 })),
                            animations.state('hide', animations.style({ opacity: 0 })),
                            animations.transition('hide <=> show', [animations.animate(200)]),
                        ]),
                    ],
                    host: {
                        '[hidden]': '!_shown',
                        '[class.weui-skin_android]': 'config.skin === "android"',
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ActionSheetComponent.ctorParameters = function () { return [
        { type: ActionSheetConfig },
        { type: i0.ChangeDetectorRef }
    ]; };
    ActionSheetComponent.propDecorators = {
        config: [{ type: i0.Input }],
        menus: [{ type: i0.Input }],
        close: [{ type: i0.Output }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ActionSheetComponent.prototype.observer;
        /**
         * @type {?}
         * @private
         */
        ActionSheetComponent.prototype.destroied;
        /** @type {?} */
        ActionSheetComponent.prototype._shown;
        /**
         * 动画状态码
         * @type {?}
         */
        ActionSheetComponent.prototype._shownAnt;
        /**
         * 配置项
         * @type {?}
         */
        ActionSheetComponent.prototype.config;
        /**
         * 菜单内容
         * @type {?}
         */
        ActionSheetComponent.prototype.menus;
        /**
         * 关闭回调
         * @type {?}
         */
        ActionSheetComponent.prototype.close;
        /**
         * @type {?}
         * @private
         */
        ActionSheetComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        ActionSheetComponent.prototype.cdr;
    }

    var ActionSheetService = /** @class */ (function (_super) {
        __extends(ActionSheetService, _super);
        /**
         * @param {?} resolver
         * @param {?} applicationRef
         * @param {?} injector
         * @param {?} doc
         */
        function ActionSheetService(resolver, applicationRef, injector, doc) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            _this.applicationRef = applicationRef;
            _this.injector = injector;
            _this.doc = doc;
            return _this;
        }
        /**
         * 创建一个弹出式菜单并显示
         *
         * @param {?} menus 菜单内容
         * @param {?=} config 配置性（可选）
         * @return {?} 可订阅来获取结果
         */
        ActionSheetService.prototype.show = function (menus, config) {
            var _this = this;
            if (config === void 0) { config = {}; }
            /** @type {?} */
            var componentRef = this.build(ActionSheetComponent);
            componentRef.instance.menus = menus;
            componentRef.instance.config = config;
            componentRef.instance.close.subscribe(( /**
             * @return {?}
             */function () {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            return componentRef.instance.show();
        };
        return ActionSheetService;
    }(core.BaseService));
    ActionSheetService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    ActionSheetService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.ApplicationRef },
        { type: i0.Injector },
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ActionSheetService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ActionSheetService_Factory() { return new ActionSheetService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.ApplicationRef), i0.ɵɵinject(i0.INJECTOR), i0.ɵɵinject(i1.DOCUMENT)); }, token: ActionSheetService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        ActionSheetService.prototype.resolver;
        /**
         * @type {?}
         * @protected
         */
        ActionSheetService.prototype.applicationRef;
        /**
         * @type {?}
         * @protected
         */
        ActionSheetService.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        ActionSheetService.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: actionsheet.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ActionSheetModule = /** @class */ (function () {
        function ActionSheetModule() {
        }
        return ActionSheetModule;
    }());
    ActionSheetModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [i1.CommonModule],
                    declarations: [ActionSheetComponent],
                    exports: [ActionSheetComponent],
                    entryComponents: [ActionSheetComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-actionsheet.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ActionSheetComponent = ActionSheetComponent;
    exports.ActionSheetConfig = ActionSheetConfig;
    exports.ActionSheetModule = ActionSheetModule;
    exports.ActionSheetService = ActionSheetService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-actionsheet.umd.js.map
