/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@angular/common"),require("@angular/core"),require("ngx-weui/core"),require("@angular/animations"),require("rxjs")):"function"==typeof define&&define.amd?define("ngx-weui/actionsheet",["exports","@angular/common","@angular/core","ngx-weui/core","@angular/animations","rxjs"],t):t(((e=e||self)["ngx-weui"]=e["ngx-weui"]||{},e["ngx-weui"].actionsheet={}),e.ng.common,e.ng.core,e["ngx-weui"].core,e.ng.animations,e.rxjs)}(this,(function(e,t,n,i,o,s){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */var r=function(e,t){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)};Object.create;Object.create;var c=function(){this.skin="ios",this.cancel="取消",this.backdrop=!0};c.decorators=[{type:n.Injectable,args:[{providedIn:"root"}]}],c.ɵprov=n.ɵɵdefineInjectable({factory:function(){return new c},token:c,providedIn:"root"});var a=function(){function e(e,t){this.DEF=e,this.cdr=t,this.destroied=!1,this._shown=!1,this._shownAnt=!1,this.menus=[],this.close=new n.EventEmitter}return Object.defineProperty(e.prototype,"_visibility",{get:function(){return this._shownAnt?"show":"hide"},enumerable:!1,configurable:!0}),e.prototype.detectChanges=function(){this.destroied||this.cdr.detectChanges()},e.prototype.show=function(){var e=this;return this.config=Object.assign(Object.assign({backdrop:!0,skin:"auto"},this.DEF),this.config),"auto"===this.config.skin&&(this.config.skin=i.isAndroid()?"android":"ios"),this._shown=!0,setTimeout((function(){e._shownAnt=!0,e.detectChanges()}),10),new s.Observable((function(t){e.observer=t}))},e.prototype.hide=function(e){var t=this;!0===e&&!1===this.config.backdrop||(this._shownAnt=!1,this.detectChanges(),setTimeout((function(){t._shown=!1,t.close.emit()}),"android"===this.config.skin?200:300))},e.prototype._onSelect=function(e){this.observer.next(e),this.observer.complete(),this.hide()},e.prototype.ngOnDestroy=function(){this.destroied=!0,this.observer&&this.observer instanceof s.Subscription&&this.observer.unsubscribe()},e}();a.decorators=[{type:n.Component,args:[{selector:"weui-actionsheet",exportAs:"weuiActionsheet",template:'<div class="weui-mask" [@visibility]="_visibility" (click)="hide(true)"></div>\n<div class="weui-actionsheet" [ngClass]="{ \'weui-actionsheet_toggle\': _shownAnt && config.skin === \'ios\' }">\n  <div class="weui-actionsheet__title" *ngIf="config.skin === \'ios\' && config.title">\n    <p class="weui-actionsheet__title-text">{{ config.title }}</p>\n  </div>\n  <div class="weui-actionsheet__menu">\n    <div class="weui-actionsheet__cell" *ngFor="let item of menus" (click)="_onSelect(item)" [class.weui-actionsheet__cell_warn]="item.type === \'warn\'">\n      {{ item.text }}\n    </div>\n  </div>\n  <div class="weui-actionsheet__action" style="color: var(--weui-FG-0);" *ngIf="config.skin === \'ios\' && config.cancel">\n    <div class="weui-actionsheet__cell" (click)="hide()">{{ config.cancel }}</div>\n  </div>\n</div>\n',animations:[o.trigger("visibility",[o.state("show",o.style({opacity:1})),o.state("hide",o.style({opacity:0})),o.transition("hide <=> show",[o.animate(200)])])],host:{"[hidden]":"!_shown","[class.weui-skin_android]":'config.skin === "android"'},preserveWhitespaces:!1,changeDetection:n.ChangeDetectionStrategy.OnPush,encapsulation:n.ViewEncapsulation.None}]}],a.ctorParameters=function(){return[{type:c},{type:n.ChangeDetectorRef}]},a.propDecorators={config:[{type:n.Input}],menus:[{type:n.Input}],close:[{type:n.Output}]};var u=function(e){function t(t,n,i,o){var s=e.call(this)||this;return s.resolver=t,s.applicationRef=n,s.injector=i,s.doc=o,s}return function(e,t){function n(){this.constructor=e}r(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}(t,e),t.prototype.show=function(e,t){var n=this;void 0===t&&(t={});var i=this.build(a);return i.instance.menus=e,i.instance.config=t,i.instance.close.subscribe((function(){setTimeout((function(){n.destroy(i)}),100)})),i.instance.show()},t}(i.BaseService);u.decorators=[{type:n.Injectable,args:[{providedIn:"root"}]}],u.ctorParameters=function(){return[{type:n.ComponentFactoryResolver},{type:n.ApplicationRef},{type:n.Injector},{type:void 0,decorators:[{type:n.Inject,args:[t.DOCUMENT]}]}]},u.ɵprov=n.ɵɵdefineInjectable({factory:function(){return new u(n.ɵɵinject(n.ComponentFactoryResolver),n.ɵɵinject(n.ApplicationRef),n.ɵɵinject(n.INJECTOR),n.ɵɵinject(t.DOCUMENT))},token:u,providedIn:"root"});var h=function(){};h.decorators=[{type:n.NgModule,args:[{imports:[t.CommonModule],declarations:[a],exports:[a],entryComponents:[a]}]}],e.ActionSheetComponent=a,e.ActionSheetConfig=c,e.ActionSheetModule=h,e.ActionSheetService=u,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=ngx-weui-actionsheet.umd.min.js.map