/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('ngx-weui/core'), require('rxjs'), require('@angular/forms'), require('ngx-weui/form'), require('ngx-weui/mask'), require('ngx-weui/slider')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/dialog', ['exports', '@angular/common', '@angular/core', 'ngx-weui/core', 'rxjs', '@angular/forms', 'ngx-weui/form', 'ngx-weui/mask', 'ngx-weui/slider'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].dialog = {}), global.ng.common, global.ng.core, global['ngx-weui'].core, global.rxjs, global.ng.forms, global['ngx-weui'].form, global['ngx-weui'].mask, global['ngx-weui'].slider));
}(this, (function (exports, i1, i0, core, rxjs, forms, form, mask, slider) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: dialog.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DialogConfig = /** @class */ (function () {
        function DialogConfig() {
            /**
             * 对话框类型，默认：`default`
             * default：默认文本或HTML格式
             * prompt：可输入对话框
             */
            this.type = 'default';
            /**
             * 样式，默认：`auto`
             */
            this.skin = 'auto';
            /**
             * 取消，返回false，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 取消按钮类型，默认：`default`
             */
            this.cancelType = 'default';
            /**
             * 确认，返回true，默认：`确认`
             */
            this.confirm = '确认';
            /**
             * 确认按钮类型，默认：`primary`
             */
            this.confirmType = 'primary';
            /**
             * 允许点击背景关闭，默认：`false`
             */
            this.backdrop = false;
        }
        return DialogConfig;
    }());
    DialogConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ DialogConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function DialogConfig_Factory() { return new DialogConfig(); }, token: DialogConfig, providedIn: "root" });
    if (false) {
        /**
         * 对话框类型，默认：`default`
         * default：默认文本或HTML格式
         * prompt：可输入对话框
         * @type {?}
         */
        DialogConfig.prototype.type;
        /**
         * 样式，默认：`auto`
         * @type {?}
         */
        DialogConfig.prototype.skin;
        /**
         * 标题
         * @type {?}
         */
        DialogConfig.prototype.title;
        /**
         * 内容（支持HTML）
         * @type {?}
         */
        DialogConfig.prototype.content;
        /**
         * Input `type` 字段
         * @type {?}
         */
        DialogConfig.prototype.input;
        /**
         * Input `placeholder` 字段
         * @type {?}
         */
        DialogConfig.prototype.inputPlaceholder;
        /**
         * Input 初始化值
         * @type {?}
         */
        DialogConfig.prototype.inputValue;
        /**
         * Input `required` 字段，必填项校验失败时【确定】按钮为 `disabled` 状态，默认：`true`
         * @type {?}
         */
        DialogConfig.prototype.inputRequired;
        /**
         * Input 正则判断校验。
         * 如无指定，会根据 `input` 类型分别对：`email`、`url` 默认提供正则表达式
         * @type {?}
         */
        DialogConfig.prototype.inputRegex;
        /**
         * 输入参数无效时提醒文本
         * @type {?}
         */
        DialogConfig.prototype.inputError;
        /**
         * 数据数组，如果input值为 `select` `radio` `checkbox` 时为必填项
         * @type {?}
         */
        DialogConfig.prototype.inputOptions;
        /**
         * HTML元素属性对象，例如 `min` `max` 等，对象键表示属性名，对象值表示属性值
         * @type {?}
         */
        DialogConfig.prototype.inputAttributes;
        /**
         * 取消，返回false，默认：`取消`
         * @type {?}
         */
        DialogConfig.prototype.cancel;
        /**
         * 取消按钮类型，默认：`default`
         * @type {?}
         */
        DialogConfig.prototype.cancelType;
        /**
         * 确认，返回true，默认：`确认`
         * @type {?}
         */
        DialogConfig.prototype.confirm;
        /**
         * 确认按钮类型，默认：`primary`
         * @type {?}
         */
        DialogConfig.prototype.confirmType;
        /**
         * 自定义按钮组，当此属性存在时 `cancel` & `confirm` 参数将失效
         * @type {?}
         */
        DialogConfig.prototype.btns;
        /**
         * 允许点击背景关闭，默认：`false`
         * @type {?}
         */
        DialogConfig.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: dialog.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 对话框，依赖于 `weui-textarea`、`weui-slider`
     *
     * 关于 `input==='prompt'` 若干细节：
     *  + 对话框内放表单在weui的表现并不是很如意，因此，在对话框增加 `.weui-dialog__prompt` 样式类名，请自行针对性进行一些样式的覆盖，`ngx-dialog` 不提供任何样式的修正。
     *  + 对于录入型表单其校验机制全都是依赖于正则，默认情况下内置 `email`、`url` 两种表单类型的正则。
     */
    var DialogComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         * @param {?} cdr
         */
        function DialogComponent(DEF, cdr) {
            this.DEF = DEF;
            this.cdr = cdr;
            this._shown = false;
            /**
             * 打开动画结束后回调（唯一参数：对话框实例对象）
             */
            this.open = new i0.EventEmitter();
            /**
             * 关闭动画开始时回调（唯一参数：对话框实例对象）
             */
            this.close = new i0.EventEmitter();
            this._prompError = false;
        }
        Object.defineProperty(DialogComponent.prototype, "config", {
            /**
             * @return {?}
             */
            get: function () {
                return this._config;
            },
            /**
             * 对话框配置项
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                var _this = this;
                /** @type {?} */
                var config = Object.assign(Object.assign({ backdrop: false }, this.DEF), value);
                if (config.skin === 'auto') {
                    config.skin = core.isAndroid() ? 'android' : 'ios';
                }
                // 重组btns
                if (!config.btns) {
                    config.btns = [];
                    if (config.cancel) {
                        config.btns.push({
                            text: config.cancel,
                            type: ( /** @type {?} */(config.cancelType)),
                            value: false,
                        });
                    }
                    if (config.confirm) {
                        config.btns.push({
                            text: config.confirm,
                            type: ( /** @type {?} */(config.confirmType)),
                            value: true,
                        });
                    }
                }
                // prompt
                if (config.type === 'prompt') {
                    // 一些默认校验正则表达式
                    if (!config.inputRegex) {
                        switch (config.input) {
                            case 'email':
                                config.inputRegex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                                if (!config.inputError) {
                                    config.inputError = '邮箱格式不正确';
                                }
                                break;
                            case 'url':
                                config.inputRegex = /^(https?:\/\/)?([\da-z\.-]+)\.([a-z\.]{2,6})([\/\w \.-]*)*\/?$/;
                                if (!config.inputError) {
                                    config.inputError = '网址格式不正确';
                                }
                                break;
                        }
                    }
                    config.inputOptions = ( /** @type {?} */((config.inputOptions || []))).slice(0);
                    config.inputAttributes = Object.assign({ maxlength: null, min: 0, max: 100, step: 1 }, config.inputAttributes);
                    // 默认值
                    /** @type {?} */
                    var defaultValue = config.inputValue;
                    if (config.input === 'checkbox' && !Array.isArray(config.inputValue)) {
                        defaultValue = typeof defaultValue !== 'undefined' ? [defaultValue] : [];
                    }
                    config.inputValue = defaultValue || '';
                    this._promptData = config.inputValue;
                    if (this._promptData) {
                        this._config = config;
                        this.promptCheck();
                    }
                    setTimeout(( /**
                     * @return {?}
                     */function () {
                        _this.setFocus();
                    }), 100);
                }
                this._config = config;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        DialogComponent.prototype.promptCheck = function () {
            if (this.config.inputRequired === true) {
                if (this.config.input === 'checkbox' && this._promptData.length === 0) {
                    this._prompError = true;
                    return false;
                }
                if (!this._promptData) {
                    this._prompError = true;
                    return false;
                }
            }
            if (this.config.inputRegex && !this.config.inputRegex.test(this._promptData.toString())) {
                this._prompError = true;
                return false;
            }
            this._prompError = false;
            return true;
        };
        /**
         * @private
         * @return {?}
         */
        DialogComponent.prototype.setFocus = function () {
            /** @type {?} */
            var containerEl = this.container.nativeElement;
            /** @type {?} */
            var firstFormEl = null;
            if (this.config.type === 'prompt') {
                firstFormEl = containerEl.querySelector('input, textarea, select');
            }
            else {
                firstFormEl = containerEl.querySelector('.weui-dialog__btn_primary');
            }
            if (firstFormEl) {
                firstFormEl.focus();
            }
        };
        /**
         * @return {?}
         */
        DialogComponent.prototype._chanage = function () {
            this.promptCheck();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        DialogComponent.prototype._keyup = function (event) {
            // tslint:disable-next-line: deprecation
            if (event.keyCode === 13) {
                this._onSelect();
            }
        };
        /**
         * 显示，组件载入页面后并不会显示，显示调用 `show()` 并订阅结果。
         *
         * @return {?} 当 `type==='prompt'` 时会多一 `result` 属性表示结果值
         */
        DialogComponent.prototype.show = function () {
            var _this = this;
            this._shown = true;
            this._prompError = false;
            this.cdr.detectChanges();
            // 模拟动画结束后回调
            setTimeout(( /**
             * @return {?}
             */function () {
                _this.open.emit(_this);
            }), 300);
            return new rxjs.Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                _this.observer = observer;
            }));
        };
        /**
         * 隐藏
         *
         * @param {?=} is_backdrop 是否从背景上点击
         * @return {?}
         */
        DialogComponent.prototype.hide = function (is_backdrop) {
            if (is_backdrop === void 0) { is_backdrop = false; }
            if (is_backdrop === true && this.config.backdrop === false) {
                return;
            }
            this._shown = false;
            this.cdr.detectChanges();
            this.close.emit(this);
        };
        /**
         * @param {?=} menu
         * @return {?}
         */
        DialogComponent.prototype._onSelect = function (menu) {
            // 未指定时查找 `value===true` 的按钮
            if (!menu && ( /** @type {?} */(this.config.btns)).length > 0) {
                menu = ( /** @type {?} */(this.config.btns)).find(( /**
                 * @param {?} w
                 * @return {?}
                 */function (/**
                 * @param {?} w
                 * @return {?}
                 */ w) { return w.value === true; }));
            }
            /** @type {?} */
            var ret = menu;
            if (menu.value === true && this._config.type === 'prompt') {
                if (!this.promptCheck()) {
                    return false;
                }
                ret.result = this._promptData;
            }
            this.observer.next(ret);
            this.observer.complete();
            this.hide();
            return false;
        };
        /**
         * @return {?}
         */
        DialogComponent.prototype.ngOnDestroy = function () {
            if (this.observer && this.observer instanceof rxjs.Subscription) {
                (( /** @type {?} */(this.observer))).unsubscribe();
            }
        };
        return DialogComponent;
    }());
    DialogComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-dialog',
                    exportAs: 'weuiDialog',
                    template: "<div class=\"weui-mask\" [ngClass]=\"{ 'weui-mask__in': _shown }\" (click)=\"hide(true)\"></div>\n<div class=\"weui-dialog\" [ngClass]=\"{\n    'weui-dialog__in': _shown,\n    'weui-skin_android': config.skin === 'android',\n    'weui-dialog__prompt': config.type === 'prompt'\n  }\" #container>\n  <div class=\"weui-dialog__hd\" *ngIf=\"config.title\">\n    <strong class=\"weui-dialog__title\">{{ config.title }}</strong>\n  </div>\n  <div class=\"weui-dialog__bd\" *ngIf=\"config.content\" [innerHTML]=\"config.content\"></div>\n  <div class=\"weui-cells\" *ngIf=\"config.type === 'prompt' && _shown\">\n    <ng-container [ngSwitch]=\"config.input\">\n      <div *ngSwitchCase=\"'textarea'\" class=\"weui-cell\" [ngClass]=\"{ 'weui-cell_warn': _prompError }\">\n        <div class=\"weui-cell__bd\">\n          <textarea class=\"weui-textarea\" placeholder=\"{{ config.inputPlaceholder }}\" [(ngModel)]=\"_promptData\"\n            name=\"_promptData\" (ngModelChange)=\"_chanage()\" weui-textarea [weui-cn]=\"config.inputAttributes.cn\"\n            [maxlength]=\"config.inputAttributes.maxlength\"></textarea>\n        </div>\n      </div>\n      <div *ngSwitchCase=\"'select'\" class=\"weui-cell weui-cell_select\">\n        <div class=\"weui-cell__bd\">\n          <select class=\"weui-select\" [(ngModel)]=\"_promptData\" name=\"_promptData\" (ngModelChange)=\"_chanage()\">\n            <option *ngFor=\"let i of config.inputOptions\" [ngValue]=\"i\">{{ i.text }}</option>\n          </select>\n        </div>\n      </div>\n      <div *ngSwitchCase=\"'radio'\" class=\"weui-cells_radio\">\n        <label class=\"weui-cell weui-check__label\" *ngFor=\"let i of config.inputOptions\">\n          <div class=\"weui-cell__bd\">\n            <p>{{ i.text }}</p>\n          </div>\n          <div class=\"weui-cell__ft\">\n            <input type=\"radio\" (click)=\"_promptData = i\" [checked]=\"i == _promptData\" (change)=\"_chanage()\"\n              class=\"weui-check\" />\n            <span class=\"weui-icon-checked\"></span>\n          </div>\n        </label>\n      </div>\n      <div *ngSwitchCase=\"'checkbox'\" class=\"weui-cells_checkbox\">\n        <label class=\"weui-cell weui-check__label\" *ngFor=\"let i of config.inputOptions\">\n          <div class=\"weui-cell__hd\">\n            <input type=\"checkbox\" class=\"weui-check\" (change)=\"_chanage()\" [weui-checklist]=\"_promptData\"\n              [weui-value]=\"i\" name=\"_promptData\" />\n            <i class=\"weui-icon-checked\"></i>\n          </div>\n          <div class=\"weui-cell__bd\">\n            <p>{{ i.text }}</p>\n          </div>\n        </label>\n      </div>\n      <div *ngSwitchCase=\"'range'\" class=\"weui-slider-box\" [(ngModel)]=\"_promptData\" name=\"_promptData\" weui-slider\n        [weui-min]=\"config.inputAttributes.min\" [weui-max]=\"config.inputAttributes.max\"\n        [weui-step]=\"config.inputAttributes.step\">\n        <div class=\"weui-slider\">\n          <div class=\"weui-slider__inner\">\n            <div class=\"weui-slider__track\"></div>\n            <div class=\"weui-slider__handler\"></div>\n          </div>\n        </div>\n        <div class=\"weui-slider-box__value\">{{ _promptData }}</div>\n      </div>\n      <div *ngSwitchDefault class=\"weui-cell\" [ngClass]=\"{ 'weui-cell_warn': _prompError }\">\n        <div class=\"weui-cell__bd\">\n          <input type=\"{{ config.input }}\" class=\"weui-input\" placeholder=\"{{ config.inputPlaceholder }}\"\n            [(ngModel)]=\"_promptData\" name=\"_promptData\" [maxlength]=\"config.inputAttributes.maxlength\"\n            (ngModelChange)=\"_chanage()\" (keyup)=\"_keyup($event)\" />\n        </div>\n        <div class=\"weui-cell__ft\">\n          <i class=\"weui-icon-warn\" *ngIf=\"_prompError\"></i>\n        </div>\n      </div>\n    </ng-container>\n  </div>\n  <div class=\"weui-dialog__error\" *ngIf=\"_prompError\">{{ config.inputError }}</div>\n  <div class=\"weui-dialog__ft\">\n    <a href=\"#\" *ngFor=\"let item of config.btns\" class=\"weui-dialog__btn weui-dialog__btn_{{ item.type }}\"\n      (click)=\"_onSelect(item)\">{{ item.text }}</a>\n  </div>\n</div>\n",
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    DialogComponent.ctorParameters = function () { return [
        { type: DialogConfig },
        { type: i0.ChangeDetectorRef }
    ]; };
    DialogComponent.propDecorators = {
        open: [{ type: i0.Output }],
        close: [{ type: i0.Output }],
        container: [{ type: i0.ViewChild, args: ['container', { static: true },] }],
        config: [{ type: i0.Input }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DialogComponent.prototype._config;
        /**
         * @type {?}
         * @private
         */
        DialogComponent.prototype.observer;
        /** @type {?} */
        DialogComponent.prototype._shown;
        /**
         * 打开动画结束后回调（唯一参数：对话框实例对象）
         * @type {?}
         */
        DialogComponent.prototype.open;
        /**
         * 关闭动画开始时回调（唯一参数：对话框实例对象）
         * @type {?}
         */
        DialogComponent.prototype.close;
        /** @type {?} */
        DialogComponent.prototype.container;
        /** @type {?} */
        DialogComponent.prototype._prompError;
        /** @type {?} */
        DialogComponent.prototype._promptData;
        /**
         * @type {?}
         * @private
         */
        DialogComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        DialogComponent.prototype.cdr;
    }

    var DialogService = /** @class */ (function (_super) {
        __extends(DialogService, _super);
        /**
         * @param {?} resolver
         * @param {?} applicationRef
         * @param {?} injector
         * @param {?} doc
         */
        function DialogService(resolver, applicationRef, injector, doc) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            _this.applicationRef = applicationRef;
            _this.injector = injector;
            _this.doc = doc;
            return _this;
        }
        /**
         * 创建一个对话框并显示
         *
         * @param {?} data 对话框配置项
         * @return {?} 可订阅来获取结果
         */
        DialogService.prototype.show = function (data) {
            var _this = this;
            /** @type {?} */
            var componentRef = this.build(DialogComponent);
            componentRef.instance.config = data;
            componentRef.instance.close.subscribe(( /**
             * @return {?}
             */function () {
                setTimeout(( /**
                 * @return {?}
                 */function () { return _this.destroy(componentRef); }), 300);
            }));
            return componentRef.instance.show();
        };
        return DialogService;
    }(core.BaseService));
    DialogService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    DialogService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.ApplicationRef },
        { type: i0.Injector },
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ DialogService.ɵprov = i0.ɵɵdefineInjectable({ factory: function DialogService_Factory() { return new DialogService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.ApplicationRef), i0.ɵɵinject(i0.INJECTOR), i0.ɵɵinject(i1.DOCUMENT)); }, token: DialogService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        DialogService.prototype.resolver;
        /**
         * @type {?}
         * @protected
         */
        DialogService.prototype.applicationRef;
        /**
         * @type {?}
         * @protected
         */
        DialogService.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        DialogService.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: dialog.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DialogModule = /** @class */ (function () {
        function DialogModule() {
        }
        return DialogModule;
    }());
    DialogModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [i1.CommonModule, forms.FormsModule, mask.MaskModule, form.FormModule, slider.SliderModule],
                    declarations: [DialogComponent],
                    exports: [DialogComponent],
                    entryComponents: [DialogComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-dialog.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.DialogComponent = DialogComponent;
    exports.DialogConfig = DialogConfig;
    exports.DialogModule = DialogModule;
    exports.DialogService = DialogService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-dialog.umd.js.map
