/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/form', ['exports', '@angular/core', '@angular/forms', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].form = {}), global.ng.core, global.ng.forms, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, core, forms, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: input.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文本框，指令是对文本框格式校验（邮箱、手机、身份证等）、视觉效果的增强而已
     */
    var InputDirective = /** @class */ (function () {
        /**
         * @param {?} el
         */
        function InputDirective(el) {
            this.el = el;
            /**
             * 是否必填项，**等同于** <intpu required> 的值，当值必填时会有视觉效果
             */
            this.required = 'warn';
            /**
             * 是否自动清除内容中的空格
             */
            this.cleaner = false;
        }
        /**
         * @return {?}
         */
        InputDirective.prototype.ngOnInit = function () {
            this.parentEl = core$1.findParent(this.el.nativeElement, '.weui-cell');
            if (!this.parentEl) {
                console.error('父DOM结构至少必须包含一个.weui-cell');
                return;
            }
            // 检查是否有 weui-cell__ft
            this.ftEl = core$1.add(this.parentEl);
        };
        /**
         * @return {?}
         */
        InputDirective.prototype.ngOnChanges = function () {
            this._createValidator();
            if (this._onChange) {
                this._onChange();
            }
        };
        /**
         * @private
         * @return {?}
         */
        InputDirective.prototype._createValidator = function () {
            var _this = this;
            /** @type {?} */
            var regex = null;
            if (this.inputRegex) {
                if (typeof this.inputRegex === 'string') {
                    regex = new RegExp("^" + this.inputRegex + "$");
                }
                else {
                    regex = this.inputRegex;
                }
            }
            else {
                // 默认行为
                if (this.inputType) {
                    switch (this.inputType) {
                        case 'qq':
                        case 'number':
                            regex = /^[0-9]+$/;
                            break;
                        case 'digit':
                            regex = /^[.0-9]+$/;
                            break;
                        case 'tel':
                            regex = /^[-.0-9]+$/;
                            break;
                        case 'email':
                            regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
                            this.cleaner = true;
                            break;
                        case 'mobile':
                            regex = /^1[0-9]{10}$/;
                            this.cleaner = true;
                            break;
                        case 'idcard': // 身份证
                            regex = /^[X0-9]{15,18}$/;
                            this.cleaner = true;
                            break;
                    }
                }
            }
            this._validator = ( /**
             * @param {?} control
             * @return {?}
             */function (control) {
                /** @type {?} */
                var value = control.value;
                if (value == null || value.length === 0) {
                    if (_this.required !== undefined) {
                        return { icon: _this.required, type: 'required', actualValue: value };
                    }
                    return null;
                }
                if (_this.cleaner && value.includes(' ')) {
                    value = value.replace(/ /g, '');
                    control.setValue(value, { emitEvent: false });
                }
                return regex === null || regex.test(value) ? null : { icon: 'warn', type: 'regex', actualValue: value };
            });
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        InputDirective.prototype.registerOnValidatorChange = function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} c
         * @return {?}
         */
        InputDirective.prototype.validate = function (c) {
            if (!this.parentEl) {
                return null;
            }
            /** @type {?} */
            var ret = this._validator(c);
            if (ret === null) {
                this.parentEl.classList.remove('weui-cell_warn');
                core$1.remove(this.ftEl, 'i');
            }
            else {
                core$1.remove(this.ftEl, 'i');
                this.parentEl.classList.add('weui-cell_warn');
                /** @type {?} */
                var icon = "weui-icon-" + ret.icon;
                core$1.add(this.ftEl, '.' + icon, 'i', icon);
            }
            return ret;
        };
        return InputDirective;
    }());
    InputDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[weui-input]',
                    exportAs: 'weuiInput',
                    providers: [
                        {
                            provide: forms.NG_VALIDATORS,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return InputDirective; })),
                            multi: true,
                        },
                    ],
                },] }
    ];
    /** @nocollapse */
    InputDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    InputDirective.propDecorators = {
        inputType: [{ type: core.Input, args: ['weui-input',] }],
        inputRegex: [{ type: core.Input, args: ['weui-regex',] }],
        required: [{ type: core.Input, args: ['weui-required',] }],
        cleaner: [{ type: core.Input, args: ['weui-cleaner',] }]
    };
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], InputDirective.prototype, "cleaner", void 0);
    if (false) {
        /**
         * @type {?}
         * @private
         */
        InputDirective.prototype.parentEl;
        /**
         * @type {?}
         * @private
         */
        InputDirective.prototype.ftEl;
        /**
         * @type {?}
         * @private
         */
        InputDirective.prototype._validator;
        /**
         * @type {?}
         * @private
         */
        InputDirective.prototype._onChange;
        /**
         * 文本框类型，**不等同于** <intpu type="text"> 的值
         * 因为 weui-input 属性只是内置格式校验的简洁写法而已。
         * 内置包括：number/digit(允许小数点)/qq/email/tel/mobile/idcard，如需要更为复杂的校验可以使用 weui-regex
         * @type {?}
         */
        InputDirective.prototype.inputType;
        /**
         * 格式校验正则表达式，优先级高于 [weui-input]。
         * @type {?}
         */
        InputDirective.prototype.inputRegex;
        /**
         * 是否必填项，**等同于** <intpu required> 的值，当值必填时会有视觉效果
         * @type {?}
         */
        InputDirective.prototype.required;
        /**
         * 是否自动清除内容中的空格
         * @type {?}
         */
        InputDirective.prototype.cleaner;
        /**
         * @type {?}
         * @private
         */
        InputDirective.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: check.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChecklistDirective = /** @class */ (function () {
        function ChecklistDirective() {
            this.checked = false;
        }
        Object.defineProperty(ChecklistDirective.prototype, "value", {
            /**
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this._value = val;
                this.checked = this.targetArray.indexOf(val) !== -1;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @param {?} $event
         * @return {?}
         */
        ChecklistDirective.prototype._change = function ($event) {
            if ($event.target.checked) {
                this.targetArray.push(this._value);
            }
            else {
                this.targetArray.splice(this.targetArray.indexOf(this._value), 1);
            }
        };
        return ChecklistDirective;
    }());
    ChecklistDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[weui-checklist]',
                    exportAs: 'weuiChecklist',
                    host: {
                        '(change)': '_change($event)',
                        '[checked]': 'checked',
                    },
                },] }
    ];
    ChecklistDirective.propDecorators = {
        targetArray: [{ type: core.Input, args: ['weui-checklist',] }],
        value: [{ type: core.Input, args: ['weui-value',] }]
    };
    if (false) {
        /** @type {?} */
        ChecklistDirective.prototype.targetArray;
        /** @type {?} */
        ChecklistDirective.prototype.checked;
        /**
         * @type {?}
         * @private
         */
        ChecklistDirective.prototype._value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: vcode.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 获取验证码
     */
    var VCodeDirective = /** @class */ (function () {
        /**
         * @param {?} el
         */
        function VCodeDirective(el) {
            this.el = el;
            /**
             * 时长（单位：秒），默认：`60`
             */
            this.seconds = 60;
            /**
             * 倒计时模板，使用 `${num}` 表示当前秒数
             */
            // tslint:disable-next-line: no-invalid-template-strings
            this.tpl = '${num} 秒';
            /**
             * 重新发送提醒文本
             */
            this.error = '重新发送';
            this._disabled = false;
        }
        /**
         * @return {?}
         */
        VCodeDirective.prototype.ngOnInit = function () {
            if (typeof this.onSend !== 'function') {
                console.error('weui-vcode必须传递一个返回值为 `Observable<boolean>` 函数');
            }
            this._cur = this.el.nativeElement.innerHTML;
        };
        /**
         * @return {?}
         */
        VCodeDirective.prototype._onClick = function () {
            var _this = this;
            this._disabled = true;
            this.onSend().subscribe(( /**
             * @param {?} res
             * @return {?}
             */function (/**
             * @param {?} res
             * @return {?}
             */ res) {
                res ? _this.tick() : _this.err();
            }));
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.err = function () {
            this._disabled = false;
            this.el.nativeElement.innerHTML = this.error;
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.tick = function () {
            var _this = this;
            /** @type {?} */
            var count = this.seconds < 1 ? 1 : this.seconds;
            this.setText(count);
            this._t = setInterval(( /**
             * @return {?}
             */function () {
                if (--count <= 0) {
                    _this._disabled = false;
                    _this.el.nativeElement.innerHTML = _this._cur;
                    _this.destroy();
                }
                else {
                    _this.setText(count);
                }
            }), 1000);
        };
        /**
         * @private
         * @param {?} num
         * @return {?}
         */
        VCodeDirective.prototype.setText = function (num) {
            this.el.nativeElement.innerHTML = this.tpl.replace(/\${num}/, num.toString());
        };
        /**
         * @private
         * @return {?}
         */
        VCodeDirective.prototype.destroy = function () {
            if (this._t) {
                clearInterval(this._t);
                this._t = null;
            }
        };
        /**
         * @return {?}
         */
        VCodeDirective.prototype.ngOnDestroy = function () {
            this.destroy();
        };
        return VCodeDirective;
    }());
    VCodeDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[weui-vcode]',
                    exportAs: 'weuiVcode',
                    host: {
                        '(click)': '_onClick()',
                        '[disabled]': '_disabled',
                    },
                },] }
    ];
    /** @nocollapse */
    VCodeDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    VCodeDirective.propDecorators = {
        onSend: [{ type: core.Input, args: ['weui-vcode',] }],
        seconds: [{ type: core.Input, args: ['weui-seconds',] }],
        tpl: [{ type: core.Input, args: ['weui-tpl',] }],
        error: [{ type: core.Input, args: ['weui-error',] }]
    };
    __decorate([
        core$1.InputNumber(),
        __metadata("design:type", Number)
    ], VCodeDirective.prototype, "seconds", void 0);
    if (false) {
        /**
         * 发送事件
         * @type {?}
         */
        VCodeDirective.prototype.onSend;
        /**
         * 时长（单位：秒），默认：`60`
         * @type {?}
         */
        VCodeDirective.prototype.seconds;
        /**
         * 倒计时模板，使用 `${num}` 表示当前秒数
         * @type {?}
         */
        VCodeDirective.prototype.tpl;
        /**
         * 重新发送提醒文本
         * @type {?}
         */
        VCodeDirective.prototype.error;
        /** @type {?} */
        VCodeDirective.prototype._disabled;
        /**
         * @type {?}
         * @private
         */
        VCodeDirective.prototype._cur;
        /**
         * @type {?}
         * @private
         */
        VCodeDirective.prototype._t;
        /**
         * @type {?}
         * @private
         */
        VCodeDirective.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: textarea.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 文本域字数统计
     */
    var TextareaDirective = /** @class */ (function () {
        /**
         * @param {?} el
         */
        function TextareaDirective(el) {
            this.el = el;
            this.fillStr = '';
            this._cn = 1;
            /**
             * 最大长度，0表示不受限
             */
            this.maxlength = 0;
        }
        Object.defineProperty(TextareaDirective.prototype, "cn", {
            /**
             * 中文部分应该算多少个字符，使用 `/[^\x00-\xff]/g` 正则表达式统计中文部分（默认：1个字符）
             * @param {?} value
             * @return {?}
             */
            set: function (value) {
                this._cn = value;
                this.fillStr = new Array(+value).fill('*').join('');
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        TextareaDirective.prototype.ngOnInit = function () {
            this.init();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        TextareaDirective.prototype.ngOnChanges = function (changes) {
            if (changes.maxlength) {
                this.init()._onChange(this._value);
            }
        };
        /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        TextareaDirective.prototype.init = function () {
            /** @type {?} */
            var clsName = "weui-textarea-counter";
            /** @type {?} */
            var pel = ( /** @type {?} */(this)).el.nativeElement.parentElement;
            ( /** @type {?} */(this)).maxlength = +( /** @type {?} */(this)).maxlength;
            if (( /** @type {?} */(this)).maxlength <= 0) {
                core$1.remove(pel, '.' + clsName);
                ( /** @type {?} */(this))._count = null;
            }
            else {
                ( /** @type {?} */(this))._count = core$1.add(pel, '.' + clsName, 'div', clsName);
            }
            return ( /** @type {?} */(this));
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TextareaDirective.prototype._onChange = function (value) {
            if (!this._count) {
                return;
            }
            value = value || '';
            if (this._cn > 1) {
                value = value.replace(/[^\x00-\xff]/g, this.fillStr);
            }
            this._value = value;
            this._count.innerHTML = value.length + " / " + this.maxlength;
        };
        return TextareaDirective;
    }());
    TextareaDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[weui-textarea]',
                    exportAs: 'weuiTextarea',
                    host: {
                        '(input)': '_onChange($event.target?.value)',
                    },
                },] }
    ];
    /** @nocollapse */
    TextareaDirective.ctorParameters = function () { return [
        { type: core.ElementRef }
    ]; };
    TextareaDirective.propDecorators = {
        maxlength: [{ type: core.Input }],
        cn: [{ type: core.Input, args: ['weui-cn',] }]
    };
    __decorate([
        core$1.InputNumber(),
        __metadata("design:type", Number)
    ], TextareaDirective.prototype, "maxlength", void 0);
    if (false) {
        /**
         * @type {?}
         * @private
         */
        TextareaDirective.prototype.fillStr;
        /**
         * @type {?}
         * @private
         */
        TextareaDirective.prototype._cn;
        /**
         * 最大长度，0表示不受限
         * @type {?}
         */
        TextareaDirective.prototype.maxlength;
        /**
         * @type {?}
         * @private
         */
        TextareaDirective.prototype._value;
        /**
         * @type {?}
         * @private
         */
        TextareaDirective.prototype._count;
        /**
         * @type {?}
         * @private
         */
        TextareaDirective.prototype.el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: form.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [InputDirective, VCodeDirective, TextareaDirective, ChecklistDirective];
    var FormModule = /** @class */ (function () {
        function FormModule() {
        }
        return FormModule;
    }());
    FormModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-form.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ChecklistDirective = ChecklistDirective;
    exports.FormModule = FormModule;
    exports.InputDirective = InputDirective;
    exports.TextareaDirective = TextareaDirective;
    exports.VCodeDirective = VCodeDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-form.umd.js.map
