/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('ngx-weui/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/picker', ['exports', '@angular/core', '@angular/common', 'ngx-weui/core', '@angular/forms'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].picker = {}), global.ng.core, global.ng.common, global['ngx-weui'].core, global.ng.forms));
}(this, (function (exports, i0, i1, core, forms) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerConfig = /** @class */ (function () {
        function PickerConfig() {
            /**
             * 取消按钮文本，默认：`取消`
             */
            this.cancel = '取消';
            /**
             * 确定按钮文本，默认：`确定`
             */
            this.confirm = '确定';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        return PickerConfig;
    }());
    PickerConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ PickerConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function PickerConfig_Factory() { return new PickerConfig(); }, token: PickerConfig, providedIn: "root" });
    if (false) {
        /**
         * 取消按钮文本，默认：`取消`
         * @type {?}
         */
        PickerConfig.prototype.cancel;
        /**
         * 确定按钮文本，默认：`确定`
         * @type {?}
         */
        PickerConfig.prototype.confirm;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        PickerConfig.prototype.backdrop;
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker-group.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerGroupComponent = /** @class */ (function () {
        /**
         * @param {?} doc
         */
        function PickerGroupComponent(doc) {
            this.doc = doc;
            /**
             * 当前默认位置
             */
            this.defaultIndex = -1;
            /**
             * 变更回调
             */
            this.change = new i0.EventEmitter();
            this.defaults = {
                offset: 2,
                // 列表初始化时的偏移量（列表初始化时，选项是聚焦在中间的，通过offset强制往上挪3项，以达到初始选项是为顶部的那项）
                rowHeight: 48,
                // 列表每一行的高度
                bodyHeight: 5 * 48,
                // picker的高度，用于辅助点击滚动的计算
                inertiaTime: 150,
                // 惯性滑动的保持时间，此值直接影响“灵敏度” (单位：ms)
                slideDuration: 300,
            };
            // 手滑动的速度 (用途：速度乘以惯性滑动的时间, 例如 300ms, 计算出应该滑动的距离)
            this._animating = false;
            this._distance = 0;
        }
        /**
         * @private
         * @return {?}
         */
        PickerGroupComponent.prototype._getWin = function () {
            return this.doc.defaultView || window;
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PickerGroupComponent.prototype.ngOnChanges = function (changes) {
            if (changes.defaultIndex) {
                if (this.defaultIndex < 0 || (this.items && this.defaultIndex >= this.items.length)) {
                    this.defaultIndex = 0;
                }
                this._distance = (this.defaults.offset - this.defaultIndex) * this.defaults.rowHeight;
            }
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchStart = function (e) {
            if (this.items.length <= 1) {
                return;
            }
            this.startY = e.changedTouches[0].pageY;
            this.startTime = +new Date();
        };
        /**
         * @param {?} e
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchMove = function (e) {
            if (this.items.length <= 1) {
                return;
            }
            /** @type {?} */
            var endTime = +new Date();
            this.endY = e.changedTouches[0].pageY;
            // 计算滑动的速度: 距离 / 时间
            /** @type {?} */
            var _distance = this.endY - this.startY;
            this.speed = _distance / (endTime - this.startTime);
            // 重新设置开始时间、开始位置
            this.startTime = endTime;
            this.startY = this.endY;
            this._animating = false; // ms
            this._distance += _distance; // 内容移动的距离
            e.preventDefault();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        PickerGroupComponent.prototype.onTouchEnd = function (event) {
            if (!this.startY) {
                return;
            }
            this.endY = event.changedTouches[0].pageY;
            /**
             * 思路:
             * 根据最后一次touchmove事件的速度(speed)，判断是否执行惯性滑动；
             * 如果speed大于1、小于5，则根据速度乘以惯性滑动的时间(如150ms)，计算出应该滑动的距离；
             * 如果speed大于5，则按照屏幕的高度(减去列表高度的一半)，作为该滑动的距离。
             * @type {?}
             */
            var _speed = Math.abs(this.speed);
            if (_speed >= 5) {
                /** @type {?} */
                var windowY = this._getWin().innerHeight - this.defaults.bodyHeight / 2;
                this.stop(windowY - this.endY);
            }
            else if (_speed >= 1) {
                /** @type {?} */
                var diff = this.speed * this.defaults.inertiaTime;
                this.stop(diff);
            }
            else {
                this.stop(0);
            }
            this.startY = 0;
        };
        /**
         * @private
         * @param {?} diff
         * @return {?}
         */
        PickerGroupComponent.prototype.stop = function (diff) {
            /** @type {?} */
            var dist = this._distance + diff;
            /** @type {?} */
            var defaults = this.defaults;
            // 移动到最接近的那一行
            dist = Math.round(dist / defaults.rowHeight) * defaults.rowHeight;
            /** @type {?} */
            var max = this._getMax(defaults.offset, defaults.rowHeight);
            /** @type {?} */
            var min = this._getMin(defaults.offset, defaults.rowHeight, this.items.length);
            // 不要超过最大值或者最小值
            dist = Math.max(Math.min(dist, max), min);
            // 如果是 disabled 的就跳过
            /** @type {?} */
            var index = defaults.offset - dist / defaults.rowHeight;
            while (!!this.items[index] && this.items[index].disabled) {
                diff > 0 ? ++index : --index;
            }
            dist = (defaults.offset - index) * defaults.rowHeight;
            this._animating = true;
            this._distance = dist; // px
            // 触发选择事件
            this.onChange(this.items[index], index);
        };
        /**
         * @private
         * @param {?} item
         * @param {?=} index
         * @return {?}
         */
        PickerGroupComponent.prototype.onChange = function (item, index) {
            if (index === void 0) { index = 0; }
            this.change.emit({ item: item, index: index, groupIndex: this.groupIndex });
        };
        /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @return {?}
         */
        PickerGroupComponent.prototype._getMax = function (offset, rowHeight) {
            return offset * rowHeight;
        };
        /**
         * @private
         * @param {?} offset
         * @param {?} rowHeight
         * @param {?} length
         * @return {?}
         */
        PickerGroupComponent.prototype._getMin = function (offset, rowHeight, length) {
            return -(rowHeight * (length - offset - 1));
        };
        return PickerGroupComponent;
    }());
    PickerGroupComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-picker-group',
                    exportAs: 'weuiPickerGroup',
                    template: "<ng-content></ng-content>\n<div class=\"weui-picker__mask\"></div>\n<div class=\"weui-picker__indicator\"></div>\n<div\n  class=\"weui-picker__content\"\n  [ngStyle]=\"{\n    transform: 'translate3d(0,' + _distance + 'px, 0px)',\n    transition: _animating ? 'all 0.3s ease 0s' : 'none'\n  }\"\n>\n  <div class=\"weui-picker__item\" *ngFor=\"let item of items\" [ngClass]=\"{ 'weui-picker__item_disabled': item.disabled }\">\n    {{ item.label || item.value }}\n  </div>\n</div>\n",
                    host: {
                        '[class.weui-picker__group]': 'true',
                        '(touchstart)': 'onTouchStart($event)',
                        '(touchmove)': 'onTouchMove($event)',
                        '(touchend)': 'onTouchEnd($event)',
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    PickerGroupComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    PickerGroupComponent.propDecorators = {
        items: [{ type: i0.Input }],
        defaultIndex: [{ type: i0.Input }],
        groupIndex: [{ type: i0.Input }],
        change: [{ type: i0.Output }]
    };
    __decorate([
        core.InputNumber(),
        __metadata("design:type", Number)
    ], PickerGroupComponent.prototype, "defaultIndex", void 0);
    __decorate([
        core.InputNumber(),
        __metadata("design:type", Number)
    ], PickerGroupComponent.prototype, "groupIndex", void 0);
    if (false) {
        /**
         * 数据列表
         * @type {?}
         */
        PickerGroupComponent.prototype.items;
        /**
         * 当前默认位置
         * @type {?}
         */
        PickerGroupComponent.prototype.defaultIndex;
        /**
         * 多列中的位置
         * @type {?}
         */
        PickerGroupComponent.prototype.groupIndex;
        /**
         * 变更回调
         * @type {?}
         */
        PickerGroupComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.defaults;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.startTime;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.startY;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.endY;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.speed;
        /** @type {?} */
        PickerGroupComponent.prototype._animating;
        /** @type {?} */
        PickerGroupComponent.prototype._distance;
        /**
         * @type {?}
         * @private
         */
        PickerGroupComponent.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker-base.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PickerBaseComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         * @param {?} injector
         * @param {?} cdr
         */
        function PickerBaseComponent(DEF, injector, cdr) {
            this.DEF = DEF;
            this.injector = injector;
            this.cdr = cdr;
            /**
             * 列变更时回调
             */
            this.groupChange = new i0.EventEmitter();
            /**
             * 取消后回调
             */
            this.cancel = new i0.EventEmitter();
            /**
             * 显示时回调
             */
            this.show = new i0.EventEmitter();
            /**
             * 隐藏后回调
             */
            this.hide = new i0.EventEmitter();
        }
        /**
         * @param {?} _value
         * @return {?}
         */
        PickerBaseComponent.prototype.writeValue = function (_value) { };
        return PickerBaseComponent;
    }());
    PickerBaseComponent.decorators = [
        { type: i0.Component, args: [{ template: "" }] }
    ];
    /** @nocollapse */
    PickerBaseComponent.ctorParameters = function () { return [
        { type: PickerConfig },
        { type: i0.Injector },
        { type: i0.ChangeDetectorRef }
    ]; };
    PickerBaseComponent.propDecorators = {
        options: [{ type: i0.Input }],
        placeholder: [{ type: i0.Input }],
        title: [{ type: i0.Input }],
        disabled: [{ type: i0.Input }],
        groupChange: [{ type: i0.Output }],
        cancel: [{ type: i0.Output }],
        show: [{ type: i0.Output }],
        hide: [{ type: i0.Output }]
    };
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], PickerBaseComponent.prototype, "disabled", void 0);
    if (false) {
        /**
         * 配置项
         * @type {?}
         */
        PickerBaseComponent.prototype.options;
        /**
         * 当options.type=='form'时，占位符文本
         * @type {?}
         */
        PickerBaseComponent.prototype.placeholder;
        /** @type {?} */
        PickerBaseComponent.prototype.title;
        /** @type {?} */
        PickerBaseComponent.prototype.disabled;
        /**
         * 列变更时回调
         * @type {?}
         */
        PickerBaseComponent.prototype.groupChange;
        /**
         * 取消后回调
         * @type {?}
         */
        PickerBaseComponent.prototype.cancel;
        /**
         * 显示时回调
         * @type {?}
         */
        PickerBaseComponent.prototype.show;
        /**
         * 隐藏后回调
         * @type {?}
         */
        PickerBaseComponent.prototype.hide;
        /**
         * @type {?}
         * @protected
         */
        PickerBaseComponent.prototype.DEF;
        /**
         * @type {?}
         * @protected
         */
        PickerBaseComponent.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        PickerBaseComponent.prototype.cdr;
    }

    var PickerComponent = /** @class */ (function (_super) {
        __extends(PickerComponent, _super);
        function PickerComponent() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this._showP = false;
            _this._shown = false;
            _this._text = '';
            /**
             * 确认后回调当前选择数据（包括已选面板所有数据）
             */
            _this.change = new i0.EventEmitter();
            _this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            _this.onTouched = ( /**
             * @return {?}
             */function () { });
            return _this;
        }
        Object.defineProperty(PickerComponent.prototype, "defaultSelect", {
            /**
             * 当前默认位置，数组的长度必须等同于 groups 长度
             * @param {?} d
             * @return {?}
             */
            set: function (d) {
                if (d) {
                    this._selected = d;
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PickerComponent.prototype, "groups", {
            /**
             * 多列数据，以数组的长度来决定几列数据
             * 支持string[]单列数组，单纯只是为了方便
             * @param {?} d
             * @return {?}
             */
            set: function (d) {
                if (!d) {
                    throw new Error('无效数据源');
                }
                if (d.length > 0) {
                    if (typeof d[0] === 'string') {
                        d = [
                            (( /** @type {?} */(d))).map(( /**
                             * @param {?} v
                             * @return {?}
                             */function (v) {
                                return { label: v, value: v };
                            })),
                        ];
                    }
                }
                this._groups = ( /** @type {?} */(d));
                this._selected = this._selected ? this._selected : Array(d.length).fill(0);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        PickerComponent.prototype.ngOnInit = function () {
            this.parseOptions();
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} fh
         * @return {THIS}
         */
        PickerComponent.prototype._onHide = function (fh) {
            var _this = this;
            if (!fh && !( /** @type {?} */(this)).options.backdrop) {
                return ( /** @type {?} */(this));
            }
            ( /** @type {?} */(this))._shown = false;
            setTimeout(( /**
             * @return {?}
             */function () {
                ( /** @type {?} */(_this))._showP = false;
                ( /** @type {?} */(_this)).hide.emit();
            }), 300);
            return ( /** @type {?} */(this));
        };
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        PickerComponent.prototype._onShow = function () {
            if (( /** @type {?} */(this)).disabled) {
                return ( /** @type {?} */(this));
            }
            ( /** @type {?} */(this))._showP = true;
            ( /** @type {?} */(this))._shown = true;
            ( /** @type {?} */(this)).show.emit();
            return ( /** @type {?} */(this));
        };
        /**
         * @private
         * @return {?}
         */
        PickerComponent.prototype.parseOptions = function () {
            this.options = ( /** @type {?} */(Object.assign(Object.assign({ type: 'form', cancel: '取消', confirm: '确定', backdrop: true, gruopCount: null, separator: ' ' }, this.DEF), this.options)));
        };
        /**
         * @private
         * @return {?}
         */
        PickerComponent.prototype.getSelecteItem = function () {
            var _this = this;
            /** @type {?} */
            var res = [];
            this._groups.forEach(( /**
             * @param {?} items
             * @param {?} idx
             * @return {?}
             */function (items, idx) {
                /** @type {?} */
                var item = items[_this._selected[idx]];
                if (item) {
                    res.push(item);
                }
            }));
            return res;
        };
        /**
         * @template THIS
         * @this {THIS}
         * @param {?=} res
         * @return {THIS}
         */
        PickerComponent.prototype._setText = function (res) {
            if (res === void 0) { res = null; }
            if (res == null) {
                res = ( /** @type {?} */(this)).getSelecteItem();
            }
            if (res.length > 0) {
                ( /** @type {?} */(this))._text = res.map(( /**
                 * @param {?} i
                 * @return {?}
                 */function (i) { return i.label || i.value; })).join(( /** @type {?} */(this)).options.separator);
            }
            return ( /** @type {?} */(this));
        };
        // 根据_value解析成相应值位置
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        PickerComponent.prototype._setDefault = function () {
            var _this = this;
            ( /** @type {?} */(this))._selected = [];
            ( /** @type {?} */(this))._groups.forEach(( /**
             * @param {?} items
             * @return {?}
             */function (items) {
                /** @type {?} */
                var idx = items.findIndex(( /**
                 * @param {?} i
                 * @return {?}
                 */function (i) { return i.value === ( /** @type {?} */(_this))._value; }));
                if (idx <= -1) {
                    idx = 0;
                }
                ( /** @type {?} */(_this))._selected.push(idx);
            }));
            return ( /** @type {?} */(this));
        };
        /**
         * @param {?} data
         * @param {?} groupIndex
         * @return {?}
         */
        PickerComponent.prototype._onGroupChange = function (data, groupIndex) {
            this._selected[groupIndex] = data.index;
            this.groupChange.emit({ item: data.item, index: data.index, groupIndex: groupIndex });
        };
        /**
         * @return {?}
         */
        PickerComponent.prototype._onCancel = function () {
            this.cancel.emit();
            this._onHide(true);
            return false;
        };
        /**
         * @return {?}
         */
        PickerComponent.prototype._onConfirm = function () {
            /** @type {?} */
            var res = this.getSelecteItem();
            this._setText(res);
            /** @type {?} */
            var lastItem = res[res.length - 1] || {};
            /** @type {?} */
            var val = lastItem.value || lastItem.label;
            this.onChange(val);
            this.onTouched();
            this.change.emit({ value: val, items: res });
            this._onHide(true);
            return false;
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PickerComponent.prototype.ngOnChanges = function (changes) {
            if (changes.options) {
                this.parseOptions();
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        PickerComponent.prototype.writeValue = function (value) {
            if (!value) {
                this._text = '';
            }
            if (value && value !== this._value) {
                this._value = value;
                // todo：当ngModel传递一个未列表中的值的情况 & 多列时数据对应问题
                this._setDefault()._setText();
            }
            this.cdr.detectChanges();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        PickerComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        PickerComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} ev
         * @return {?}
         */
        PickerComponent.prototype._onFocus = function (ev) {
            (( /** @type {?} */(( /** @type {?} */(ev.target))))).blur();
        };
        return PickerComponent;
    }(PickerBaseComponent));
    PickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-picker',
                    exportAs: 'weuiPicker',
                    template: "<input\n  type=\"text\"\n  class=\"weui-input\"\n  value=\"{{ _text }}\"\n  placeholder=\"{{ placeholder }}\"\n  readonly=\"readonly\"\n  (focus)=\"_onFocus($event)\"\n  (click)=\"_onShow()\"\n  [disabled]=\"disabled\"\n  *ngIf=\"options.type === 'form'\"\n/>\n<div [ngClass]=\"options.className\" [hidden]=\"!_showP\">\n  <div class=\"weui-mask\" (click)=\"_onHide(false)\" [ngClass]=\"{ 'weui-animate-fade-in': _shown, 'weui-animate-fade-out': !_shown }\"></div>\n  <div class=\"weui-half-screen-dialog weui-picker\" [ngClass]=\"{ 'weui-animate-slide-up': _shown, 'weui-animate-slide-down': !_shown }\">\n    <div class=\"weui-half-screen-dialog__hd\">\n      <div class=\"weui-half-screen-dialog__hd__side\">\n        <button (click)=\"_onCancel()\" class=\"weui-icon-btn weui-icon-btn_close weui-picker__btn\">{{ options.cancel }}</button>\n      </div>\n      <div *ngIf=\"title\" class=\"weui-half-screen-dialog__hd__main\">\n        <strong class=\"weui-half-screen-dialog__title\">{{ title }}</strong>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__bd\">\n      <div class=\"weui-picker__bd\">\n        <weui-picker-group\n          tappable\n          *ngFor=\"let items of _groups; let i = index\"\n          [attr.data-index]=\"i\"\n          [items]=\"items\"\n          [defaultIndex]=\"_selected[i]\"\n          [groupIndex]=\"i\"\n          (change)=\"_onGroupChange($event, i)\"\n        ></weui-picker-group>\n      </div>\n    </div>\n    <div class=\"weui-half-screen-dialog__ft\">\n      <a class=\"weui-btn weui-btn_primary weui-picker__btn\" (click)=\"_onConfirm()\">{{ options.confirm }}</a>\n    </div>\n  </div>\n</div>\n",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(( /**
                             * @return {?}
                             */function () { return PickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    PickerComponent.propDecorators = {
        change: [{ type: i0.Output }],
        defaultSelect: [{ type: i0.Input }],
        groups: [{ type: i0.Input }]
    };
    if (false) {
        /** @type {?} */
        PickerComponent.prototype._showP;
        /** @type {?} */
        PickerComponent.prototype._shown;
        /** @type {?} */
        PickerComponent.prototype._value;
        /** @type {?} */
        PickerComponent.prototype._selected;
        /** @type {?} */
        PickerComponent.prototype._groups;
        /** @type {?} */
        PickerComponent.prototype._text;
        /**
         * 确认后回调当前选择数据（包括已选面板所有数据）
         * @type {?}
         */
        PickerComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        PickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        PickerComponent.prototype.onTouched;
    }

    /** @type {?} */
    var DATA_MAP = {
        label: 'name',
        value: 'code',
        items: 'sub',
    };
    /**
     * 城市选择器（并不包含城市数据，可以参考示例中的数据格式）
     */
    var CityPickerComponent = /** @class */ (function (_super) {
        __extends(CityPickerComponent, _super);
        function CityPickerComponent() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.change = new i0.EventEmitter();
            _this._tmpData = null;
            _this._dataMap = DATA_MAP;
            _this._groups = [];
            _this._selected = [];
            _this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            _this.onTouched = ( /**
             * @return {?}
             */function () { });
            return _this;
        }
        Object.defineProperty(CityPickerComponent.prototype, "dataMap", {
            /**
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this._dataMap = Object.assign(Object.assign({}, DATA_MAP), val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(CityPickerComponent.prototype, "data", {
            /**
             * @param {?} d
             * @return {?}
             */
            set: function (d) {
                this._tmpData = d;
                this.parseData(this._tmpData, this._dataMap.items, this._selected);
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} selected
         * @param {?=} group
         * @param {?=} newSelected
         * @return {?}
         */
        CityPickerComponent.prototype.parseData = function (data, subKey, selected, group, newSelected) {
            if (selected === void 0) { selected = []; }
            if (group === void 0) { group = []; }
            if (newSelected === void 0) { newSelected = []; }
            /** @type {?} */
            var _selected = 0;
            if (Array.isArray(selected) && selected.length > 0) {
                /** @type {?} */
                var _selectedClone = selected.slice(0);
                _selected = ( /** @type {?} */(_selectedClone.shift()));
                selected = _selectedClone;
            }
            if (typeof data[_selected] === 'undefined') {
                _selected = 0;
            }
            newSelected.push(_selected);
            /** @type {?} */
            var item = data[_selected];
            /** @type {?} */
            var _group = ( /** @type {?} */(JSON.parse(JSON.stringify(data))));
            /** @type {?} */
            var map = this._dataMap;
            _group.forEach(( /**
             * @param {?} g
             * @return {?}
             */function (g) {
                delete g[subKey];
                g.label = g[map.label];
                g.value = g[map.value];
            }));
            group.push(_group);
            if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
                return this.parseData(item[subKey], subKey, selected, group, newSelected);
            }
            else {
                this._groups = group;
                this._selected = newSelected;
                return { groups: group, newSelected: newSelected };
            }
        };
        /**
         * 将值转换成位置
         * @private
         * @param {?} data
         * @param {?} subKey
         * @param {?=} dept
         * @param {?=} newSelected
         * @return {?}
         */
        CityPickerComponent.prototype.valueToSelect = function (data, subKey, dept, newSelected) {
            var _this = this;
            if (dept === void 0) { dept = 1; }
            if (newSelected === void 0) { newSelected = []; }
            /** @type {?} */
            var code = (this._value.substr(0, dept * 2) + '0000').substr(0, 6);
            /** @type {?} */
            var _selected = data.findIndex(( /**
             * @param {?} w
             * @return {?}
             */function (w) { return w[_this._dataMap.value] === code; }));
            if (_selected <= -1) {
                _selected = 0;
            }
            newSelected.push(_selected);
            /** @type {?} */
            var item = data[_selected];
            if (typeof item[subKey] !== 'undefined' && Array.isArray(item[subKey])) {
                return this.valueToSelect(item[subKey], subKey, ++dept, newSelected);
            }
            else {
                this._selected = newSelected;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.pickerComp._setText();
                }), 100);
                return newSelected;
            }
        };
        /**
         * @param {?} data
         * @return {?}
         */
        CityPickerComponent.prototype._onChange = function (data) {
            this.onChange(data.value);
            this.onTouched();
            this.change.emit(data);
        };
        /**
         * @param {?} res
         * @return {?}
         */
        CityPickerComponent.prototype._onGroupChange = function (res) {
            this._selected[res.groupIndex] = res.index;
            if (res.groupIndex !== 2) {
                this.parseData(( /** @type {?} */(this._tmpData)), this._dataMap.items, this._selected);
            }
            this.groupChange.emit(res);
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onCityCancelChange = function () {
            this.cancel.emit();
        };
        /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        CityPickerComponent.prototype._triggerShow = function () {
            this.pickerComp._onShow();
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onShow = function () {
            this.show.emit();
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype._onHide = function () {
            this.hide.emit();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        CityPickerComponent.prototype.writeValue = function (value) {
            if (!value) {
                this.pickerComp._text = '';
                return;
            }
            this._value = value;
            if (this._value && this._value.length === 6) {
                /** @type {?} */
                var items = this._dataMap.items;
                this.valueToSelect(( /** @type {?} */(this._tmpData)), items, 1);
                this.parseData(( /** @type {?} */(this._tmpData)), items, this._selected);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        CityPickerComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        CityPickerComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        CityPickerComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @return {?}
         */
        CityPickerComponent.prototype.ngOnDestroy = function () {
            this._tmpData = null;
            this._groups = null;
        };
        return CityPickerComponent;
    }(PickerBaseComponent));
    CityPickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-city-picker',
                    exportAs: 'weuiCityPicker',
                    template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups!\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onChange($event)\"\n      (groupChange)=\"_onGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(( /**
                             * @return {?}
                             */function () { return CityPickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    CityPickerComponent.propDecorators = {
        dataMap: [{ type: i0.Input }],
        data: [{ type: i0.Input }],
        pickerComp: [{ type: i0.ViewChild, args: [PickerComponent, { static: true },] }],
        change: [{ type: i0.Output }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype.pickerComp;
        /** @type {?} */
        CityPickerComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype._tmpData;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype._dataMap;
        /** @type {?} */
        CityPickerComponent.prototype._value;
        /** @type {?} */
        CityPickerComponent.prototype._groups;
        /** @type {?} */
        CityPickerComponent.prototype._selected;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        CityPickerComponent.prototype.onTouched;
    }

    /** @type {?} */
    var FORMAT = {
        format: null,
        yu: '年',
        Mu: '月',
        du: '日',
        hu: '时',
        mu: '分',
    };
    /**
     * 日期时间选择器
     */
    var DatePickerComponent = /** @class */ (function (_super) {
        __extends(DatePickerComponent, _super);
        function DatePickerComponent() {
            var _this = _super.apply(this, __spread(arguments)) || this;
            _this.initFlag = false;
            _this._format = Object.assign({}, FORMAT);
            _this._groups = [];
            _this._selected = [];
            /**
             * 类型
             * + `date-ym` 年月
             * + `date` 日期
             * + `datetime` 日期&时间（不包括秒）
             * + `time` 时间（不包括秒）
             */
            _this.type = 'date';
            _this.change = new i0.EventEmitter();
            _this.onChange = ( /**
             * @param {?} _
             * @return {?}
             */function (_) { });
            _this.onTouched = ( /**
             * @return {?}
             */function () { });
            return _this;
        }
        Object.defineProperty(DatePickerComponent.prototype, "format", {
            /**
             * 日期格式化代码，实际是采用 DatePipe，所有代码内容和它一样
             * @param {?} v
             * @return {?}
             */
            set: function (v) {
                if (typeof v === 'string') {
                    this._format = Object.assign(Object.assign({}, FORMAT), { format: v });
                }
                else {
                    this._format = Object.assign(Object.assign({}, FORMAT), v);
                }
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(DatePickerComponent.prototype, "datePipe", {
            /**
             * @private
             * @return {?}
             */
            get: function () {
                return this.injector.get(i1.DatePipe);
            },
            enumerable: false,
            configurable: true
        });
        // todo: 太粗暴，需要优化代码
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genGroups = function () {
            if (!this._value) {
                this._value = new Date();
            }
            this._groups = [];
            this._selected = [];
            if (~this.type.indexOf('date')) {
                this.genDateGroups();
            }
            if (~this.type.indexOf('time')) {
                this.genDateTimeGroups();
            }
        };
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genDateGroups = function () {
            var _this = this;
            /** @type {?} */
            var year = this._value.getFullYear();
            /** @type {?} */
            var month = this._value.getMonth() + 1;
            /** @type {?} */
            var day = this._value.getDate();
            // year
            /** @type {?} */
            var _selected = 0;
            /** @type {?} */
            var startYear = year - 10;
            /** @type {?} */
            var endYear = year + 10;
            if (this.min) {
                startYear = this.min.getFullYear();
            }
            if (this.max) {
                endYear = this.max.getFullYear();
            }
            this._groups.push(Array(endYear - startYear + 1)
                .fill(0)
                .map(( /**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */function (_v, idx) {
                /** @type {?} */
                var val = startYear + idx;
                if (val === year) {
                    _selected = idx;
                }
                return { label: val + ( /** @type {?} */(_this._format.yu)), value: val };
            })));
            this._selected.push(_selected);
            // month
            /** @type {?} */
            var cy = this._groups[0][_selected].value;
            /** @type {?} */
            var startMonth = 1;
            /** @type {?} */
            var endMonth = 12;
            if (cy === startYear) {
                startMonth = this.min.getMonth() + 1;
            }
            if (cy === endYear) {
                endMonth = this.max.getMonth() + 1;
            }
            _selected = 0;
            this._groups.push(Array(endMonth - startMonth + 1)
                .fill(0)
                .map(( /**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */function (_v, idx) {
                /** @type {?} */
                var val = startMonth + idx;
                if (val === month) {
                    _selected = idx;
                }
                return { label: val + ( /** @type {?} */(_this._format.Mu)), value: val };
            })));
            this._selected.push(_selected);
            // day
            if (this.type !== 'date-ym') {
                /** @type {?} */
                var cm = this._groups[1][_selected].value;
                /** @type {?} */
                var startDay_1 = 1;
                /** @type {?} */
                var endDay = new Date(year, month, 0).getDate();
                if (cy === startYear && cm === startMonth) {
                    startDay_1 = this.min.getDate();
                }
                if (cy === endYear && cm === endMonth) {
                    endDay = this.max.getDate();
                }
                _selected = 0;
                this._groups.push(Array(endDay - startDay_1 + 1)
                    .fill(0)
                    .map(( /**
             * @param {?} _v
             * @param {?} idx
             * @return {?}
             */function (_v, idx) {
                    /** @type {?} */
                    var val = startDay_1 + idx;
                    if (val === day) {
                        _selected = idx;
                    }
                    return { label: val + ( /** @type {?} */(_this._format.du)), value: val };
                })));
                this._selected.push(_selected);
            }
        };
        /**
         * @private
         * @return {?}
         */
        DatePickerComponent.prototype.genDateTimeGroups = function () {
            var _this = this;
            /** @type {?} */
            var hours = this._value.getHours();
            /** @type {?} */
            var minutes = this._value.getMinutes();
            // hours
            /** @type {?} */
            var _selected = 0;
            this._groups.push(Array(24)
                .fill(0)
                .map(( /**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */function (_v, idx) {
                /** @type {?} */
                var val = idx;
                if (val === hours) {
                    _selected = idx;
                }
                return { label: val + ( /** @type {?} */(_this._format.hu)), value: val };
            })));
            this._selected.push(_selected);
            // minutes
            _selected = 0;
            this._groups.push(Array(60)
                .fill(0)
                .map(( /**
         * @param {?} _v
         * @param {?} idx
         * @return {?}
         */function (_v, idx) {
                /** @type {?} */
                var val = idx;
                if (val === minutes) {
                    _selected = idx;
                }
                return { label: val + ( /** @type {?} */(_this._format.mu)), value: val };
            })));
            this._selected.push(_selected);
        };
        // 根据selected
        /**
         * @private
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        DatePickerComponent.prototype.genValueBySelected = function () {
            if (( /** @type {?} */(this)).type === 'time') {
                /** @type {?} */
                var now = new Date();
                ( /** @type {?} */(this))._value = new Date(now.getFullYear(), now.getMonth() + 1, now.getDate(), ( /** @type {?} */(this))._groups[0][( /** @type {?} */(this))._selected[0]].value, ( /** @type {?} */(this))._groups[1][( /** @type {?} */(this))._selected[1]].value, 0);
                return ( /** @type {?} */(this));
            }
            /** @type {?} */
            var obj = {
                y: ( /** @type {?} */(this))._groups[0][( /** @type {?} */(this))._selected[0]].value,
                M: ( /** @type {?} */(this))._groups[1][( /** @type {?} */(this))._selected[1]].value - 1,
                d: ( /** @type {?} */(this)).type !== 'date-ym' ? ( /** @type {?} */(this))._groups[2][( /** @type {?} */(this))._selected[2]].value : 1,
                h: 0,
                m: 0,
                s: 0,
            };
            if (~( /** @type {?} */(this)).type.indexOf('time')) {
                obj.h = ( /** @type {?} */(this))._groups[3][( /** @type {?} */(this))._selected[3]].value;
                obj.m = ( /** @type {?} */(this))._groups[4][( /** @type {?} */(this))._selected[4]].value;
            }
            ( /** @type {?} */(this))._value = new Date(obj.y, obj.M, obj.d, obj.h, obj.m, obj.s);
            return ( /** @type {?} */(this));
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnDestroy = function () {
            this._groups.length = 0;
        };
        /**
         * @private
         * @param {?} date
         * @return {?}
         */
        DatePickerComponent.prototype.getFormatDate = function (date) {
            /** @type {?} */
            var f = '';
            if (this._format && this._format.format) {
                f = this._format.format;
            }
            else {
                switch (this.type) {
                    case 'date-ym':
                        f = 'yyyy-MM';
                        break;
                    case 'date':
                        f = 'yyyy-MM-dd';
                        break;
                    case 'datetime':
                        f = 'yyyy-MM-dd HH:mm:ss';
                        break;
                    case 'time':
                        f = 'HH:mm';
                        break;
                }
            }
            return ( /** @type {?} */(this.datePipe.transform(date, f)));
        };
        /**
         * @param {?} data
         * @return {?}
         */
        DatePickerComponent.prototype._onChange = function (data) {
            this.genValueBySelected();
            /** @type {?} */
            var retVal = new Date(this._value.getTime());
            this.onChange(retVal);
            this.onTouched();
            data.value = retVal;
            data.formatValue = this.getFormatDate(retVal);
            this._pickerInstance._text = data.formatValue;
            this.change.emit(data);
        };
        /**
         * @param {?} res
         * @return {?}
         */
        DatePickerComponent.prototype._onGroupChange = function (res) {
            this._selected[res.groupIndex] = res.index;
            if (res.groupIndex !== this._groups.length - 1) {
                this.genValueBySelected().genGroups();
            }
            this.groupChange.emit(res);
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onCityCancelChange = function () {
            this.cancel.emit();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnInit = function () {
            this.initFlag = true;
            this.genGroups();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnChanges = function () {
            if (this.initFlag) {
                this.genGroups();
            }
        };
        /**
         * 服务于Service，并无实际意义
         * @return {?}
         */
        DatePickerComponent.prototype._triggerShow = function () {
            this._pickerInstance._onShow();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onShow = function () {
            this.show.emit();
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype._onHide = function () {
            this.hide.emit();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        DatePickerComponent.prototype.writeValue = function (value) {
            if (value) {
                this.genGroups();
            }
            this._value = value;
            this._pickerInstance._text = value instanceof Date ? ( /** @type {?} */(this.getFormatDate(value))) : '';
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        DatePickerComponent.prototype.setDisabledState = function (isDisabled) {
            this.disabled = isDisabled;
        };
        return DatePickerComponent;
    }(PickerBaseComponent));
    DatePickerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-date-picker',
                    exportAs: 'weuiDatePicker',
                    template: "\n    <weui-picker\n      [placeholder]=\"placeholder\"\n      [groups]=\"_groups\"\n      [defaultSelect]=\"_selected\"\n      [disabled]=\"disabled\"\n      [title]=\"title\"\n      [options]=\"options\"\n      (show)=\"_onShow()\"\n      (hide)=\"_onHide()\"\n      (change)=\"_onChange($event)\"\n      (groupChange)=\"_onGroupChange($event)\"\n      (cancel)=\"_onCityCancelChange()\"\n    ></weui-picker>\n  ",
                    providers: [
                        i1.DatePipe,
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: i0.forwardRef(( /**
                             * @return {?}
                             */function () { return DatePickerComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    DatePickerComponent.propDecorators = {
        format: [{ type: i0.Input }],
        _pickerInstance: [{ type: i0.ViewChild, args: [PickerComponent, { static: true },] }],
        min: [{ type: i0.Input }],
        max: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        change: [{ type: i0.Output }]
    };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.initFlag;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype._format;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype._pickerInstance;
        /** @type {?} */
        DatePickerComponent.prototype._value;
        /** @type {?} */
        DatePickerComponent.prototype._groups;
        /** @type {?} */
        DatePickerComponent.prototype._selected;
        /**
         * 最小时间范围
         * - 当前只限定年月日，暂不包括时间范围
         * @type {?}
         */
        DatePickerComponent.prototype.min;
        /**
         * 最大时间范围
         * - 当前只限定年月日，暂不包括时间范围
         * @type {?}
         */
        DatePickerComponent.prototype.max;
        /**
         * 类型
         * + `date-ym` 年月
         * + `date` 日期
         * + `datetime` 日期&时间（不包括秒）
         * + `time` 时间（不包括秒）
         * @type {?}
         */
        DatePickerComponent.prototype.type;
        /** @type {?} */
        DatePickerComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        DatePickerComponent.prototype.onTouched;
    }

    /**
     * 多列选择器Service，可直接通过Class构造选择器
     */
    var PickerService = /** @class */ (function (_super) {
        __extends(PickerService, _super);
        /**
         * @param {?} resolver
         * @param {?} applicationRef
         * @param {?} injector
         * @param {?} doc
         */
        function PickerService(resolver, applicationRef, injector, doc) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            _this.applicationRef = applicationRef;
            _this.injector = injector;
            _this.doc = doc;
            return _this;
        }
        /**
         * @private
         * @param {?} ref
         * @param {?} config
         * @return {?}
         */
        PickerService.prototype.attachBase = function (ref, config) {
            var _this = this;
            /** @type {?} */
            var instance = ref.instance;
            var options = config.options, title = config.title, placeholder = config.placeholder, disabled = config.disabled, value = config.value;
            // 通过Service打开的强制设置为 `default` 以免出现 `input`
            config.options = Object.assign(Object.assign({}, options), { type: 'default' });
            instance.options = config.options;
            instance.title = ( /** @type {?} */(title));
            instance.placeholder = ( /** @type {?} */(placeholder));
            instance.disabled = ( /** @type {?} */(disabled));
            if (value) {
                setTimeout(( /**
                 * @return {?}
                 */function () { return instance.writeValue(value); }), 100);
            }
            instance.hide.subscribe(( /**
             * @return {?}
             */function () { return setTimeout(( /**
             * @return {?}
             */function () { return _this.destroy(ref); }), 100); }));
        };
        /**
         * @param {?} config
         * @return {?}
         */
        PickerService.prototype.create = function (config) {
            var defaultSelect = config.defaultSelect, data = config.data;
            /** @type {?} */
            var componentRef = this.build(PickerComponent);
            /** @type {?} */
            var instance = componentRef.instance;
            if (defaultSelect) {
                instance.defaultSelect = defaultSelect;
            }
            instance.groups = data;
            this.attachBase(componentRef, config);
            instance._onShow();
            return instance.change;
        };
        /**
         * @deprecated Use `create()` instead and going to be removed in 11.0.0
         *
         * 构建一个多列选择器并显示
         * @param {?} data
         * @param {?=} value
         * @param {?=} defaultSelect
         * @param {?=} options
         * @return {?}
         */
        PickerService.prototype.show = function (data, value, defaultSelect, options) {
            return this.create({ data: data, value: value, defaultSelect: defaultSelect, options: options });
        };
        /**
         * 构建一个城市选择器并显示
         * @param {?} config
         * @return {?}
         */
        PickerService.prototype.city = function (config) {
            var dataMap = config.dataMap, data = config.data;
            /** @type {?} */
            var componentRef = this.build(CityPickerComponent);
            /** @type {?} */
            var instance = componentRef.instance;
            if (dataMap) {
                instance.dataMap = dataMap;
            }
            this.attachBase(componentRef, config);
            instance.data = data;
            setTimeout(( /**
             * @return {?}
             */function () {
                instance._triggerShow();
            }), 200);
            return instance.change;
        };
        /**
         * @deprecated Use `city()` instead and going to be removed in 11.0.0
         *
         * 构建一个城市选择器并显示
         * @param {?} data
         * @param {?=} value
         * @param {?=} dataMap
         * @param {?=} options
         * @return {?}
         */
        PickerService.prototype.showCity = function (data, value, dataMap, options) {
            return this.city({ data: data, value: value, dataMap: dataMap, options: options });
        };
        /**
         * 构建一个日期时间选择器并显示
         * @param {?} config
         * @return {?}
         */
        PickerService.prototype.dateTime = function (config) {
            var type = config.type, format = config.format, min = config.min, max = config.max;
            /** @type {?} */
            var componentRef = this.build(DatePickerComponent);
            /** @type {?} */
            var instance = componentRef.instance;
            this.attachBase(componentRef, config);
            if (type) {
                instance.type = type;
            }
            if (format) {
                instance.format = format;
            }
            if (min) {
                instance.min = min;
            }
            if (max) {
                instance.max = max;
            }
            setTimeout(( /**
             * @return {?}
             */function () {
                instance.ngOnChanges();
                instance._triggerShow();
            }), 200);
            return instance.change;
        };
        /**
         * @deprecated Use `dateTime()` instead and going to be removed in 11.0.0
         *
         * 构建一个日期时间选择器并显示
         * @param {?=} type
         * @param {?=} format
         * @param {?=} value
         * @param {?=} min
         * @param {?=} max
         * @param {?=} options
         * @return {?}
         */
        PickerService.prototype.showDateTime = function (type, format, value, min, max, options) {
            return this.dateTime({ type: type, format: format, value: value, min: min, max: max, options: options });
        };
        return PickerService;
    }(core.BaseService));
    PickerService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    PickerService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.ApplicationRef },
        { type: i0.Injector },
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ PickerService.ɵprov = i0.ɵɵdefineInjectable({ factory: function PickerService_Factory() { return new PickerService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.ApplicationRef), i0.ɵɵinject(i0.INJECTOR), i0.ɵɵinject(i1.DOCUMENT)); }, token: PickerService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        PickerService.prototype.resolver;
        /**
         * @type {?}
         * @protected
         */
        PickerService.prototype.applicationRef;
        /**
         * @type {?}
         * @protected
         */
        PickerService.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        PickerService.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: picker.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [PickerComponent, PickerGroupComponent, DatePickerComponent, CityPickerComponent];
    var PickerModule = /** @class */ (function () {
        function PickerModule() {
        }
        return PickerModule;
    }());
    PickerModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [i1.CommonModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                    entryComponents: COMPONENTS,
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-picker.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.CityPickerComponent = CityPickerComponent;
    exports.DatePickerComponent = DatePickerComponent;
    exports.PickerComponent = PickerComponent;
    exports.PickerConfig = PickerConfig;
    exports.PickerGroupComponent = PickerGroupComponent;
    exports.PickerModule = PickerModule;
    exports.PickerService = PickerService;
    exports.ɵa = PickerBaseComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-picker.umd.js.map
