/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common'), require('rxjs')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/sidebar', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common', 'rxjs'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].sidebar = {}), global.ng.core, global['ngx-weui'].core, global.ng.common, global.rxjs));
}(this, (function (exports, i0, core, common, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: sidebar.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SidebarConfig = /** @class */ (function () {
        function SidebarConfig() {
            /**
             * 位置方向，默认：`left`
             */
            this.position = 'left';
            /**
             * 类型，默认：`slide`
             * - over: 不覆盖
             * - slide：侧边移动
             */
            this.mode = 'slide';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
        }
        return SidebarConfig;
    }());
    SidebarConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ SidebarConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function SidebarConfig_Factory() { return new SidebarConfig(); }, token: SidebarConfig, providedIn: "root" });
    if (false) {
        /**
         * 位置方向，默认：`left`
         * @type {?}
         */
        SidebarConfig.prototype.position;
        /**
         * 类型，默认：`slide`
         * - over: 不覆盖
         * - slide：侧边移动
         * @type {?}
         */
        SidebarConfig.prototype.mode;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        SidebarConfig.prototype.backdrop;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: sidebar.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SidebarService = /** @class */ (function () {
        function SidebarService() {
            this._openObserver = new rxjs.Subject();
            this._closeObserver = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        SidebarService.prototype.open = function () {
            this._openObserver.next();
        };
        /**
         * @return {?}
         */
        SidebarService.prototype.close = function () {
            this._closeObserver.next();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SidebarService.prototype.onOpen = function (fn) {
            return this._openObserver.subscribe(fn);
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SidebarService.prototype.onClose = function (fn) {
            return this._closeObserver.subscribe(fn);
        };
        return SidebarService;
    }());
    SidebarService.decorators = [
        { type: i0.Injectable }
    ];
    if (false) {
        /**
         * @type {?}
         * @private
         */
        SidebarService.prototype._openObserver;
        /**
         * @type {?}
         * @private
         */
        SidebarService.prototype._closeObserver;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: sidebar.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 侧边栏
     */
    var SidebarComponent = /** @class */ (function () {
        /**
         * @param {?} _sidebarService
         * @param {?} config
         * @param {?} doc
         */
        function SidebarComponent(_sidebarService, config, doc) {
            this._sidebarService = _sidebarService;
            this.doc = doc;
            /**
             * 状态，true表示打开，false表示关闭
             */
            this.status = false;
            this.statusChange = new i0.EventEmitter();
            /**
             * 位置方向，默认：`left`
             */
            this.position = 'left';
            /**
             * 类型，默认：`slide`
             * - over: 不覆盖
             * - slide：侧边移动
             */
            this.mode = 'slide';
            /**
             * 允许点击背景关闭，默认：`true`
             */
            this.backdrop = true;
            /**
             * 打开前回调
             */
            this.openStart = new i0.EventEmitter();
            /**
             * 打开后回调
             */
            this.opened = new i0.EventEmitter();
            /**
             * 关闭前回调
             */
            this.closeStart = new i0.EventEmitter();
            /**
             * 关闭后回调
             */
            this.closed = new i0.EventEmitter();
            /**
             * 模式变更通知
             */
            this.modeChange = new i0.EventEmitter();
            /**
             * 位置变更通知
             */
            this.positionChange = new i0.EventEmitter();
            this._rerender = new i0.EventEmitter();
            this._clickEvent = 'click';
            this._onClickOutsideAttached = false;
            this._anting = false;
            Object.assign(this, config);
            if (core.isIOS() && 'ontouchstart' in window) {
                this._clickEvent = 'touchstart';
            }
            this.open = this.open.bind(this);
            this.close = this.close.bind(this);
            this._onClickOutside = this._onClickOutside.bind(this);
            this._openSub = this._sidebarService.onOpen(this.open);
            this._closeSub = this._sidebarService.onClose(this.close);
        }
        Object.defineProperty(SidebarComponent.prototype, "_height", {
            /**
             * 获取侧边栏容器高度
             * @return {?}
             */
            get: function () {
                return this._elSidebar.nativeElement ? this._elSidebar.nativeElement.offsetHeight : 0;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(SidebarComponent.prototype, "_width", {
            /**
             * 获取侧边栏容器宽度
             * @return {?}
             */
            get: function () {
                return this._elSidebar.nativeElement ? this._elSidebar.nativeElement.offsetWidth : 0;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        SidebarComponent.prototype.ngOnChanges = function (changes) {
            if (changes.status && !this._anting) {
                if (changes.status.currentValue) {
                    this.open();
                }
                else {
                    this.close();
                }
                if (changes.status.firstChange) {
                    this._anting = false;
                }
            }
            if (changes.mode) {
                this.modeChange.emit(changes.mode.currentValue);
            }
            if (changes.position) {
                this.positionChange.emit(changes.position.currentValue);
            }
            if (changes.backdrop) {
                this._initCloseListeners();
            }
        };
        /**
         * @return {?}
         */
        SidebarComponent.prototype.ngOnDestroy = function () {
            this._destroyCloseListeners();
            if (this._openSub) {
                this._openSub.unsubscribe();
            }
            if (this._closeSub) {
                this._closeSub.unsubscribe();
            }
        };
        /**
         * 打开侧边栏
         * @return {?}
         */
        SidebarComponent.prototype.open = function () {
            this._anting = true;
            this.status = true;
            this.statusChange.emit(true);
            this.openStart.emit();
            this.closeAnt();
        };
        /**
         * 关闭侧边栏
         * @return {?}
         */
        SidebarComponent.prototype.close = function () {
            this._anting = true;
            this.status = false;
            this.statusChange.emit(false);
            this.closeStart.emit();
            this.closeAnt();
        };
        /**
         * 手动触发容器的重新渲染
         * @return {?}
         */
        SidebarComponent.prototype._triggerRerender = function () {
            this._rerender.emit();
        };
        /**
         * @return {?}
         */
        SidebarComponent.prototype._getStyle = function () {
            /** @type {?} */
            var transformStyle = 'none';
            /** @type {?} */
            var marginStyle = {};
            /** @type {?} */
            var isSlideMode = this.mode === 'slide';
            if (!this.status || isSlideMode) {
                transformStyle = "translate" + (this.position === 'left' || this.position === 'right' ? 'X' : 'Y');
                /** @type {?} */
                var isLeftOrTop = this.position === 'left' || this.position === 'top';
                /** @type {?} */
                var translateAmt = (isLeftOrTop ? '-' : '') + "100%";
                transformStyle += "(" + translateAmt + ")";
            }
            return ( /** @type {?} */(Object.assign(Object.assign({}, marginStyle), { webkitTransform: transformStyle, transform: transformStyle })));
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype.closeAnt = function () {
            var _this = this;
            setTimeout(( /**
             * @return {?}
             */function () {
                _this._anting = false;
                if (_this.status) {
                    _this._initCloseListeners();
                    _this.opened.emit();
                }
                else {
                    _this._destroyCloseListeners();
                    _this.closed.emit();
                }
            }), 300);
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype._initCloseListeners = function () {
            var _this = this;
            if (this.status && this.backdrop) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    if (_this.backdrop && !_this._onClickOutsideAttached) {
                        _this.doc.addEventListener(_this._clickEvent, _this._onClickOutside, false);
                        _this._onClickOutsideAttached = true;
                    }
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        SidebarComponent.prototype._destroyCloseListeners = function () {
            if (this._onClickOutsideAttached) {
                this.doc.removeEventListener(this._clickEvent, this._onClickOutside, false);
                this._onClickOutsideAttached = false;
            }
        };
        /**
         * @private
         * @param {?} e
         * @return {?}
         */
        SidebarComponent.prototype._onClickOutside = function (e) {
            if (this._onClickOutsideAttached && this._elSidebar && !this._elSidebar.nativeElement.contains(( /** @type {?} */(e.target)))) {
                this.close();
            }
        };
        return SidebarComponent;
    }());
    SidebarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-sidebar',
                    exportAs: 'weuiSidebar',
                    template: "<aside\n  #sidebar\n  role=\"complementary\"\n  [attr.aria-hidden]=\"!status\"\n  [attr.aria-label]=\"ariaLabel\"\n  class=\"weui-sidebar weui-sidebar__{{ status ? 'opened' : 'closed' }} weui-sidebar__{{ position }} weui-sidebar__{{\n    mode\n  }}\"\n  [class.weui-sidebar__inert]=\"!status\"\n  [ngClass]=\"sidebarClass\"\n  [ngStyle]=\"_getStyle()\"\n>\n  <ng-content></ng-content>\n</aside>\n",
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SidebarComponent.ctorParameters = function () { return [
        { type: SidebarService },
        { type: SidebarConfig },
        { type: undefined, decorators: [{ type: i0.Inject, args: [common.DOCUMENT,] }] }
    ]; };
    SidebarComponent.propDecorators = {
        status: [{ type: i0.Input }],
        statusChange: [{ type: i0.Output }],
        position: [{ type: i0.Input }],
        mode: [{ type: i0.Input }],
        backdrop: [{ type: i0.Input }],
        sidebarClass: [{ type: i0.Input }],
        ariaLabel: [{ type: i0.Input }],
        openStart: [{ type: i0.Output }],
        opened: [{ type: i0.Output }],
        closeStart: [{ type: i0.Output }],
        closed: [{ type: i0.Output }],
        modeChange: [{ type: i0.Output }],
        positionChange: [{ type: i0.Output }],
        _rerender: [{ type: i0.Output }],
        _elSidebar: [{ type: i0.ViewChild, args: ['sidebar', { static: true },] }]
    };
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], SidebarComponent.prototype, "status", void 0);
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], SidebarComponent.prototype, "backdrop", void 0);
    if (false) {
        /**
         * 状态，true表示打开，false表示关闭
         * @type {?}
         */
        SidebarComponent.prototype.status;
        /** @type {?} */
        SidebarComponent.prototype.statusChange;
        /**
         * 位置方向，默认：`left`
         * @type {?}
         */
        SidebarComponent.prototype.position;
        /**
         * 类型，默认：`slide`
         * - over: 不覆盖
         * - slide：侧边移动
         * @type {?}
         */
        SidebarComponent.prototype.mode;
        /**
         * 允许点击背景关闭，默认：`true`
         * @type {?}
         */
        SidebarComponent.prototype.backdrop;
        /**
         * 自定义CLSS
         * @type {?}
         */
        SidebarComponent.prototype.sidebarClass;
        /**
         * 辅助设备标识
         * @type {?}
         */
        SidebarComponent.prototype.ariaLabel;
        /**
         * 打开前回调
         * @type {?}
         */
        SidebarComponent.prototype.openStart;
        /**
         * 打开后回调
         * @type {?}
         */
        SidebarComponent.prototype.opened;
        /**
         * 关闭前回调
         * @type {?}
         */
        SidebarComponent.prototype.closeStart;
        /**
         * 关闭后回调
         * @type {?}
         */
        SidebarComponent.prototype.closed;
        /**
         * 模式变更通知
         * @type {?}
         */
        SidebarComponent.prototype.modeChange;
        /**
         * 位置变更通知
         * @type {?}
         */
        SidebarComponent.prototype.positionChange;
        /** @type {?} */
        SidebarComponent.prototype._rerender;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._elSidebar;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._openSub;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._closeSub;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._clickEvent;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._onClickOutsideAttached;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._anting;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype._sidebarService;
        /**
         * @type {?}
         * @private
         */
        SidebarComponent.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: sidebar-container.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 侧边栏容器
     */
    var SidebarContainerComponent = /** @class */ (function () {
        /**
         * @param {?} _ref
         * @param {?} _el
         */
        function SidebarContainerComponent(_ref, _el) {
            this._ref = _ref;
            this._el = _el;
            this._showBackdrop = false;
            this._showBackdropChange = new i0.EventEmitter();
            this.orgOverflowX = '';
        }
        Object.defineProperty(SidebarContainerComponent.prototype, "body", {
            /**
             * @private
             * @return {?}
             */
            get: function () {
                return ( /** @type {?} */(document.querySelector('body')));
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            this._onToggle();
            this._subscribe();
            this._sidebars.changes.subscribe(( /**
             * @return {?}
             */function () {
                _this._unsubscribe();
                _this._subscribe();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnChanges = function (changes) {
            if (changes._showBackdrop) {
                this._showBackdropChange.emit(changes._showBackdrop.currentValue);
            }
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnInit = function () {
            this.orgOverflowX = ( /** @type {?} */(this.body.style.overflowX));
            this.body.style.overflowX = 'hidden';
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype.ngOnDestroy = function () {
            this._unsubscribe();
            this.body.style.overflowX = this.orgOverflowX;
        };
        /**
         * @return {?}
         */
        SidebarContainerComponent.prototype._getStyles = function () {
            var _this = this;
            if (this._sidebars) {
                this._sidebars.forEach(( /**
                 * @param {?} sidebar
                 * @return {?}
                 */function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    if (sidebar.mode === 'slide') {
                        /** @type {?} */
                        var transformStyle = null;
                        if (sidebar.status) {
                            /** @type {?} */
                            var isLeftOrTop = sidebar.position === 'left' || sidebar.position === 'top';
                            /** @type {?} */
                            var isLeftOrRight = sidebar.position === 'left' || sidebar.position === 'right';
                            /** @type {?} */
                            var transformDir = isLeftOrRight ? 'X' : 'Y';
                            /** @type {?} */
                            var transformAmt = "" + (isLeftOrTop ? '' : '-') + (isLeftOrRight ? sidebar._width : sidebar._height);
                            transformStyle = "translate" + transformDir + "(" + transformAmt + "px)";
                        }
                        _this._el.nativeElement.style.transform = transformStyle;
                    }
                }));
            }
            return ( /** @type {?} */({
                margin: "0px 0px 0px 0px",
            }));
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        SidebarContainerComponent.prototype._onBackdropClicked = function ($event) {
            $event.preventDefault();
            $event.stopPropagation();
            this._sidebars.forEach(( /**
             * @param {?} sidebar
             * @return {?}
             */function (sidebar) {
                if (sidebar.status && sidebar.backdrop) {
                    sidebar.close();
                }
            }));
            return false;
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._subscribe = function () {
            var _this = this;
            if (this._sidebars) {
                this._sidebars.forEach(( /**
                 * @param {?} sidebar
                 * @return {?}
                 */function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    sidebar.openStart.subscribe(( /**
                     * @return {?}
                     */function () { return _this._onToggle(); }));
                    sidebar.opened.subscribe(( /**
                     * @return {?}
                     */function () { return _this._markForCheck(); }));
                    sidebar.closeStart.subscribe(( /**
                     * @return {?}
                     */function () { return _this._onToggle(); }));
                    sidebar.closed.subscribe(( /**
                     * @return {?}
                     */function () { return _this._markForCheck(); }));
                    sidebar.modeChange.subscribe(( /**
                     * @return {?}
                     */function () { return _this._markForCheck(); }));
                    sidebar.positionChange.subscribe(( /**
                     * @return {?}
                     */function () { return _this._markForCheck(); }));
                    sidebar._rerender.subscribe(( /**
                     * @return {?}
                     */function () { return _this._markForCheck(); }));
                }));
            }
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._unsubscribe = function () {
            if (this._sidebars) {
                this._sidebars.forEach(( /**
                 * @param {?} sidebar
                 * @return {?}
                 */function (sidebar) {
                    if (!sidebar) {
                        return;
                    }
                    sidebar.openStart.unsubscribe();
                    sidebar.opened.unsubscribe();
                    sidebar.closeStart.unsubscribe();
                    sidebar.closed.unsubscribe();
                    sidebar.modeChange.unsubscribe();
                    sidebar.positionChange.unsubscribe();
                    sidebar._rerender.unsubscribe();
                }));
            }
        };
        /**
         * 状态变更时重新计算样式
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._markForCheck = function () {
            this._ref.markForCheck();
        };
        /**
         * @private
         * @return {?}
         */
        SidebarContainerComponent.prototype._onToggle = function () {
            if (this._sidebars) {
                /** @type {?} */
                var hasOpen = false;
                /** @type {?} */
                var _sidebars = this._sidebars.toArray();
                // tslint:disable-next-line: prefer-for-of
                for (var i = 0; i < _sidebars.length; i++) {
                    /** @type {?} */
                    var sidebar = _sidebars[i];
                    if (sidebar.status) {
                        hasOpen = true;
                        break;
                    }
                }
                this._showBackdrop = hasOpen;
                this._showBackdropChange.emit(hasOpen);
            }
            this._markForCheck();
        };
        return SidebarContainerComponent;
    }());
    SidebarContainerComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-sidebar-container',
                    exportAs: 'weuiSidebarContainer',
                    template: "<ng-content select=\"weui-sidebar\"></ng-content>\n<div *ngIf=\"_showBackdrop\" aria-hidden=\"true\" class=\"weui-mask\" (click)=\"_onBackdropClicked($event)\"></div>\n<div class=\"weui-sidebar__content\" [ngStyle]=\"_getStyles()\">\n  <ng-content></ng-content>\n</div>\n",
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SidebarContainerComponent.ctorParameters = function () { return [
        { type: i0.ChangeDetectorRef },
        { type: i0.ElementRef }
    ]; };
    SidebarContainerComponent.propDecorators = {
        _sidebars: [{ type: i0.ContentChildren, args: [SidebarComponent,] }],
        _showBackdrop: [{ type: i0.Input }],
        _showBackdropChange: [{ type: i0.Output }]
    };
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], SidebarContainerComponent.prototype, "_showBackdrop", void 0);
    if (false) {
        /** @type {?} */
        SidebarContainerComponent.prototype._sidebars;
        /** @type {?} */
        SidebarContainerComponent.prototype._showBackdrop;
        /** @type {?} */
        SidebarContainerComponent.prototype._showBackdropChange;
        /**
         * @type {?}
         * @private
         */
        SidebarContainerComponent.prototype.orgOverflowX;
        /**
         * @type {?}
         * @private
         */
        SidebarContainerComponent.prototype._ref;
        /**
         * @type {?}
         * @private
         */
        SidebarContainerComponent.prototype._el;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: close.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 关闭侧边栏指令
     */
    var CloseSidebarDirective = /** @class */ (function () {
        /**
         * @param {?} _sidebarService
         */
        function CloseSidebarDirective(_sidebarService) {
            this._sidebarService = _sidebarService;
        }
        /**
         * @return {?}
         */
        CloseSidebarDirective.prototype._onClick = function () {
            this._sidebarService.close();
        };
        return CloseSidebarDirective;
    }());
    CloseSidebarDirective.decorators = [
        { type: i0.Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[closeSidebar]',
                    exportAs: 'weuiCloseSidebar',
                    host: {
                        '(click)': '_onClick()',
                    },
                },] }
    ];
    /** @nocollapse */
    CloseSidebarDirective.ctorParameters = function () { return [
        { type: SidebarService }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        CloseSidebarDirective.prototype._sidebarService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: sidebar.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [SidebarContainerComponent, SidebarComponent, CloseSidebarDirective];
    var SidebarModule = /** @class */ (function () {
        function SidebarModule() {
        }
        return SidebarModule;
    }());
    SidebarModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                    providers: [SidebarService],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-sidebar.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.CloseSidebarDirective = CloseSidebarDirective;
    exports.SidebarComponent = SidebarComponent;
    exports.SidebarConfig = SidebarConfig;
    exports.SidebarContainerComponent = SidebarContainerComponent;
    exports.SidebarModule = SidebarModule;
    exports.SidebarService = SidebarService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-sidebar.umd.js.map
