/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/slider', ['exports', '@angular/core', '@angular/forms', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].slider = {}), global.ng.core, global.ng.forms, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, core, forms, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: slider.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SliderComponent = /** @class */ (function () {
        /**
         * @param {?} el
         * @param {?} cdr
         */
        function SliderComponent(el, cdr) {
            this.cdr = cdr;
            this.state = null;
            this.isInit = false;
            this.value = 0;
            /**
             * 允许的最小值，默认：`0`
             */
            this.min = 0;
            /**
             * 允许的最大值，默认：`100`
             */
            this.max = 100;
            /**
             * 步长，默认：`1`
             */
            this.step = 1;
            /**
             * 是否可用
             */
            this.enabled = true;
            this.showValue = true;
            /**
             * 值改变时触发
             */
            // tslint:disable-next-line: no-output-rename
            this.change = new core.EventEmitter();
            this.el = el.nativeElement;
        }
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngAfterViewInit = function () {
            this.isInit = true;
            this.trackEl = ( /** @type {?} */(( /** @type {?} */(this.el.querySelector('.weui-slider__track')))));
            this.handlerEl = ( /** @type {?} */(( /** @type {?} */(this.el.querySelector('.weui-slider__handler')))));
            this.onTouchStart = this.startHandle.bind(this);
            this.onTouchMove = this.moveHandle.bind(this);
            this.handlerEl.addEventListener('touchstart', this.onTouchStart, false);
            this.handlerEl.addEventListener('touchmove', this.onTouchMove, false);
        };
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngOnDestroy = function () {
            this.handlerEl.removeEventListener('touchstart', this.onTouchStart, false);
            this.handlerEl.removeEventListener('touchmove', this.onTouchMove, false);
        };
        /**
         * @private
         * @return {?}
         */
        SliderComponent.prototype.refresh = function () {
            this.state = {
                enabled: this.enabled,
                left: this.el.getBoundingClientRect().left,
                size: ( /** @type {?} */((( /** @type {?} */(( /** @type {?} */(this.el.querySelector('.weui-slider__inner')))))).offsetWidth)),
                percentage: [0, 0, 0],
                x: 0,
            };
            this.max = +this.max;
            this.min = +this.min;
            this.step = +this.step;
            this.setValue(this.value);
            this.layout();
        };
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        SliderComponent.prototype.setValue = function (value) {
            if (this.max > this.min) {
                this.state.percentage = [
                    // tslint:disable-next-line: binary-expression-operand-order
                    (100 * (value - this.min)) / (this.max - this.min),
                    0,
                    (this.step * 100) / (this.max - this.min),
                ];
            }
            else {
                this.state.percentage = [0, 0, 100];
            }
        };
        /**
         * @private
         * @return {?}
         */
        SliderComponent.prototype.layout = function () {
            this.trackEl.style.width = this.state.percentage[0] + '%';
            this.handlerEl.style.left = this.state.percentage[0] + '%';
        };
        /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        SliderComponent.prototype.startHandle = function ($event) {
            if (this.state === null) {
                this.refresh();
            }
            this.state.x = ($event.touches[0] || $event.changedTouches[0]).pageX;
        };
        /**
         * @private
         * @param {?} $event
         * @return {?}
         */
        SliderComponent.prototype.moveHandle = function ($event) {
            if (!this.state.enabled) {
                return;
            }
            /** @type {?} */
            var pageX = ($event.touches[0] || $event.changedTouches[0]).pageX;
            /** @type {?} */
            var xDiff = pageX - this.state.x;
            if (xDiff >= 15 || xDiff <= 15) {
                this.state.percentage[0] = this.getPercentage(pageX);
                this.layout();
                this.calculateValue(this.state.percentage[0]);
            }
        };
        /**
         * @private
         * @param {?} pageX
         * @return {?}
         */
        SliderComponent.prototype.getPercentage = function (pageX) {
            /** @type {?} */
            var distanceToSlide = pageX - this.state.left;
            /** @type {?} */
            var percentage = (distanceToSlide / this.state.size) * 100;
            percentage = Math.round(percentage / this.state.percentage[2]) * this.state.percentage[2];
            return Math.max(0, Math.min(100, percentage));
        };
        /**
         * @private
         * @param {?} percentage
         * @return {?}
         */
        SliderComponent.prototype.calculateValue = function (percentage) {
            /** @type {?} */
            var rawValue = (percentage / 100) * (this.max - this.min);
            // adjustment = this.min
            /** @type {?} */
            var value = this.min + Math.round(rawValue / this.step) * this.step;
            if (value < this.min) {
                value = this.min;
            }
            else if (value > this.max) {
                value = this.max;
            }
            this.value = value;
            this.onChange(this.value);
            this.onTouched();
            this.change.emit(this.value);
        };
        /**
         * @return {?}
         */
        SliderComponent.prototype.ngOnChanges = function () {
            if (this.isInit) {
                this.refresh();
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        SliderComponent.prototype.writeValue = function (value) {
            if (value) {
                this.value = +value;
                this.refresh();
                this.calculateValue(this.state.percentage[0]);
            }
            this.cdr.detectChanges();
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SliderComponent.prototype.registerOnChange = function (fn) {
            this.onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        SliderComponent.prototype.registerOnTouched = function (fn) {
            this.onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        SliderComponent.prototype.setDisabledState = function (isDisabled) {
            this.enabled = !isDisabled;
        };
        return SliderComponent;
    }());
    SliderComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'weui-slider, [weui-slider]',
                    exportAs: 'weuiSlider',
                    template: "<div *ngIf=\"!showValue\" class=\"weui-slider__inner\">\n  <div class=\"weui-slider__track\"></div>\n  <div class=\"weui-slider__handler\"></div>\n</div>\n<ng-container *ngIf=\"showValue\">\n  <div class=\"weui-slider\">\n    <div class=\"weui-slider__inner\">\n      <div class=\"weui-slider__track\"></div>\n      <div class=\"weui-slider__handler\"></div>\n    </div>\n  </div>\n  <div class=\"weui-slider-box__value\">{{ value }}</div>\n</ng-container>\n",
                    host: {
                        '[class.weui-slider-box]': 'showValue',
                        '[class.weui-slider]': '!showValue',
                        '[class.weui-slider__disabled]': '!enabled',
                    },
                    providers: [
                        {
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(( /**
                             * @return {?}
                             */function () { return SliderComponent; })),
                            multi: true,
                        },
                    ],
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SliderComponent.ctorParameters = function () { return [
        { type: core.ElementRef },
        { type: core.ChangeDetectorRef }
    ]; };
    SliderComponent.propDecorators = {
        min: [{ type: core.Input, args: ['weui-min',] }],
        max: [{ type: core.Input, args: ['weui-max',] }],
        step: [{ type: core.Input, args: ['weui-step',] }],
        enabled: [{ type: core.Input, args: ['weui-enabled',] }],
        showValue: [{ type: core.Input, args: ['weui-show-value',] }],
        change: [{ type: core.Output, args: ['weui-change',] }]
    };
    __decorate([
        core$1.InputNumber(),
        __metadata("design:type", Number)
    ], SliderComponent.prototype, "min", void 0);
    __decorate([
        core$1.InputNumber(),
        __metadata("design:type", Number)
    ], SliderComponent.prototype, "max", void 0);
    __decorate([
        core$1.InputNumber(),
        __metadata("design:type", Number)
    ], SliderComponent.prototype, "step", void 0);
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], SliderComponent.prototype, "enabled", void 0);
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], SliderComponent.prototype, "showValue", void 0);
    if (false) {
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.state;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.isInit;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.trackEl;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.handlerEl;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.onChange;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.onTouched;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.onTouchStart;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.onTouchMove;
        /** @type {?} */
        SliderComponent.prototype.value;
        /**
         * 允许的最小值，默认：`0`
         * @type {?}
         */
        SliderComponent.prototype.min;
        /**
         * 允许的最大值，默认：`100`
         * @type {?}
         */
        SliderComponent.prototype.max;
        /**
         * 步长，默认：`1`
         * @type {?}
         */
        SliderComponent.prototype.step;
        /**
         * 是否可用
         * @type {?}
         */
        SliderComponent.prototype.enabled;
        /** @type {?} */
        SliderComponent.prototype.showValue;
        /**
         * 值改变时触发
         * @type {?}
         */
        SliderComponent.prototype.change;
        /**
         * @type {?}
         * @private
         */
        SliderComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: slider.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SliderModule = /** @class */ (function () {
        function SliderModule() {
        }
        return SliderModule;
    }());
    SliderModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [SliderComponent],
                    exports: [SliderComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-slider.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.SliderDirective = SliderComponent;
    exports.SliderModule = SliderModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-slider.umd.js.map
