/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/tab', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].tab = {}), global.ng.core, global['ngx-weui'].core, global.ng.common, global.ng.forms));
}(this, (function (exports, core, core$1, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: bar.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarComponent = /** @class */ (function () {
        /**
         * @param {?} cdr
         */
        function BarComponent(cdr) {
            this.cdr = cdr;
            this.tabs = [];
        }
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.add = function (tab) {
            this.tabs.push(tab);
            tab.active = this.tabs.length === 1 && tab.active !== false;
        };
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.remove = function (tab) {
            /** @type {?} */
            var index = this.tabs.indexOf(tab);
            if (index === -1 || this.isDestroyed) {
                return;
            }
            // Select a new tab if the tab to be removed is selected and not destroyed
            if (tab.active && this.hasAvailableTabs(index)) {
                /** @type {?} */
                var newActiveIndex = this.getClosestTabIndex(index);
                this.tabs[newActiveIndex].active = true;
            }
            tab.removed.emit(tab);
            this.tabs.splice(index, 1);
        };
        /**
         * @param {?} tab
         * @return {?}
         */
        BarComponent.prototype.setActive = function (tab) {
            tab.active = true;
            tab.select.emit(tab);
        };
        /**
         * @return {?}
         */
        BarComponent.prototype.detectChanges = function () {
            this.cdr.detectChanges();
        };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BarComponent.prototype.getClosestTabIndex = function (index) {
            /** @type {?} */
            var tabsLength = this.tabs.length;
            if (!tabsLength) {
                return -1;
            }
            for (var step = 1; step <= tabsLength; step += 1) {
                /** @type {?} */
                var prevIndex = index - step;
                /** @type {?} */
                var nextIndex = index + step;
                if (this.tabs[prevIndex] && !this.tabs[prevIndex].disabled) {
                    return prevIndex;
                }
                if (this.tabs[nextIndex] && !this.tabs[nextIndex].disabled) {
                    return nextIndex;
                }
            }
            return -1;
        };
        /**
         * @protected
         * @param {?} index
         * @return {?}
         */
        BarComponent.prototype.hasAvailableTabs = function (index) {
            /** @type {?} */
            var tabsLength = this.tabs.length;
            if (!tabsLength) {
                return false;
            }
            for (var i = 0; i < tabsLength; i += 1) {
                if (!this.tabs[i].disabled && i !== index) {
                    return true;
                }
            }
            return false;
        };
        /**
         * @return {?}
         */
        BarComponent.prototype.ngOnDestroy = function () {
            this.isDestroyed = true;
        };
        return BarComponent;
    }());
    BarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'weui-bar-component',
                    template: ""
                }] }
    ];
    /** @nocollapse */
    BarComponent.ctorParameters = function () { return [
        { type: core.ChangeDetectorRef }
    ]; };
    if (false) {
        /** @type {?} */
        BarComponent.prototype.tabs;
        /**
         * @type {?}
         * @protected
         */
        BarComponent.prototype.isDestroyed;
        /**
         * @type {?}
         * @private
         */
        BarComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: tab.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TabDirective = /** @class */ (function () {
        /**
         * @param {?} tab
         */
        function TabDirective(tab) {
            this.iconUrl = false;
            /**
             * 当tab激活时触发
             */
            this.select = new core.EventEmitter();
            /**
             * 当tab无效时触发
             */
            this.deselect = new core.EventEmitter();
            /**
             * 当tab移除时触发
             */
            this.removed = new core.EventEmitter();
            this._tabComp = tab;
            this._tabComp.add(this);
        }
        Object.defineProperty(TabDirective.prototype, "active", {
            /**
             * 激活
             * @return {?}
             */
            get: function () {
                return this._active;
            },
            /**
             * @param {?} active
             * @return {?}
             */
            set: function (active) {
                var _this = this;
                if ((this.disabled && active) || !active) {
                    if (!active) {
                        this._active = active;
                    }
                    this.deselect.emit(this);
                    return;
                }
                this._active = active;
                this._tabComp.tabs.filter(( /**
                 * @param {?} t
                 * @return {?}
                 */function (/**
                 * @param {?} t
                 * @return {?}
                 */ t) { return t !== _this; })).forEach(( /**
                 * @param {?} tab
                 * @return {?}
                 */function (/**
                 * @param {?} tab
                 * @return {?}
                 */ tab) { return (tab.active = false); }));
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        TabDirective.prototype.ngOnChanges = function () {
            this.iconUrl = /(webp|svg|png|gif|jpg|jpeg|jfif|bmp|dpg)$/i.test(this.icon);
            if (!this.activeIcon) {
                this.activeIcon = this.icon;
            }
            this._tabComp.detectChanges();
        };
        /**
         * @return {?}
         */
        TabDirective.prototype.ngOnDestroy = function () {
            this._tabComp.remove(this);
        };
        return TabDirective;
    }());
    TabDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: 'weui-tab, [weui-tab]',
                    exportAs: 'weuiTab',
                    host: {
                        '[class.active]': 'active',
                    },
                },] }
    ];
    /** @nocollapse */
    TabDirective.ctorParameters = function () { return [
        { type: BarComponent }
    ]; };
    TabDirective.propDecorators = {
        heading: [{ type: core.Input }],
        disabled: [{ type: core.Input }],
        iconClassName: [{ type: core.Input }],
        icon: [{ type: core.Input }],
        activeIcon: [{ type: core.Input }],
        badge: [{ type: core.Input }],
        select: [{ type: core.Output }],
        deselect: [{ type: core.Output }],
        removed: [{ type: core.Output }],
        active: [{ type: core.Input }]
    };
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], TabDirective.prototype, "disabled", void 0);
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], TabDirective.prototype, "active", null);
    if (false) {
        /** @type {?} */
        TabDirective.prototype.iconUrl;
        /**
         * 选项卡名称
         * @type {?}
         */
        TabDirective.prototype.heading;
        /**
         * 是否禁用
         * @type {?}
         */
        TabDirective.prototype.disabled;
        /**
         * Icon类名，一般用于雪碧图
         * @type {?}
         */
        TabDirective.prototype.iconClassName;
        /**
         * icon图标，支持HTML、支持有效图像资源结尾的扩展名URL地址
         * @type {?}
         */
        TabDirective.prototype.icon;
        /**
         * 激活时icon图标，支持HTML、支持有效图像资源结尾的扩展名URL地址
         * @type {?}
         */
        TabDirective.prototype.activeIcon;
        /**
         * 徽章内容，支持数字或圆点
         * @type {?}
         */
        TabDirective.prototype.badge;
        /**
         * 当tab激活时触发
         * @type {?}
         */
        TabDirective.prototype.select;
        /**
         * 当tab无效时触发
         * @type {?}
         */
        TabDirective.prototype.deselect;
        /**
         * 当tab移除时触发
         * @type {?}
         */
        TabDirective.prototype.removed;
        /**
         * @type {?}
         * @protected
         */
        TabDirective.prototype._active;
        /**
         * @type {?}
         * @protected
         */
        TabDirective.prototype._tabComp;
    }

    /**
     * 顶部选项卡
     */
    var NavbarComponent = /** @class */ (function (_super) {
        __extends(NavbarComponent, _super);
        function NavbarComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return NavbarComponent;
    }(BarComponent));
    NavbarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'weui-navbar',
                    exportAs: 'weuiNavbar',
                    template: "<div class=\"weui-navbar\">\n  <div\n    class=\"weui-navbar__item\"\n    [ngClass]=\"{ 'weui-bar__item_on': item.active }\"\n    [class.disabled]=\"item.disabled\"\n    *ngFor=\"let item of tabs\"\n    (click)=\"setActive(item)\"\n  >\n    {{ item.heading }}\n  </div>\n</div>\n<div class=\"weui-tab__panel\"><ng-content></ng-content></div>\n",
                    providers: [{ provide: BarComponent, useExisting: core.forwardRef(( /**
                                     * @return {?}
                                     */function () { return NavbarComponent; })) }],
                    host: {
                        '[class.weui-tab]': 'true',
                    },
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                }] }
    ];

    /**
     * 底部选项卡
     */
    var TabbarComponent = /** @class */ (function (_super) {
        __extends(TabbarComponent, _super);
        function TabbarComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return TabbarComponent;
    }(BarComponent));
    TabbarComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'weui-tabbar',
                    exportAs: 'weuiTabbar',
                    template: "<div class=\"weui-tab__panel\"><ng-content></ng-content></div>\n<div class=\"weui-tabbar\">\n  <div class=\"weui-tabbar__item\" *ngFor=\"let item of tabs\" [ngClass]=\"{ 'weui-bar__item_on': item.active }\" (click)=\"setActive(item)\">\n    <div style=\"position: relative; display: inline-block;\">\n      <div *ngIf=\"item.iconUrl\" class=\"weui-tabbar__icon\" [ngClass]=\"item.iconClassName\">\n        <img [src]=\"item.active ? item.activeIcon : item.icon\" />\n      </div>\n      <div *ngIf=\"!item.iconUrl\" class=\"weui-tabbar__icon\" [innerHTML]=\"item.active ? item.activeIcon : item.icon\" [ngClass]=\"item.iconClassName\"></div>\n      <span class=\"weui-badge\" style=\"position: absolute; top: -2px; right: -13px;\" *ngIf=\"item.badge && item.badge !== 'dot'\">{{ item.badge }}</span>\n      <span class=\"weui-badge weui-badge_dot\" style=\"position: absolute; top: 0; right: -6px;\" *ngIf=\"item.badge && item.badge === 'dot'\"></span>\n    </div>\n    <p class=\"weui-tabbar__label\">{{ item.heading }}</p>\n  </div>\n</div>\n",
                    providers: [{ provide: BarComponent, useExisting: core.forwardRef(( /**
                                     * @return {?}
                                     */function () { return TabbarComponent; })) }],
                    host: {
                        '[class.weui-tab]': 'true',
                    },
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                }] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: tab.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var COMPONENTS = [TabDirective, NavbarComponent, TabbarComponent, BarComponent];
    var TabModule = /** @class */ (function () {
        function TabModule() {
        }
        return TabModule;
    }());
    TabModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: COMPONENTS,
                    exports: COMPONENTS,
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-tab.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.BarComponent = BarComponent;
    exports.NavbarComponent = NavbarComponent;
    exports.TabDirective = TabDirective;
    exports.TabModule = TabModule;
    exports.TabbarComponent = TabbarComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-tab.umd.js.map
