/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/toptips', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].toptips = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, i0, core, i1) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: toptips.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToptipsComponent = /** @class */ (function () {
        /**
         * @param {?} el
         * @param {?} uhcs
         */
        function ToptipsComponent(el, uhcs) {
            this.el = el;
            this.uhcs = uhcs;
            this._showd = false;
            /**
             * 显示时长后自动关闭（单位：ms），默认：`2000`
             */
            this.time = 2000;
            /**
             * 类型
             */
            this.type = 'primary';
            /**
             * 隐藏后回调
             */
            this.hide = new i0.EventEmitter();
        }
        /**
         * @private
         * @return {?}
         */
        ToptipsComponent.prototype.setClassMap = function () {
            var _a;
            /** @type {?} */
            var prefixCls = 'weui-toptips';
            var _b = this, uhcs = _b.uhcs, el = _b.el, type = _b.type;
            uhcs.updateHostClass(el.nativeElement, (_a = {},
                _a["" + prefixCls] = true,
                _a[prefixCls + "__" + type] = true,
                _a));
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnInit = function () {
            this.setClassMap();
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnChanges = function () {
            this.setClassMap();
        };
        /**
         * @template THIS
         * @this {THIS}
         * @return {THIS}
         */
        ToptipsComponent.prototype.onShow = function () {
            var _this = this;
            ( /** @type {?} */(this)).destroy();
            ( /** @type {?} */(this))._showd = true;
            ( /** @type {?} */(this)).timer = setTimeout(( /**
             * @return {?}
             */function () { return ( /** @type {?} */(_this)).onHide(); }), ( /** @type {?} */(this)).time);
            return ( /** @type {?} */(this));
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.onHide = function () {
            this._showd = false;
            this.hide.emit();
        };
        /**
         * @private
         * @return {?}
         */
        ToptipsComponent.prototype.destroy = function () {
            if (this.timer) {
                clearTimeout(this.timer);
                this.timer = null;
            }
        };
        /**
         * @return {?}
         */
        ToptipsComponent.prototype.ngOnDestroy = function () {
            this.destroy();
        };
        return ToptipsComponent;
    }());
    ToptipsComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-toptips',
                    exportAs: 'weuiToptips',
                    template: " {{ text }}<ng-content></ng-content> ",
                    host: {
                        '[hidden]': '!_showd',
                        '[style.display]': '_showd ? "block" : "none"',
                    },
                    providers: [core.UpdateHostClassService],
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ToptipsComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: core.UpdateHostClassService }
    ]; };
    ToptipsComponent.propDecorators = {
        text: [{ type: i0.Input }],
        time: [{ type: i0.Input }],
        type: [{ type: i0.Input }],
        hide: [{ type: i0.Output }]
    };
    __decorate([
        core.InputNumber(),
        __metadata("design:type", Number)
    ], ToptipsComponent.prototype, "time", void 0);
    if (false) {
        /**
         * @type {?}
         * @private
         */
        ToptipsComponent.prototype.timer;
        /** @type {?} */
        ToptipsComponent.prototype._showd;
        /**
         * 文本
         * @type {?}
         */
        ToptipsComponent.prototype.text;
        /**
         * 显示时长后自动关闭（单位：ms），默认：`2000`
         * @type {?}
         */
        ToptipsComponent.prototype.time;
        /**
         * 类型
         * @type {?}
         */
        ToptipsComponent.prototype.type;
        /**
         * 隐藏后回调
         * @type {?}
         */
        ToptipsComponent.prototype.hide;
        /**
         * @type {?}
         * @private
         */
        ToptipsComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        ToptipsComponent.prototype.uhcs;
    }

    var ToptipsService = /** @class */ (function (_super) {
        __extends(ToptipsService, _super);
        /**
         * @param {?} resolver
         * @param {?} applicationRef
         * @param {?} injector
         * @param {?} doc
         */
        function ToptipsService(resolver, applicationRef, injector, doc) {
            var _this = _super.call(this) || this;
            _this.resolver = resolver;
            _this.applicationRef = applicationRef;
            _this.injector = injector;
            _this.doc = doc;
            return _this;
        }
        /**
         * 构建一个Toptips并显示
         *
         * @param {?} text 文本
         * @param {?} type 类型
         * @param {?=} time
         * @return {?}
         */
        ToptipsService.prototype.show = function (text, type, time) {
            var _this = this;
            if (time === void 0) { time = 2000; }
            /** @type {?} */
            var componentRef = this.build(ToptipsComponent);
            if (type) {
                componentRef.instance.type = type;
            }
            if (text) {
                componentRef.instance.text = text;
            }
            componentRef.instance.time = time;
            componentRef.instance.hide.subscribe(( /**
             * @return {?}
             */function () {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this.destroy(componentRef);
                }), 100);
            }));
            return componentRef.instance.onShow();
        };
        /**
         * 构建一个Warn Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.warn = function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'warn', time);
        };
        /**
         * 构建一个Info Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.info = function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'info', time);
        };
        /**
         * 构建一个Primary Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.primary = function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'primary', time);
        };
        /**
         * 构建一个Success Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.success = function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'primary', time);
        };
        /**
         * 构建一个Default Toptips并显示
         *
         * @param {?} text 文本
         * @param {?=} time 显示时长后自动关闭（单位：ms）
         * @return {?}
         */
        ToptipsService.prototype.default = function (text, time) {
            if (time === void 0) { time = 2000; }
            return this.show(text, 'default', time);
        };
        return ToptipsService;
    }(core.BaseService));
    ToptipsService.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */
    ToptipsService.ctorParameters = function () { return [
        { type: i0.ComponentFactoryResolver },
        { type: i0.ApplicationRef },
        { type: i0.Injector },
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ ToptipsService.ɵprov = i0.ɵɵdefineInjectable({ factory: function ToptipsService_Factory() { return new ToptipsService(i0.ɵɵinject(i0.ComponentFactoryResolver), i0.ɵɵinject(i0.ApplicationRef), i0.ɵɵinject(i0.INJECTOR), i0.ɵɵinject(i1.DOCUMENT)); }, token: ToptipsService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        ToptipsService.prototype.resolver;
        /**
         * @type {?}
         * @protected
         */
        ToptipsService.prototype.applicationRef;
        /**
         * @type {?}
         * @protected
         */
        ToptipsService.prototype.injector;
        /**
         * @type {?}
         * @protected
         */
        ToptipsService.prototype.doc;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: toptips.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToptipsModule = /** @class */ (function () {
        function ToptipsModule() {
        }
        return ToptipsModule;
    }());
    ToptipsModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [i1.CommonModule],
                    declarations: [ToptipsComponent],
                    exports: [ToptipsComponent],
                    entryComponents: [ToptipsComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-toptips.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ToptipsComponent = ToptipsComponent;
    exports.ToptipsModule = ToptipsModule;
    exports.ToptipsService = ToptipsService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-toptips.umd.js.map
