/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("@angular/core"),require("ngx-weui/core"),require("@angular/common")):"function"==typeof define&&define.amd?define("ngx-weui/toptips",["exports","@angular/core","ngx-weui/core","@angular/common"],e):e(((t=t||self)["ngx-weui"]=t["ngx-weui"]||{},t["ngx-weui"].toptips={}),t.ng.core,t["ngx-weui"].core,t.ng.common)}(this,(function(t,e,o,n){"use strict";
/*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */var r=function(t,e){return(r=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,e){t.__proto__=e}||function(t,e){for(var o in e)e.hasOwnProperty(o)&&(t[o]=e[o])})(t,e)};Object.create;Object.create;var i=function(){function t(t,o){this.el=t,this.uhcs=o,this._showd=!1,this.time=2e3,this.type="primary",this.hide=new e.EventEmitter}return t.prototype.setClassMap=function(){var t,e=this.uhcs,o=this.el,n=this.type;e.updateHostClass(o.nativeElement,((t={})["weui-toptips"]=!0,t["weui-toptips__"+n]=!0,t))},t.prototype.ngOnInit=function(){this.setClassMap()},t.prototype.ngOnChanges=function(){this.setClassMap()},t.prototype.onShow=function(){var t=this;return this.destroy(),this._showd=!0,this.timer=setTimeout((function(){return t.onHide()}),this.time),this},t.prototype.onHide=function(){this._showd=!1,this.hide.emit()},t.prototype.destroy=function(){this.timer&&(clearTimeout(this.timer),this.timer=null)},t.prototype.ngOnDestroy=function(){this.destroy()},t}();i.decorators=[{type:e.Component,args:[{selector:"weui-toptips",exportAs:"weuiToptips",template:" {{ text }}<ng-content></ng-content> ",host:{"[hidden]":"!_showd","[style.display]":'_showd ? "block" : "none"'},providers:[o.UpdateHostClassService],preserveWhitespaces:!1,changeDetection:e.ChangeDetectionStrategy.OnPush,encapsulation:e.ViewEncapsulation.None}]}],i.ctorParameters=function(){return[{type:e.ElementRef},{type:o.UpdateHostClassService}]},i.propDecorators={text:[{type:e.Input}],time:[{type:e.Input}],type:[{type:e.Input}],hide:[{type:e.Output}]},function(t,e,o,n){var r,i=arguments.length,s=i<3?e:null===n?n=Object.getOwnPropertyDescriptor(e,o):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(t,e,o,n);else for(var p=t.length-1;p>=0;p--)(r=t[p])&&(s=(i<3?r(s):i>3?r(e,o,s):r(e,o))||s);i>3&&s&&Object.defineProperty(e,o,s)}([o.InputNumber(),function(t,e){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(t,e)}("design:type",Number)],i.prototype,"time",void 0);var s=function(t){function e(e,o,n,r){var i=t.call(this)||this;return i.resolver=e,i.applicationRef=o,i.injector=n,i.doc=r,i}return function(t,e){function o(){this.constructor=t}r(t,e),t.prototype=null===e?Object.create(e):(o.prototype=e.prototype,new o)}(e,t),e.prototype.show=function(t,e,o){var n=this;void 0===o&&(o=2e3);var r=this.build(i);return e&&(r.instance.type=e),t&&(r.instance.text=t),r.instance.time=o,r.instance.hide.subscribe((function(){setTimeout((function(){n.destroy(r)}),100)})),r.instance.onShow()},e.prototype.warn=function(t,e){return void 0===e&&(e=2e3),this.show(t,"warn",e)},e.prototype.info=function(t,e){return void 0===e&&(e=2e3),this.show(t,"info",e)},e.prototype.primary=function(t,e){return void 0===e&&(e=2e3),this.show(t,"primary",e)},e.prototype.success=function(t,e){return void 0===e&&(e=2e3),this.show(t,"primary",e)},e.prototype.default=function(t,e){return void 0===e&&(e=2e3),this.show(t,"default",e)},e}(o.BaseService);s.decorators=[{type:e.Injectable,args:[{providedIn:"root"}]}],s.ctorParameters=function(){return[{type:e.ComponentFactoryResolver},{type:e.ApplicationRef},{type:e.Injector},{type:void 0,decorators:[{type:e.Inject,args:[n.DOCUMENT]}]}]},s.ɵprov=e.ɵɵdefineInjectable({factory:function(){return new s(e.ɵɵinject(e.ComponentFactoryResolver),e.ɵɵinject(e.ApplicationRef),e.ɵɵinject(e.INJECTOR),e.ɵɵinject(n.DOCUMENT))},token:s,providedIn:"root"});var p=function(){};p.decorators=[{type:e.NgModule,args:[{imports:[n.CommonModule],declarations:[i],exports:[i],entryComponents:[i]}]}],t.ToptipsComponent=i,t.ToptipsModule=p,t.ToptipsService=s,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=ngx-weui-toptips.umd.min.js.map