/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ngx-weui/core'), require('ngx-weui/cell'), require('ngx-weui/button'), require('ngx-weui/form'), require('ngx-weui/slider'), require('ngx-weui/uploader'), require('ngx-weui/actionsheet'), require('ngx-weui/dialog'), require('ngx-weui/loadmore'), require('ngx-weui/progress'), require('ngx-weui/gallery'), require('ngx-weui/picker'), require('ngx-weui/searchbar'), require('ngx-weui/tab'), require('ngx-weui/toast'), require('ngx-weui/toptips'), require('ngx-weui/popup'), require('ngx-weui/ptr'), require('ngx-weui/infiniteloader'), require('ngx-weui/sidebar'), require('ngx-weui/swiper'), require('ngx-weui/chart-g2'), require('ngx-weui/jweixin'), require('ngx-weui/accordion'), require('ngx-weui/mask'), require('ngx-weui/rating'), require('ngx-weui/stepper'), require('ngx-weui/pagination'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-weui', ['exports', 'ngx-weui/core', 'ngx-weui/cell', 'ngx-weui/button', 'ngx-weui/form', 'ngx-weui/slider', 'ngx-weui/uploader', 'ngx-weui/actionsheet', 'ngx-weui/dialog', 'ngx-weui/loadmore', 'ngx-weui/progress', 'ngx-weui/gallery', 'ngx-weui/picker', 'ngx-weui/searchbar', 'ngx-weui/tab', 'ngx-weui/toast', 'ngx-weui/toptips', 'ngx-weui/popup', 'ngx-weui/ptr', 'ngx-weui/infiniteloader', 'ngx-weui/sidebar', 'ngx-weui/swiper', 'ngx-weui/chart-g2', 'ngx-weui/jweixin', 'ngx-weui/accordion', 'ngx-weui/mask', 'ngx-weui/rating', 'ngx-weui/stepper', 'ngx-weui/pagination', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-weui'] = {}, global['ngx-weui'].core, global['ngx-weui'].cell, global['ngx-weui'].button, global['ngx-weui'].form, global['ngx-weui'].slider, global['ngx-weui'].uploader, global['ngx-weui'].actionsheet, global['ngx-weui'].dialog, global['ngx-weui'].loadmore, global['ngx-weui'].progress, global['ngx-weui'].gallery, global['ngx-weui'].picker, global['ngx-weui'].searchbar, global['ngx-weui'].tab, global['ngx-weui'].toast, global['ngx-weui'].toptips, global['ngx-weui'].popup, global['ngx-weui'].ptr, global['ngx-weui'].infiniteloader, global['ngx-weui'].sidebar, global['ngx-weui'].swiper, global['ngx-weui']['chart-g2'], global['ngx-weui'].jweixin, global['ngx-weui'].accordion, global['ngx-weui'].mask, global['ngx-weui'].rating, global['ngx-weui'].stepper, global['ngx-weui'].pagination, global.ng.core));
}(this, (function (exports, core, cell, button, form, slider, uploader, actionsheet, dialog, loadmore, progress, gallery, picker, searchbar, tab, toast, toptips, popup, ptr, infiniteloader, sidebar, swiper, chartG2, jweixin, accordion, mask, rating, stepper, pagination, core$1) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MODULES = [
        cell.CellModule,
        button.ButtonModule,
        form.FormModule,
        slider.SliderModule,
        uploader.UploaderModule,
        actionsheet.ActionSheetModule,
        dialog.DialogModule,
        loadmore.LoadmoreModule,
        progress.ProgressModule,
        gallery.GalleryModule,
        picker.PickerModule,
        searchbar.SearchBarModule,
        tab.TabModule,
        toast.ToastModule,
        toptips.ToptipsModule,
        popup.PopupModule,
        ptr.PTRModule,
        infiniteloader.InfiniteLoaderModule,
        sidebar.SidebarModule,
        swiper.SwiperModule,
        chartG2.ChartG2Module,
        jweixin.JWeiXinModule,
        accordion.AccordionModule,
        mask.MaskModule,
        rating.RatingModule,
        stepper.StepperModule,
        pagination.PaginationModule,
    ];
    /**
     * @deprecated Use secondary entry eg: `import { ButtonModule } from 'ngx-weui/button';`.
     */
    var WeUiModule = /** @class */ (function () {
        function WeUiModule() {
            core.warnDeprecation("The `WeUiModule` has been deprecated and will be removed in 10.0.0. Please use secondary entry instead.\ne.g. `import { ButtonModule } from 'ngx-weui/button';`");
        }
        return WeUiModule;
    }());
    WeUiModule.decorators = [
        { type: core$1.NgModule, args: [{ exports: MODULES },] }
    ];
    /** @nocollapse */
    WeUiModule.ctorParameters = function () { return []; };

    /**
     * @fileoverview added by tsickle
     * Generated from: version.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var VERSION = new core$1.Version('10.0.2');

    /**
     * @fileoverview added by tsickle
     * Generated from: public_api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    Object.defineProperty(exports, 'AddOnModule', {
        enumerable: true,
        get: function () {
            return core.AddOnModule;
        }
    });
    Object.defineProperty(exports, 'BaseService', {
        enumerable: true,
        get: function () {
            return core.BaseService;
        }
    });
    Object.defineProperty(exports, 'InputBoolean', {
        enumerable: true,
        get: function () {
            return core.InputBoolean;
        }
    });
    Object.defineProperty(exports, 'InputNumber', {
        enumerable: true,
        get: function () {
            return core.InputNumber;
        }
    });
    Object.defineProperty(exports, 'LoaderService', {
        enumerable: true,
        get: function () {
            return core.LoaderService;
        }
    });
    Object.defineProperty(exports, 'PREFIX', {
        enumerable: true,
        get: function () {
            return core.PREFIX;
        }
    });
    Object.defineProperty(exports, 'StringTemplateOutletDirective', {
        enumerable: true,
        get: function () {
            return core.StringTemplateOutletDirective;
        }
    });
    Object.defineProperty(exports, 'UpdateHostClassService', {
        enumerable: true,
        get: function () {
            return core.UpdateHostClassService;
        }
    });
    Object.defineProperty(exports, 'add', {
        enumerable: true,
        get: function () {
            return core.add;
        }
    });
    Object.defineProperty(exports, 'deprecation10', {
        enumerable: true,
        get: function () {
            return core.deprecation10;
        }
    });
    Object.defineProperty(exports, 'findParent', {
        enumerable: true,
        get: function () {
            return core.findParent;
        }
    });
    Object.defineProperty(exports, 'genImageUrl', {
        enumerable: true,
        get: function () {
            return core.genImageUrl;
        }
    });
    Object.defineProperty(exports, 'isAndroid', {
        enumerable: true,
        get: function () {
            return core.isAndroid;
        }
    });
    Object.defineProperty(exports, 'isEmpty', {
        enumerable: true,
        get: function () {
            return core.isEmpty;
        }
    });
    Object.defineProperty(exports, 'isIOS', {
        enumerable: true,
        get: function () {
            return core.isIOS;
        }
    });
    Object.defineProperty(exports, 'isImage', {
        enumerable: true,
        get: function () {
            return core.isImage;
        }
    });
    Object.defineProperty(exports, 'isPlatform', {
        enumerable: true,
        get: function () {
            return core.isPlatform;
        }
    });
    Object.defineProperty(exports, 'isSSR', {
        enumerable: true,
        get: function () {
            return core.isSSR;
        }
    });
    Object.defineProperty(exports, 'log', {
        enumerable: true,
        get: function () {
            return core.log;
        }
    });
    Object.defineProperty(exports, 'remove', {
        enumerable: true,
        get: function () {
            return core.remove;
        }
    });
    Object.defineProperty(exports, 'toBoolean', {
        enumerable: true,
        get: function () {
            return core.toBoolean;
        }
    });
    Object.defineProperty(exports, 'toNumber', {
        enumerable: true,
        get: function () {
            return core.toNumber;
        }
    });
    Object.defineProperty(exports, 'warn', {
        enumerable: true,
        get: function () {
            return core.warn;
        }
    });
    Object.defineProperty(exports, 'warnDeprecation', {
        enumerable: true,
        get: function () {
            return core.warnDeprecation;
        }
    });
    Object.defineProperty(exports, 'CellModule', {
        enumerable: true,
        get: function () {
            return cell.CellModule;
        }
    });
    Object.defineProperty(exports, 'SwipeDirective', {
        enumerable: true,
        get: function () {
            return cell.SwipeDirective;
        }
    });
    Object.defineProperty(exports, 'ButtonComponent', {
        enumerable: true,
        get: function () {
            return button.ButtonComponent;
        }
    });
    Object.defineProperty(exports, 'ButtonConfig', {
        enumerable: true,
        get: function () {
            return button.ButtonConfig;
        }
    });
    Object.defineProperty(exports, 'ButtonIconComponent', {
        enumerable: true,
        get: function () {
            return button.ButtonIconComponent;
        }
    });
    Object.defineProperty(exports, 'ButtonModule', {
        enumerable: true,
        get: function () {
            return button.ButtonModule;
        }
    });
    Object.defineProperty(exports, 'ChecklistDirective', {
        enumerable: true,
        get: function () {
            return form.ChecklistDirective;
        }
    });
    Object.defineProperty(exports, 'FormModule', {
        enumerable: true,
        get: function () {
            return form.FormModule;
        }
    });
    Object.defineProperty(exports, 'InputDirective', {
        enumerable: true,
        get: function () {
            return form.InputDirective;
        }
    });
    Object.defineProperty(exports, 'TextareaDirective', {
        enumerable: true,
        get: function () {
            return form.TextareaDirective;
        }
    });
    Object.defineProperty(exports, 'VCodeDirective', {
        enumerable: true,
        get: function () {
            return form.VCodeDirective;
        }
    });
    Object.defineProperty(exports, 'SliderDirective', {
        enumerable: true,
        get: function () {
            return slider.SliderDirective;
        }
    });
    Object.defineProperty(exports, 'SliderModule', {
        enumerable: true,
        get: function () {
            return slider.SliderModule;
        }
    });
    Object.defineProperty(exports, 'FileItem', {
        enumerable: true,
        get: function () {
            return uploader.FileItem;
        }
    });
    Object.defineProperty(exports, 'FileLikeObject', {
        enumerable: true,
        get: function () {
            return uploader.FileLikeObject;
        }
    });
    Object.defineProperty(exports, 'FileThumbDirective', {
        enumerable: true,
        get: function () {
            return uploader.FileThumbDirective;
        }
    });
    Object.defineProperty(exports, 'FileType', {
        enumerable: true,
        get: function () {
            return uploader.FileType;
        }
    });
    Object.defineProperty(exports, 'Uploader', {
        enumerable: true,
        get: function () {
            return uploader.Uploader;
        }
    });
    Object.defineProperty(exports, 'UploaderConfig', {
        enumerable: true,
        get: function () {
            return uploader.UploaderConfig;
        }
    });
    Object.defineProperty(exports, 'UploaderFileDirective', {
        enumerable: true,
        get: function () {
            return uploader.UploaderFileDirective;
        }
    });
    Object.defineProperty(exports, 'UploaderModule', {
        enumerable: true,
        get: function () {
            return uploader.UploaderModule;
        }
    });
    Object.defineProperty(exports, 'ActionSheetComponent', {
        enumerable: true,
        get: function () {
            return actionsheet.ActionSheetComponent;
        }
    });
    Object.defineProperty(exports, 'ActionSheetConfig', {
        enumerable: true,
        get: function () {
            return actionsheet.ActionSheetConfig;
        }
    });
    Object.defineProperty(exports, 'ActionSheetModule', {
        enumerable: true,
        get: function () {
            return actionsheet.ActionSheetModule;
        }
    });
    Object.defineProperty(exports, 'ActionSheetService', {
        enumerable: true,
        get: function () {
            return actionsheet.ActionSheetService;
        }
    });
    Object.defineProperty(exports, 'DialogComponent', {
        enumerable: true,
        get: function () {
            return dialog.DialogComponent;
        }
    });
    Object.defineProperty(exports, 'DialogConfig', {
        enumerable: true,
        get: function () {
            return dialog.DialogConfig;
        }
    });
    Object.defineProperty(exports, 'DialogModule', {
        enumerable: true,
        get: function () {
            return dialog.DialogModule;
        }
    });
    Object.defineProperty(exports, 'DialogService', {
        enumerable: true,
        get: function () {
            return dialog.DialogService;
        }
    });
    Object.defineProperty(exports, 'LoadmoreComponent', {
        enumerable: true,
        get: function () {
            return loadmore.LoadmoreComponent;
        }
    });
    Object.defineProperty(exports, 'LoadmoreConfig', {
        enumerable: true,
        get: function () {
            return loadmore.LoadmoreConfig;
        }
    });
    Object.defineProperty(exports, 'LoadmoreModule', {
        enumerable: true,
        get: function () {
            return loadmore.LoadmoreModule;
        }
    });
    Object.defineProperty(exports, 'ProgressComponent', {
        enumerable: true,
        get: function () {
            return progress.ProgressComponent;
        }
    });
    Object.defineProperty(exports, 'ProgressModule', {
        enumerable: true,
        get: function () {
            return progress.ProgressModule;
        }
    });
    Object.defineProperty(exports, 'GalleryComponent', {
        enumerable: true,
        get: function () {
            return gallery.GalleryComponent;
        }
    });
    Object.defineProperty(exports, 'GalleryModule', {
        enumerable: true,
        get: function () {
            return gallery.GalleryModule;
        }
    });
    Object.defineProperty(exports, 'CityPickerComponent', {
        enumerable: true,
        get: function () {
            return picker.CityPickerComponent;
        }
    });
    Object.defineProperty(exports, 'DatePickerComponent', {
        enumerable: true,
        get: function () {
            return picker.DatePickerComponent;
        }
    });
    Object.defineProperty(exports, 'PickerComponent', {
        enumerable: true,
        get: function () {
            return picker.PickerComponent;
        }
    });
    Object.defineProperty(exports, 'PickerConfig', {
        enumerable: true,
        get: function () {
            return picker.PickerConfig;
        }
    });
    Object.defineProperty(exports, 'PickerGroupComponent', {
        enumerable: true,
        get: function () {
            return picker.PickerGroupComponent;
        }
    });
    Object.defineProperty(exports, 'PickerModule', {
        enumerable: true,
        get: function () {
            return picker.PickerModule;
        }
    });
    Object.defineProperty(exports, 'PickerService', {
        enumerable: true,
        get: function () {
            return picker.PickerService;
        }
    });
    Object.defineProperty(exports, 'ɵa', {
        enumerable: true,
        get: function () {
            return picker.ɵa;
        }
    });
    Object.defineProperty(exports, 'SearchBarComponent', {
        enumerable: true,
        get: function () {
            return searchbar.SearchBarComponent;
        }
    });
    Object.defineProperty(exports, 'SearchBarConfig', {
        enumerable: true,
        get: function () {
            return searchbar.SearchBarConfig;
        }
    });
    Object.defineProperty(exports, 'SearchBarModule', {
        enumerable: true,
        get: function () {
            return searchbar.SearchBarModule;
        }
    });
    Object.defineProperty(exports, 'BarComponent', {
        enumerable: true,
        get: function () {
            return tab.BarComponent;
        }
    });
    Object.defineProperty(exports, 'NavbarComponent', {
        enumerable: true,
        get: function () {
            return tab.NavbarComponent;
        }
    });
    Object.defineProperty(exports, 'TabDirective', {
        enumerable: true,
        get: function () {
            return tab.TabDirective;
        }
    });
    Object.defineProperty(exports, 'TabModule', {
        enumerable: true,
        get: function () {
            return tab.TabModule;
        }
    });
    Object.defineProperty(exports, 'TabbarComponent', {
        enumerable: true,
        get: function () {
            return tab.TabbarComponent;
        }
    });
    Object.defineProperty(exports, 'ToastComponent', {
        enumerable: true,
        get: function () {
            return toast.ToastComponent;
        }
    });
    Object.defineProperty(exports, 'ToastConfig', {
        enumerable: true,
        get: function () {
            return toast.ToastConfig;
        }
    });
    Object.defineProperty(exports, 'ToastModule', {
        enumerable: true,
        get: function () {
            return toast.ToastModule;
        }
    });
    Object.defineProperty(exports, 'ToastService', {
        enumerable: true,
        get: function () {
            return toast.ToastService;
        }
    });
    Object.defineProperty(exports, 'ToptipsComponent', {
        enumerable: true,
        get: function () {
            return toptips.ToptipsComponent;
        }
    });
    Object.defineProperty(exports, 'ToptipsModule', {
        enumerable: true,
        get: function () {
            return toptips.ToptipsModule;
        }
    });
    Object.defineProperty(exports, 'ToptipsService', {
        enumerable: true,
        get: function () {
            return toptips.ToptipsService;
        }
    });
    Object.defineProperty(exports, 'PopupComponent', {
        enumerable: true,
        get: function () {
            return popup.PopupComponent;
        }
    });
    Object.defineProperty(exports, 'PopupConfig', {
        enumerable: true,
        get: function () {
            return popup.PopupConfig;
        }
    });
    Object.defineProperty(exports, 'PopupModule', {
        enumerable: true,
        get: function () {
            return popup.PopupModule;
        }
    });
    Object.defineProperty(exports, 'PTRComponent', {
        enumerable: true,
        get: function () {
            return ptr.PTRComponent;
        }
    });
    Object.defineProperty(exports, 'PTRConfig', {
        enumerable: true,
        get: function () {
            return ptr.PTRConfig;
        }
    });
    Object.defineProperty(exports, 'PTRModule', {
        enumerable: true,
        get: function () {
            return ptr.PTRModule;
        }
    });
    Object.defineProperty(exports, 'InfiniteLoaderComponent', {
        enumerable: true,
        get: function () {
            return infiniteloader.InfiniteLoaderComponent;
        }
    });
    Object.defineProperty(exports, 'InfiniteLoaderConfig', {
        enumerable: true,
        get: function () {
            return infiniteloader.InfiniteLoaderConfig;
        }
    });
    Object.defineProperty(exports, 'InfiniteLoaderModule', {
        enumerable: true,
        get: function () {
            return infiniteloader.InfiniteLoaderModule;
        }
    });
    Object.defineProperty(exports, 'CloseSidebarDirective', {
        enumerable: true,
        get: function () {
            return sidebar.CloseSidebarDirective;
        }
    });
    Object.defineProperty(exports, 'SidebarComponent', {
        enumerable: true,
        get: function () {
            return sidebar.SidebarComponent;
        }
    });
    Object.defineProperty(exports, 'SidebarConfig', {
        enumerable: true,
        get: function () {
            return sidebar.SidebarConfig;
        }
    });
    Object.defineProperty(exports, 'SidebarContainerComponent', {
        enumerable: true,
        get: function () {
            return sidebar.SidebarContainerComponent;
        }
    });
    Object.defineProperty(exports, 'SidebarModule', {
        enumerable: true,
        get: function () {
            return sidebar.SidebarModule;
        }
    });
    Object.defineProperty(exports, 'SidebarService', {
        enumerable: true,
        get: function () {
            return sidebar.SidebarService;
        }
    });
    Object.defineProperty(exports, 'SwiperComponent', {
        enumerable: true,
        get: function () {
            return swiper.SwiperComponent;
        }
    });
    Object.defineProperty(exports, 'SwiperConfig', {
        enumerable: true,
        get: function () {
            return swiper.SwiperConfig;
        }
    });
    Object.defineProperty(exports, 'SwiperModule', {
        enumerable: true,
        get: function () {
            return swiper.SwiperModule;
        }
    });
    Object.defineProperty(exports, 'ChartG2Directive', {
        enumerable: true,
        get: function () {
            return chartG2.ChartG2Directive;
        }
    });
    Object.defineProperty(exports, 'ChartG2Module', {
        enumerable: true,
        get: function () {
            return chartG2.ChartG2Module;
        }
    });
    Object.defineProperty(exports, 'JWeiXinModule', {
        enumerable: true,
        get: function () {
            return jweixin.JWeiXinModule;
        }
    });
    Object.defineProperty(exports, 'JWeiXinService', {
        enumerable: true,
        get: function () {
            return jweixin.JWeiXinService;
        }
    });
    Object.defineProperty(exports, 'AccordionComponent', {
        enumerable: true,
        get: function () {
            return accordion.AccordionComponent;
        }
    });
    Object.defineProperty(exports, 'AccordionConfig', {
        enumerable: true,
        get: function () {
            return accordion.AccordionConfig;
        }
    });
    Object.defineProperty(exports, 'AccordionModule', {
        enumerable: true,
        get: function () {
            return accordion.AccordionModule;
        }
    });
    Object.defineProperty(exports, 'AccordionPanelComponent', {
        enumerable: true,
        get: function () {
            return accordion.AccordionPanelComponent;
        }
    });
    Object.defineProperty(exports, 'MaskComponent', {
        enumerable: true,
        get: function () {
            return mask.MaskComponent;
        }
    });
    Object.defineProperty(exports, 'MaskModule', {
        enumerable: true,
        get: function () {
            return mask.MaskModule;
        }
    });
    Object.defineProperty(exports, 'RatingComponent', {
        enumerable: true,
        get: function () {
            return rating.RatingComponent;
        }
    });
    Object.defineProperty(exports, 'RatingConfig', {
        enumerable: true,
        get: function () {
            return rating.RatingConfig;
        }
    });
    Object.defineProperty(exports, 'RatingModule', {
        enumerable: true,
        get: function () {
            return rating.RatingModule;
        }
    });
    Object.defineProperty(exports, 'StepperComponent', {
        enumerable: true,
        get: function () {
            return stepper.StepperComponent;
        }
    });
    Object.defineProperty(exports, 'StepperModule', {
        enumerable: true,
        get: function () {
            return stepper.StepperModule;
        }
    });
    Object.defineProperty(exports, 'PaginationComponent', {
        enumerable: true,
        get: function () {
            return pagination.PaginationComponent;
        }
    });
    Object.defineProperty(exports, 'PaginationConfig', {
        enumerable: true,
        get: function () {
            return pagination.PaginationConfig;
        }
    });
    Object.defineProperty(exports, 'PaginationModule', {
        enumerable: true,
        get: function () {
            return pagination.PaginationModule;
        }
    });
    exports.VERSION = VERSION;
    exports.WeUiModule = WeUiModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui.umd.js.map
