import { ElementRef, OnChanges, OnInit } from '@angular/core';
import { ButtonType, UpdateHostClassService } from 'ngx-weui/core';
import { ButtonConfig } from './button.config';
export declare class ButtonComponent implements OnInit, OnChanges {
    private el;
    private uhcs;
    /**
     * 操作场景：primary、default、warn，默认：`primary`
     */
    type: ButtonType;
    /**
     * 是否加载状态
     */
    loading: boolean;
    /**
     * 是否小号
     */
    mini: boolean;
    /**
     * 行按钮
     */
    cell: boolean;
    /**
     * Block 按钮
     */
    block: boolean;
    /**
     * 禁用状态
     */
    disabled: boolean;
    constructor(_config: ButtonConfig, el: ElementRef, uhcs: UpdateHostClassService);
    private setClassMap;
    ngOnInit(): void;
    ngOnChanges(): void;
}
