import { ElementRef, NgZone, OnChanges, OnDestroy, OnInit, SimpleChange, SimpleChanges } from '@angular/core';
import { NwSafeAny } from 'ngx-weui/core';
export declare class ChartG2Directive implements OnInit, OnDestroy, OnChanges {
    private el;
    private zone;
    _chart: NwSafeAny;
    /**
     * 画布内部的边距，可以是数组 [top, right, bottom, left] 也可以是一个数字。
     */
    margin: number[] | number;
    private initFlag;
    /**
     * chart实例对象
     */
    get chart(): NwSafeAny;
    /**
     * GM对象
     */
    get GM(): NwSafeAny;
    constructor(el: ElementRef, zone: NgZone);
    ngOnInit(): void;
    private buildChart;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    ngOnDestroy(): void;
}
