/**
 * 是否服务端渲染
 */
export declare const isSSR: boolean;
export declare function isPlatform(type: 'android' | 'ios'): boolean;
/**
 * 检查是否安卓系统
 */
export declare function isAndroid(): boolean;
/**
 * 检查是否IOS系统
 */
export declare function isIOS(): boolean;
/**
 * 检查File是否为图像文件
 */
export declare function isImage(file: File): boolean;
/**
 * 生成可预览的图像地址
 */
export declare function genImageUrl(file: File): string;
