import { ApplicationRef, ComponentFactoryResolver, Injector } from '@angular/core';
import { BaseService } from 'ngx-weui/core';
import { Observable } from 'rxjs';
import { DialogConfig } from './dialog.config';
export declare class DialogService extends BaseService {
    protected readonly resolver: ComponentFactoryResolver;
    protected readonly applicationRef: ApplicationRef;
    protected readonly injector: Injector;
    protected readonly doc: any;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, doc: any);
    /**
     * 创建一个对话框并显示
     *
     * @param data 对话框配置项
     * @returns 可订阅来获取结果
     */
    show(data: DialogConfig): Observable<any>;
}
