import { warnDeprecation } from 'ngx-weui/core';
export { AddOnModule, BaseService, InputBoolean, InputNumber, LoaderService, PREFIX, StringTemplateOutletDirective, UpdateHostClassService, add, deprecation10, findParent, genImageUrl, isAndroid, isEmpty, isIOS, isImage, isPlatform, isSSR, log, remove, toBoolean, toNumber, warn, warnDeprecation } from 'ngx-weui/core';
import { CellModule } from 'ngx-weui/cell';
export { CellModule, SwipeDirective } from 'ngx-weui/cell';
import { ButtonModule } from 'ngx-weui/button';
export { ButtonComponent, ButtonConfig, ButtonIconComponent, ButtonModule } from 'ngx-weui/button';
import { FormModule } from 'ngx-weui/form';
export { ChecklistDirective, FormModule, InputDirective, TextareaDirective, VCodeDirective } from 'ngx-weui/form';
import { SliderModule } from 'ngx-weui/slider';
export { SliderDirective, SliderModule } from 'ngx-weui/slider';
import { UploaderModule } from 'ngx-weui/uploader';
export { FileItem, FileLikeObject, FileThumbDirective, FileType, Uploader, UploaderConfig, UploaderFileDirective, UploaderModule } from 'ngx-weui/uploader';
import { ActionSheetModule } from 'ngx-weui/actionsheet';
export { ActionSheetComponent, ActionSheetConfig, ActionSheetModule, ActionSheetService } from 'ngx-weui/actionsheet';
import { DialogModule } from 'ngx-weui/dialog';
export { DialogComponent, DialogConfig, DialogModule, DialogService } from 'ngx-weui/dialog';
import { LoadmoreModule } from 'ngx-weui/loadmore';
export { LoadmoreComponent, LoadmoreConfig, LoadmoreModule } from 'ngx-weui/loadmore';
import { ProgressModule } from 'ngx-weui/progress';
export { ProgressComponent, ProgressModule } from 'ngx-weui/progress';
import { GalleryModule } from 'ngx-weui/gallery';
export { GalleryComponent, GalleryModule } from 'ngx-weui/gallery';
import { PickerModule } from 'ngx-weui/picker';
export { CityPickerComponent, DatePickerComponent, PickerComponent, PickerConfig, PickerGroupComponent, PickerModule, PickerService, ɵa } from 'ngx-weui/picker';
import { SearchBarModule } from 'ngx-weui/searchbar';
export { SearchBarComponent, SearchBarConfig, SearchBarModule } from 'ngx-weui/searchbar';
import { TabModule } from 'ngx-weui/tab';
export { BarComponent, NavbarComponent, TabDirective, TabModule, TabbarComponent } from 'ngx-weui/tab';
import { ToastModule } from 'ngx-weui/toast';
export { ToastComponent, ToastConfig, ToastModule, ToastService } from 'ngx-weui/toast';
import { ToptipsModule } from 'ngx-weui/toptips';
export { ToptipsComponent, ToptipsModule, ToptipsService } from 'ngx-weui/toptips';
import { PopupModule } from 'ngx-weui/popup';
export { PopupComponent, PopupConfig, PopupModule } from 'ngx-weui/popup';
import { PTRModule } from 'ngx-weui/ptr';
export { PTRComponent, PTRConfig, PTRModule } from 'ngx-weui/ptr';
import { InfiniteLoaderModule } from 'ngx-weui/infiniteloader';
export { InfiniteLoaderComponent, InfiniteLoaderConfig, InfiniteLoaderModule } from 'ngx-weui/infiniteloader';
import { SidebarModule } from 'ngx-weui/sidebar';
export { CloseSidebarDirective, SidebarComponent, SidebarConfig, SidebarContainerComponent, SidebarModule, SidebarService } from 'ngx-weui/sidebar';
import { SwiperModule } from 'ngx-weui/swiper';
export { SwiperComponent, SwiperConfig, SwiperModule } from 'ngx-weui/swiper';
import { ChartG2Module } from 'ngx-weui/chart-g2';
export { ChartG2Directive, ChartG2Module } from 'ngx-weui/chart-g2';
import { JWeiXinModule } from 'ngx-weui/jweixin';
export { JWeiXinModule, JWeiXinService } from 'ngx-weui/jweixin';
import { AccordionModule } from 'ngx-weui/accordion';
export { AccordionComponent, AccordionConfig, AccordionModule, AccordionPanelComponent } from 'ngx-weui/accordion';
import { MaskModule } from 'ngx-weui/mask';
export { MaskComponent, MaskModule } from 'ngx-weui/mask';
import { RatingModule } from 'ngx-weui/rating';
export { RatingComponent, RatingConfig, RatingModule } from 'ngx-weui/rating';
import { StepperModule } from 'ngx-weui/stepper';
export { StepperComponent, StepperModule } from 'ngx-weui/stepper';
import { PaginationModule } from 'ngx-weui/pagination';
export { PaginationComponent, PaginationConfig, PaginationModule } from 'ngx-weui/pagination';
import { NgModule, Version } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const MODULES = [
    CellModule,
    ButtonModule,
    FormModule,
    SliderModule,
    UploaderModule,
    ActionSheetModule,
    DialogModule,
    LoadmoreModule,
    ProgressModule,
    GalleryModule,
    PickerModule,
    SearchBarModule,
    TabModule,
    ToastModule,
    ToptipsModule,
    PopupModule,
    PTRModule,
    InfiniteLoaderModule,
    SidebarModule,
    SwiperModule,
    ChartG2Module,
    JWeiXinModule,
    AccordionModule,
    MaskModule,
    RatingModule,
    StepperModule,
    PaginationModule,
];
/**
 * @deprecated Use secondary entry eg: `import { ButtonModule } from 'ngx-weui/button';`.
 */
class WeUiModule {
    constructor() {
        warnDeprecation("The `WeUiModule` has been deprecated and will be removed in 10.0.0. Please use secondary entry instead.\ne.g. `import { ButtonModule } from 'ngx-weui/button';`");
    }
}
WeUiModule.decorators = [
    { type: NgModule, args: [{ exports: MODULES },] }
];
/** @nocollapse */
WeUiModule.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: version.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const VERSION = new Version('10.0.2');

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-weui.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { VERSION, WeUiModule };
//# sourceMappingURL=ngx-weui.js.map
