import { ElementRef, OnChanges, OnInit, SimpleChange, SimpleChanges } from '@angular/core';
/**
 * 文本域字数统计
 */
export declare class TextareaDirective implements OnInit, OnChanges {
    private el;
    private fillStr;
    private _cn;
    /**
     * 最大长度，0表示不受限
     */
    maxlength: number;
    private _value;
    private _count;
    /**
     * 中文部分应该算多少个字符，使用 `/[^\x00-\xff]/g` 正则表达式统计中文部分（默认：1个字符）
     */
    set cn(value: number);
    constructor(el: ElementRef<HTMLElement>);
    ngOnInit(): void;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    private init;
    _onChange(value: string): void;
}
