import { LoadmoreConfig } from './loadmore.config';
export declare type LoadmoreType = 'loading' | 'line' | 'dot';
export declare class LoadmoreComponent {
    /**
     * 类型，默认：`loading`
     */
    type: LoadmoreType;
    /**
     * 当 `type==='loading'` 时显示的文本，默认：`正在加载`
     */
    loadingText: string;
    /**
     * 当 `type==='line'` 时显示的文本，默认：`暂无数据`
     */
    lineText: string;
    constructor(DEF: LoadmoreConfig);
}
