import { EventEmitter, OnChanges, SimpleChange, SimpleChanges } from '@angular/core';
import { NwSafeAny } from 'ngx-weui/core';
import { PickerData, PickerGroupChange } from './picker.types';
export declare class PickerGroupComponent implements OnChanges {
    private doc;
    /** 数据列表 */
    items: PickerData[];
    /** 当前默认位置 */
    defaultIndex: number;
    /** 多列中的位置 */
    groupIndex: number;
    /** 变更回调 */
    readonly change: EventEmitter<PickerGroupChange>;
    private defaults;
    private startTime;
    private startY;
    private endY;
    private speed;
    _animating: boolean;
    _distance: number;
    constructor(doc: NwSafeAny);
    private _getWin;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    onTouchStart(e: TouchEvent): void;
    onTouchMove(e: TouchEvent): void;
    onTouchEnd(event: TouchEvent): void;
    private stop;
    private onChange;
    private _getMax;
    private _getMin;
}
