import { AfterViewInit, ElementRef, NgZone, OnChanges, OnDestroy, OnInit, SimpleChange, SimpleChanges } from '@angular/core';
import { SwiperConfig } from './swiper.config';
export declare class SwiperComponent implements AfterViewInit, OnChanges, OnInit, OnDestroy {
    private el;
    private zone;
    private DEF;
    private containerEl;
    /**
     * 等同于swiper[参数项](http://idangero.us/swiper/api/)
     */
    options: any;
    /**
     * Swiper 实例对象，可以通过 `@ViewChild` 访问到它
     */
    swiper: any;
    constructor(el: ElementRef, zone: NgZone, DEF: SwiperConfig);
    private initOptions;
    private init;
    private destroy;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    ngOnDestroy(): void;
}
