import { ChangeDetectorRef, OnDestroy } from '@angular/core';
import { TabDirective } from './tab.directive';
export declare class BarComponent implements OnDestroy {
    private cdr;
    tabs: TabDirective[];
    protected isDestroyed: boolean;
    constructor(cdr: ChangeDetectorRef);
    add(tab: TabDirective): void;
    remove(tab: TabDirective): void;
    setActive(tab: TabDirective): void;
    detectChanges(): void;
    protected getClosestTabIndex(index: number): number;
    protected hasAvailableTabs(index: number): boolean;
    ngOnDestroy(): void;
}
