import { EventEmitter, OnDestroy } from '@angular/core';
import { ToastConfig } from './toast.config';
export declare class ToastComponent implements OnDestroy {
    private DEF;
    /**
     * 文本
     */
    text: string;
    /**
     * icon图标Class名
     */
    icon: string;
    /**
     * 显示时长后自动关闭（单位：ms），0 表示永久，默认：`2000`
     */
    time: number;
    /**
     * 隐藏后回调
     */
    readonly hide: EventEmitter<any>;
    _showd: boolean;
    private timer;
    /**
     * 类型
     */
    set type(_t: 'success' | 'loading');
    constructor(DEF: ToastConfig);
    onShow(): this;
    onHide(): void;
    ngOnDestroy(): void;
}
