/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/button', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].button = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, i0, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: button.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonConfig = /** @class */ (function () {
        function ButtonConfig() {
            /**
             * 操作场景：primary、default、warn
             */
            this.type = 'primary';
            /**
             * disabled状态，默认：`false`
             */
            this.disabled = false;
            /**
             * 是否加载状态，默认：`false`
             */
            this.loading = false;
            /**
             * 镂空按钮，默认：`false`
             */
            this.plain = false;
            /**
             * 是否小号，默认：`false`
             */
            this.mini = false;
        }
        return ButtonConfig;
    }());
    ButtonConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ ButtonConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function ButtonConfig_Factory() { return new ButtonConfig(); }, token: ButtonConfig, providedIn: "root" });
    if (false) {
        /**
         * 操作场景：primary、default、warn
         * @type {?}
         */
        ButtonConfig.prototype.type;
        /**
         * disabled状态，默认：`false`
         * @type {?}
         */
        ButtonConfig.prototype.disabled;
        /**
         * 是否加载状态，默认：`false`
         * @type {?}
         */
        ButtonConfig.prototype.loading;
        /**
         * 镂空按钮，默认：`false`
         * @type {?}
         */
        ButtonConfig.prototype.plain;
        /**
         * 是否小号，默认：`false`
         * @type {?}
         */
        ButtonConfig.prototype.mini;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: button.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonComponent = /** @class */ (function () {
        /**
         * @param {?} _config
         * @param {?} el
         * @param {?} uhcs
         */
        function ButtonComponent(_config, el, uhcs) {
            this.el = el;
            this.uhcs = uhcs;
            /**
             * 操作场景：primary、default、warn，默认：`primary`
             */
            this.type = 'primary';
            /**
             * 是否加载状态
             */
            this.loading = false;
            /**
             * 是否小号
             */
            this.mini = false;
            /**
             * 行按钮
             */
            this.cell = false;
            /**
             * Block 按钮
             */
            this.block = false;
            /**
             * 禁用状态
             */
            this.disabled = false;
            Object.assign(this, _config);
        }
        /**
         * @private
         * @return {?}
         */
        ButtonComponent.prototype.setClassMap = function () {
            var _a;
            /** @type {?} */
            var prefixCls = 'weui-btn';
            var _b = this, uhcs = _b.uhcs, el = _b.el, type = _b.type, cell = _b.cell, disabled = _b.disabled, block = _b.block, mini = _b.mini, loading = _b.loading;
            /** @type {?} */
            var median = cell ? 'cell' : '';
            uhcs.updateHostClass(el.nativeElement, (_a = {},
                _a["" + prefixCls] = !cell,
                _a[prefixCls + "_cell"] = cell,
                _a[prefixCls + "_disabled"] = disabled,
                _a[prefixCls + "_block"] = block,
                _a[prefixCls + "_mini"] = mini,
                _a[prefixCls + "_" + median + "-" + type] = median,
                _a[prefixCls + "_" + type] = !median,
                _a[prefixCls + "_loading"] = loading,
                _a));
        };
        /**
         * @return {?}
         */
        ButtonComponent.prototype.ngOnInit = function () {
            this.setClassMap();
        };
        /**
         * @return {?}
         */
        ButtonComponent.prototype.ngOnChanges = function () {
            this.setClassMap();
        };
        return ButtonComponent;
    }());
    ButtonComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-button, [weui-button]',
                    exportAs: 'weuiButton',
                    host: {
                        '[attr.disabled]': 'disabled ? "disabled" : null',
                    },
                    template: '<i class="weui-loading" *ngIf="loading"></i><ng-content></ng-content>',
                    providers: [core.UpdateHostClassService],
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    ButtonComponent.ctorParameters = function () { return [
        { type: ButtonConfig },
        { type: i0.ElementRef },
        { type: core.UpdateHostClassService }
    ]; };
    ButtonComponent.propDecorators = {
        type: [{ type: i0.Input, args: ['weui-type',] }],
        loading: [{ type: i0.Input, args: ['weui-loading',] }],
        mini: [{ type: i0.Input, args: ['weui-mini',] }],
        cell: [{ type: i0.Input, args: ['weui-cell',] }],
        block: [{ type: i0.Input, args: ['weui-block',] }],
        disabled: [{ type: i0.Input }]
    };
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], ButtonComponent.prototype, "loading", void 0);
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], ButtonComponent.prototype, "mini", void 0);
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], ButtonComponent.prototype, "cell", void 0);
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], ButtonComponent.prototype, "block", void 0);
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], ButtonComponent.prototype, "disabled", void 0);
    if (false) {
        /**
         * 操作场景：primary、default、warn，默认：`primary`
         * @type {?}
         */
        ButtonComponent.prototype.type;
        /**
         * 是否加载状态
         * @type {?}
         */
        ButtonComponent.prototype.loading;
        /**
         * 是否小号
         * @type {?}
         */
        ButtonComponent.prototype.mini;
        /**
         * 行按钮
         * @type {?}
         */
        ButtonComponent.prototype.cell;
        /**
         * Block 按钮
         * @type {?}
         */
        ButtonComponent.prototype.block;
        /**
         * 禁用状态
         * @type {?}
         */
        ButtonComponent.prototype.disabled;
        /**
         * @type {?}
         * @private
         */
        ButtonComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        ButtonComponent.prototype.uhcs;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: button-icon.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonIconComponent = /** @class */ (function () {
        function ButtonIconComponent() {
        }
        return ButtonIconComponent;
    }());
    ButtonIconComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-button-icon, [weui-button-icon]',
                    exportAs: 'weuiButtonIcon',
                    host: {
                        '[class.weui-btn_cell__icon]': 'true',
                    },
                    template: '<ng-content></ng-content>',
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: button.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ButtonModule = /** @class */ (function () {
        function ButtonModule() {
        }
        return ButtonModule;
    }());
    ButtonModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [ButtonComponent, ButtonIconComponent],
                    exports: [ButtonComponent, ButtonIconComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-button.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.ButtonComponent = ButtonComponent;
    exports.ButtonConfig = ButtonConfig;
    exports.ButtonIconComponent = ButtonIconComponent;
    exports.ButtonModule = ButtonModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-button.umd.js.map
