/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/gallery', ['exports', '@angular/animations', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].gallery = {}), global.ng.animations, global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, animations, core, core$1, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: gallery.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 数据对象
     * @record
     */
    function GalleryItem() { }
    if (false) {
        /**
         * 远程网址
         * @type {?|undefined}
         */
        GalleryItem.prototype.url;
        /**
         * JavaScript File 对象
         * @type {?|undefined}
         */
        GalleryItem.prototype.file;
        /**
         * 文件标题
         * @type {?|undefined}
         */
        GalleryItem.prototype.title;
        /**
         * 是否允许删除，默认：`true`
         * @type {?|undefined}
         */
        GalleryItem.prototype.canDelete;
    }
    var GalleryComponent = /** @class */ (function () {
        function GalleryComponent() {
            /**
             * 是否允许删除，默认：`true`
             */
            this.canDelete = true;
            /**
             * 删除回调
             */
            this.delete = new core.EventEmitter();
            /**
             * 隐藏回调
             */
            this.hide = new core.EventEmitter();
            /**
             * 标记是否显示，支持双向绑定
             */
            this.show = false;
            this.showChange = new core.EventEmitter();
            this._showd = false;
        }
        Object.defineProperty(GalleryComponent.prototype, "imgs", {
            /**
             * 图片数据
             *
             * - 虽然支持传递数组，但并不支持在打开后切换图片。
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this.parseImgs(val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(GalleryComponent.prototype, "_visibility", {
            /**
             * @return {?}
             */
            get: function () {
                return this.show ? 'show' : 'hide';
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        GalleryComponent.prototype._antStart = function () {
            if (this.show) {
                this._showd = this.show;
            }
        };
        /**
         * @return {?}
         */
        GalleryComponent.prototype._antDone = function () {
            this._showd = this.show;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        GalleryComponent.prototype._onDel = function (item) {
            if (this.canDelete) {
                this.delete.emit(item);
                this._onHide();
            }
            return false;
        };
        /**
         * @return {?}
         */
        GalleryComponent.prototype._onHide = function () {
            this.show = false;
            this.showChange.emit(this.show);
            this.hide.emit();
        };
        /**
         * @private
         * @param {?} imgs
         * @return {?}
         */
        GalleryComponent.prototype.parseImgs = function (imgs) {
            if (Array.isArray(imgs)) {
                if (imgs.length > 0) {
                    if (typeof imgs[0] === 'string') {
                        imgs = (( /** @type {?} */(imgs))).map(( /**
                         * @param {?} url
                         * @return {?}
                         */function (url) {
                            return { url: url };
                        }));
                    }
                    else {
                        imgs = (( /** @type {?} */(imgs))).map(( /**
                         * @param {?} item
                         * @return {?}
                         */function (item) {
                            if (item.file) {
                                item.url = core$1.genImageUrl(item.file);
                            }
                            return item;
                        }));
                    }
                }
            }
            else {
                if (typeof imgs === 'string') {
                    imgs = [{ url: imgs }];
                }
                else {
                    /** @type {?} */
                    var imgUrl = core$1.genImageUrl(imgs);
                    if (imgUrl) {
                        imgs = [{ url: imgUrl }];
                    }
                }
            }
            // todo: 永远只返回一个
            // 针对未来可能直接上下个
            this._imgs = imgs && (( /** @type {?} */(imgs))).length > 0 ? imgs.slice(0, 1) : [];
        };
        return GalleryComponent;
    }());
    GalleryComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'weui-gallery',
                    exportAs: 'weuiGallery',
                    template: "<div *ngIf=\"_imgs\" class=\"weui-galleries\">\n  <ng-template ngFor let-item [ngForOf]=\"_imgs\">\n    <div\n      class=\"weui-gallery\"\n      [ngStyle]=\"{ display: _showd ? 'block' : 'none' }\"\n      [@visibility]=\"_visibility\"\n      (@visibility.start)=\"_antStart()\"\n      (@visibility.done)=\"_antDone()\"\n      (click)=\"_onHide()\"\n    >\n      <span class=\"weui-gallery__img\" [ngStyle]=\"{ 'background-image': 'url(' + item?.url + ')' }\"></span>\n      <div class=\"weui-gallery__opr\" *ngIf=\"canDelete\">\n        <a href=\"#\" class=\"weui-gallery__del\" (click)=\"_onDel(item)\">\n          <i class=\"weui-icon-delete weui-icon_gallery-delete\"></i>\n        </a>\n      </div>\n    </div>\n  </ng-template>\n</div>\n",
                    animations: [
                        animations.trigger('visibility', [
                            animations.state('show', animations.style({ opacity: 1 })),
                            animations.state('hide', animations.style({ opacity: 0 })),
                            animations.transition('hide <=> show', [animations.animate(200)]),
                        ]),
                    ],
                    preserveWhitespaces: false,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    encapsulation: core.ViewEncapsulation.None
                }] }
    ];
    GalleryComponent.propDecorators = {
        canDelete: [{ type: core.Input }],
        delete: [{ type: core.Output }],
        hide: [{ type: core.Output }],
        show: [{ type: core.Input }],
        showChange: [{ type: core.Output }],
        imgs: [{ type: core.Input }]
    };
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], GalleryComponent.prototype, "canDelete", void 0);
    __decorate([
        core$1.InputBoolean(),
        __metadata("design:type", Boolean)
    ], GalleryComponent.prototype, "show", void 0);
    if (false) {
        /** @type {?} */
        GalleryComponent.prototype._imgs;
        /**
         * 是否允许删除，默认：`true`
         * @type {?}
         */
        GalleryComponent.prototype.canDelete;
        /**
         * 删除回调
         * @type {?}
         */
        GalleryComponent.prototype.delete;
        /**
         * 隐藏回调
         * @type {?}
         */
        GalleryComponent.prototype.hide;
        /**
         * 标记是否显示，支持双向绑定
         * @type {?}
         */
        GalleryComponent.prototype.show;
        /** @type {?} */
        GalleryComponent.prototype.showChange;
        /** @type {?} */
        GalleryComponent.prototype._showd;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: gallery.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GalleryModule = /** @class */ (function () {
        function GalleryModule() {
        }
        return GalleryModule;
    }());
    GalleryModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [GalleryComponent],
                    exports: [GalleryComponent],
                    entryComponents: [GalleryComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-gallery.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.GalleryComponent = GalleryComponent;
    exports.GalleryModule = GalleryModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-gallery.umd.js.map
