/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/ptr', ['exports', '@angular/core', 'ngx-weui/core', '@angular/common'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].ptr = {}), global.ng.core, global['ngx-weui'].core, global.ng.common));
}(this, (function (exports, i0, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: ptr.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRConfig = /** @class */ (function () {
        function PTRConfig() {
            /**
             * 是否使用默认icon样式，默认：`false`
             */
            this.customIcon = false;
            /**
             * 下拉icon，支持HTML
             */
            this.pullIcon = '<i class="weui-icon-download"></i>';
            /**
             * 加载中icon，支持HTML
             */
            this.loadingIcon = '<i class="weui-loading"></i>';
            /**
             * 加载成功icon，支持HTML
             */
            this.successIcon = '<i class="weui-icon-success"></i>';
            /**
             * 下拉刷新容器高度（单位：px），默认：`100`
             */
            this.height = 100;
            /**
             * 下拉范围有效（单位：%），默认：`80`
             */
            this.treshold = 80;
        }
        return PTRConfig;
    }());
    PTRConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ PTRConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function PTRConfig_Factory() { return new PTRConfig(); }, token: PTRConfig, providedIn: "root" });
    if (false) {
        /**
         * 是否使用默认icon样式，默认：`false`
         * @type {?}
         */
        PTRConfig.prototype.customIcon;
        /**
         * 下拉icon，支持HTML
         * @type {?}
         */
        PTRConfig.prototype.pullIcon;
        /**
         * 加载中icon，支持HTML
         * @type {?}
         */
        PTRConfig.prototype.loadingIcon;
        /**
         * 加载成功icon，支持HTML
         * @type {?}
         */
        PTRConfig.prototype.successIcon;
        /**
         * 下拉刷新容器高度（单位：px），默认：`100`
         * @type {?}
         */
        PTRConfig.prototype.height;
        /**
         * 下拉范围有效（单位：%），默认：`80`
         * @type {?}
         */
        PTRConfig.prototype.treshold;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: ptr.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRComponent = /** @class */ (function () {
        /**
         * @param {?} el
         * @param {?} DEF
         * @param {?} cdr
         */
        function PTRComponent(el, DEF, cdr) {
            this.el = el;
            this.DEF = DEF;
            this.cdr = cdr;
            this.ogY = 0;
            this.touching = false;
            this.initScrollTop = 0;
            this.loading = false;
            this._animating = false;
            this._pullPercent = 0;
            /**
             * 是否禁止
             */
            this.disabled = false;
            /**
             * 下拉滚动时回调，返回一个0-100%的参数
             */
            this.scroll = new i0.EventEmitter();
            /**
             * 刷新回调
             */
            this.refresh = new i0.EventEmitter();
            this.config = Object.assign({}, DEF);
        }
        Object.defineProperty(PTRComponent.prototype, "config", {
            /**
             * @return {?}
             */
            get: function () {
                return this._config;
            },
            /**
             * @param {?} val
             * @return {?}
             */
            set: function (val) {
                this._config = Object.assign(Object.assign({}, this.DEF), val);
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(PTRComponent.prototype, "icon", {
            /**
             * @return {?}
             */
            get: function () {
                return this._pullPercent !== 100 ? ( /** @type {?} */(this.config.pullIcon)) : this.loading ? ( /** @type {?} */(this.config.loadingIcon)) : ( /** @type {?} */(this.config.successIcon));
            },
            enumerable: false,
            configurable: true
        });
        /**
         * 设置最后更新标签
         *
         * @param {?} label 标签内容（支持HTML）
         * @return {?}
         */
        PTRComponent.prototype.setLastUpdatedLabel = function (label) {
            this._lastLabel = label;
            this.cdr.detectChanges();
        };
        /**
         * 设置刷新成功
         *
         * @param {?=} lastUpdatedLabel
         * @return {?}
         */
        PTRComponent.prototype.setFinished = function (lastUpdatedLabel) {
            var _this = this;
            this._pullPercent = 0;
            this.loading = false;
            this._animating = true;
            this.cdr.detectChanges();
            if (!this.touching) {
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    _this._animating = false;
                    if (lastUpdatedLabel) {
                        _this.setLastUpdatedLabel(lastUpdatedLabel);
                    }
                    _this.cdr.detectChanges();
                }), 350);
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        PTRComponent.prototype.onTouchStart = function ($event) {
            if (this.disabled || this.touching || this.loading) {
                return;
            }
            this.touching = true;
            this.touchId = $event.targetTouches[0].identifier;
            this.ogY = this._pullPercent === 0 ? $event.targetTouches[0].pageY : $event.targetTouches[0].pageY - this._pullPercent;
            this.initScrollTop = this.contentEl.scrollTop;
            this._animating = false;
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        PTRComponent.prototype.onTouchMove = function ($event) {
            if (this.disabled || !this.touching || this.loading) {
                return;
            }
            if ($event.targetTouches[0].identifier !== this.touchId) {
                return;
            }
            /** @type {?} */
            var pageY = $event.targetTouches[0].pageY;
            /** @type {?} */
            var diffY = pageY - this.ogY;
            // if it's scroll
            if (diffY < 0) {
                return;
            }
            // if it's not at top
            if (this.contentEl.scrollTop > 0) {
                return;
            }
            if ($event.cancelable) {
                $event.preventDefault();
            }
            // let diffY = Math.abs(this.ogY - pageY);
            this._pullPercent = diffY - this.initScrollTop > 100 ? 100 : diffY - this.initScrollTop;
            this.scroll.emit(this._pullPercent);
        };
        /**
         * @return {?}
         */
        PTRComponent.prototype.onTouchEnd = function () {
            if (this.disabled || !this.touching || this.loading) {
                return;
            }
            /** @type {?} */
            var _pullPercent = this._pullPercent;
            /** @type {?} */
            var loading = false;
            if (_pullPercent >= ( /** @type {?} */(this.config.treshold))) {
                loading = true;
            }
            else {
                _pullPercent = 0;
            }
            this.touching = false;
            this.ogY = 0;
            this.touchId = undefined;
            this.initScrollTop = 0;
            this._animating = loading;
            this._pullPercent = _pullPercent;
            this.loading = loading;
            if (loading) {
                this.refresh.emit(this);
            }
            this.cdr.detectChanges();
        };
        /**
         * @return {?}
         */
        PTRComponent.prototype.ngOnInit = function () {
            this.contentEl = ( /** @type {?} */(( /** @type {?} */(this.el.nativeElement.querySelector('.weui-ptr__content')))));
        };
        return PTRComponent;
    }());
    PTRComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-ptr',
                    exportAs: 'weuiPtr',
                    template: "<div\n  class=\"weui-ptr__loader\"\n  [ngStyle]=\"{\n    'height.px': config.height,\n    'margin-top.px': -config.height! + _pullPercent / (100 / config.height!),\n    transition: _animating ? 'all .5s' : 'none'\n  }\"\n>\n  <div style=\"flex: 1 1 0%; padding: 5px;\" *ngIf=\"!config.customIcon\">\n    <span\n      [innerHTML]=\"icon\"\n      class=\"weui-ptr__icon\"\n      style=\"display: inline-block;\"\n      [ngStyle]=\"{\n        transform: 'rotate(' + -(_pullPercent !== 100 ? _pullPercent * 1.8 : 0) + 'deg)',\n        color: _pullPercent !== 100 ? '#5f5f5f' : '#1AAD19'\n      }\"\n    ></span>\n    <p *ngIf=\"_lastLabel\" class=\"weui-ptr__label\">{{ _lastLabel }}</p>\n  </div>\n  <ng-content select=\"[loader]\"></ng-content>\n</div>\n<div class=\"weui-ptr__content\">\n  <ng-content></ng-content>\n</div>\n",
                    host: {
                        '(touchstart)': 'onTouchStart($event)',
                        '(touchmove)': 'onTouchMove($event)',
                        '(touchend)': 'onTouchEnd()',
                        '(touchcancel)': 'onTouchEnd()',
                        '[class.weui-ptr]': 'true',
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    PTRComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: PTRConfig },
        { type: i0.ChangeDetectorRef }
    ]; };
    PTRComponent.propDecorators = {
        disabled: [{ type: i0.Input }],
        scroll: [{ type: i0.Output }],
        refresh: [{ type: i0.Output }],
        config: [{ type: i0.Input }]
    };
    __decorate([
        core.InputBoolean(),
        __metadata("design:type", Boolean)
    ], PTRComponent.prototype, "disabled", void 0);
    if (false) {
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.ogY;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.touching;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.touchId;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.initScrollTop;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.contentEl;
        /** @type {?} */
        PTRComponent.prototype.loading;
        /** @type {?} */
        PTRComponent.prototype._animating;
        /** @type {?} */
        PTRComponent.prototype._pullPercent;
        /** @type {?} */
        PTRComponent.prototype._lastLabel;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype._config;
        /**
         * 是否禁止
         * @type {?}
         */
        PTRComponent.prototype.disabled;
        /**
         * 下拉滚动时回调，返回一个0-100%的参数
         * @type {?}
         */
        PTRComponent.prototype.scroll;
        /**
         * 刷新回调
         * @type {?}
         */
        PTRComponent.prototype.refresh;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.el;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.DEF;
        /**
         * @type {?}
         * @private
         */
        PTRComponent.prototype.cdr;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: ptr.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PTRModule = /** @class */ (function () {
        function PTRModule() {
        }
        return PTRModule;
    }());
    PTRModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule],
                    declarations: [PTRComponent],
                    exports: [PTRComponent],
                    entryComponents: [PTRComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-ptr.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.PTRComponent = PTRComponent;
    exports.PTRConfig = PTRConfig;
    exports.PTRModule = PTRModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-ptr.umd.js.map
