/**
 * @license ngx-weui(cipchk@qq.com) v10.0.2
 * (c) 2020 Cipchk https://github.com/cipchk/ngx-weui
 * License: MIT
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('ngx-weui/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-weui/searchbar', ['exports', '@angular/core', 'ngx-weui/core', 'rxjs', 'rxjs/operators', '@angular/common', '@angular/forms'], factory) :
    (global = global || self, factory((global['ngx-weui'] = global['ngx-weui'] || {}, global['ngx-weui'].searchbar = {}), global.ng.core, global['ngx-weui'].core, global.rxjs, global.rxjs.operators, global.ng.common, global.ng.forms));
}(this, (function (exports, i0, core, rxjs, operators, common, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                __createBinding(exports, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: searchbar.config.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarConfig = /** @class */ (function () {
        function SearchBarConfig() {
            /**
             * 占位符，默认：`搜索`
             */
            this.placeholder = '搜索';
            /**
             * 取消按键文字，默认：`取消`
             */
            this.cancelText = '取消';
            /**
             * 去抖时长（单位：ms），默认：`300`
             */
            this.debounceTime = 300;
        }
        return SearchBarConfig;
    }());
    SearchBarConfig.decorators = [
        { type: i0.Injectable, args: [{ providedIn: 'root' },] }
    ];
    /** @nocollapse */ SearchBarConfig.ɵprov = i0.ɵɵdefineInjectable({ factory: function SearchBarConfig_Factory() { return new SearchBarConfig(); }, token: SearchBarConfig, providedIn: "root" });
    if (false) {
        /**
         * 占位符，默认：`搜索`
         * @type {?}
         */
        SearchBarConfig.prototype.placeholder;
        /**
         * 取消按键文字，默认：`取消`
         * @type {?}
         */
        SearchBarConfig.prototype.cancelText;
        /**
         * 去抖时长（单位：ms），默认：`300`
         * @type {?}
         */
        SearchBarConfig.prototype.debounceTime;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: searchbar.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarComponent = /** @class */ (function () {
        /**
         * @param {?} DEF
         */
        function SearchBarComponent(DEF) {
            this._q = '';
            /**
             * 搜索回调
             */
            this.search = new i0.EventEmitter();
            /**
             * 取消回调
             */
            this.cancel = new i0.EventEmitter();
            /**
             * 清空回调
             */
            this.clear = new i0.EventEmitter();
            /**
             * 提交回调（指的是键盘回车后）
             */
            this.submit = new i0.EventEmitter();
            this._focus = false;
            this._subject = new rxjs.Subject();
            Object.assign(this, DEF);
        }
        Object.defineProperty(SearchBarComponent.prototype, "value", {
            /**
             * @param {?} _value
             * @return {?}
             */
            set: function (_value) {
                this._q = _value;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        SearchBarComponent.prototype.ngOnInit = function () {
            var _this = this;
            this._sub = this._subject.pipe(operators.debounceTime(this.debounceTime), operators.distinctUntilChanged()).subscribe(( /**
             * @param {?} q
             * @return {?}
             */function (q) {
                _this.search.emit(q);
            }));
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._doFocus = function () {
            this._term.nativeElement.focus();
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onBlur = function () {
            if (this._q === '') {
                this._focus = false;
            }
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onSearch = function () {
            this._subject.next(this._q);
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onCancel = function () {
            this._q = '';
            this._onBlur();
            this._subject.next('');
            this.cancel.emit();
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype._onClear = function () {
            this._q = '';
            this._doFocus();
            this._subject.next('');
            this.clear.emit();
        };
        /**
         * @param {?} e
         * @return {?}
         */
        SearchBarComponent.prototype._onSubmit = function (e) {
            e.preventDefault();
            e.stopPropagation();
            this._subject.next(this._q);
            this.submit.emit(this._q);
            return false;
        };
        /**
         * @return {?}
         */
        SearchBarComponent.prototype.ngOnDestroy = function () {
            if (this._sub) {
                this._sub.unsubscribe();
            }
        };
        return SearchBarComponent;
    }());
    SearchBarComponent.decorators = [
        { type: i0.Component, args: [{
                    selector: 'weui-searchbar',
                    exportAs: 'weuiSearchbar',
                    template: "<form class=\"weui-search-bar__form\" (ngSubmit)=\"_onSubmit($event)\">\n  <div class=\"weui-search-bar__box\">\n    <i class=\"weui-icon-search\"></i>\n    <input\n      #term\n      type=\"search\"\n      autocomplete=\"off\"\n      name=\"q\"\n      class=\"weui-search-bar__input\"\n      [placeholder]=\"placeholder\"\n      [(ngModel)]=\"_q\"\n      (ngModelChange)=\"_onSearch()\"\n      (focus)=\"_focus = true\"\n      (blur)=\"_onBlur()\"\n    />\n    <a href=\"javascript:\" class=\"weui-icon-clear\" (click)=\"_onClear()\"></a>\n  </div>\n  <label class=\"weui-search-bar__label\" (click)=\"_doFocus()\">\n    <i class=\"weui-icon-search\"></i>\n    <span>{{ placeholder }}</span>\n  </label>\n</form>\n<a class=\"weui-search-bar__cancel-btn\" (click)=\"_onCancel()\">{{ cancelText }}</a>\n",
                    host: {
                        '[class.weui-search-bar]': "true",
                        '[class.weui-search-bar_focusing]': "_focus",
                    },
                    preserveWhitespaces: false,
                    changeDetection: i0.ChangeDetectionStrategy.OnPush,
                    encapsulation: i0.ViewEncapsulation.None
                }] }
    ];
    /** @nocollapse */
    SearchBarComponent.ctorParameters = function () { return [
        { type: SearchBarConfig }
    ]; };
    SearchBarComponent.propDecorators = {
        placeholder: [{ type: i0.Input }],
        cancelText: [{ type: i0.Input }],
        debounceTime: [{ type: i0.Input }],
        search: [{ type: i0.Output }],
        cancel: [{ type: i0.Output }],
        clear: [{ type: i0.Output }],
        submit: [{ type: i0.Output }],
        _term: [{ type: i0.ViewChild, args: ['term', { static: true },] }],
        value: [{ type: i0.Input }]
    };
    __decorate([
        core.InputNumber(),
        __metadata("design:type", Number)
    ], SearchBarComponent.prototype, "debounceTime", void 0);
    if (false) {
        /** @type {?} */
        SearchBarComponent.prototype._q;
        /**
         * 占位符，默认：`搜索`
         * @type {?}
         */
        SearchBarComponent.prototype.placeholder;
        /**
         * 取消按键文字，默认：`取消`
         * @type {?}
         */
        SearchBarComponent.prototype.cancelText;
        /**
         * 去抖时长（单位：ms），默认：`300`
         * @type {?}
         */
        SearchBarComponent.prototype.debounceTime;
        /**
         * 搜索回调
         * @type {?}
         */
        SearchBarComponent.prototype.search;
        /**
         * 取消回调
         * @type {?}
         */
        SearchBarComponent.prototype.cancel;
        /**
         * 清空回调
         * @type {?}
         */
        SearchBarComponent.prototype.clear;
        /**
         * 提交回调（指的是键盘回车后）
         * @type {?}
         */
        SearchBarComponent.prototype.submit;
        /** @type {?} */
        SearchBarComponent.prototype._focus;
        /**
         * @type {?}
         * @private
         */
        SearchBarComponent.prototype._term;
        /**
         * @type {?}
         * @private
         */
        SearchBarComponent.prototype._sub;
        /**
         * @type {?}
         * @private
         */
        SearchBarComponent.prototype._subject;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: searchbar.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchBarModule = /** @class */ (function () {
        function SearchBarModule() {
        }
        return SearchBarModule;
    }());
    SearchBarModule.decorators = [
        { type: i0.NgModule, args: [{
                    imports: [common.CommonModule, forms.FormsModule],
                    declarations: [SearchBarComponent],
                    exports: [SearchBarComponent],
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: ngx-weui-searchbar.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.SearchBarComponent = SearchBarComponent;
    exports.SearchBarConfig = SearchBarConfig;
    exports.SearchBarModule = SearchBarModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-weui-searchbar.umd.js.map
