import { ElementRef, OnInit } from '@angular/core';
/**
 * 单元格滑块
 */
export declare class SwipeDirective implements OnInit {
    private el;
    private curX;
    private opend;
    private swipeEl;
    /**
     * 右边滑动宽度（单位：px），默认：`68`
     */
    width: number;
    constructor(el: ElementRef<HTMLElement>);
    ngOnInit(): void;
    private setPos;
    private getTouch;
    onTouchStart($event: TouchEvent): void;
    onTouchMove($event: TouchEvent): void;
    onTouchEnd($event: TouchEvent): void;
}
