import { ElementRef, OnDestroy, OnInit } from '@angular/core';
import { Observable } from 'rxjs';
/**
 * 获取验证码
 */
export declare class VCodeDirective implements OnInit, OnDestroy {
    private el;
    /**
     * 发送事件
     */
    onSend: () => Observable<boolean>;
    /**
     * 时长（单位：秒），默认：`60`
     */
    seconds: number;
    /**
     * 倒计时模板，使用 `${num}` 表示当前秒数
     */
    tpl: string;
    /**
     * 重新发送提醒文本
     */
    error: string;
    _disabled: boolean;
    private _cur;
    private _t;
    constructor(el: ElementRef);
    ngOnInit(): void;
    _onClick(): void;
    private err;
    private tick;
    private setText;
    private destroy;
    ngOnDestroy(): void;
}
