export declare class InfiniteLoaderConfig {
    /**
     * 容器高度，默认：`100vh`
     */
    height?: string;
    /**
     * 滚动至x%时触发加载，默认：75%
     */
    percent?: number;
    /**
     * 加载中文本（支持HTML），默认：weui-loadmore 组件
     */
    loading?: string;
    /**
     * 完成所有数据加载文本（支持HTML），默认：weui-loadmore 组件
     */
    finished?: string;
    /** 滚动节流时长（单位：ms），默认：`100` */
    throttle?: number;
}
