import { ChangeDetectorRef, EventEmitter, OnChanges, SimpleChange, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { RatingConfig } from './rating.config';
export declare class RatingComponent implements ControlValueAccessor, OnChanges {
    private DEF;
    private cdr;
    private onChange;
    _range: any[];
    _value: number;
    _preValue: number;
    _class: string;
    /** 配置项 */
    config: RatingConfig;
    /** 是否只读模式，默认：`false` */
    readonly: boolean;
    /** 选中后回调，参数：选中值 */
    readonly selected: EventEmitter<number>;
    constructor(DEF: RatingConfig, cdr: ChangeDetectorRef);
    private setConfig;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    _rate(value: number): void;
    writeValue(_value: any): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(_fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
}
