import { AfterContentInit, ChangeDetectorRef, ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit, QueryList, SimpleChange, SimpleChanges } from '@angular/core';
import { SidebarComponent } from './sidebar.component';
/**
 * 侧边栏容器
 */
export declare class SidebarContainerComponent implements AfterContentInit, OnChanges, OnInit, OnDestroy {
    private _ref;
    private _el;
    _sidebars: QueryList<SidebarComponent>;
    _showBackdrop: boolean;
    readonly _showBackdropChange: EventEmitter<boolean>;
    private orgOverflowX;
    private get body();
    constructor(_ref: ChangeDetectorRef, _el: ElementRef);
    ngAfterContentInit(): void;
    ngOnChanges(changes: {
        [P in keyof this]?: SimpleChange;
    } & SimpleChanges): void;
    ngOnInit(): void;
    ngOnDestroy(): void;
    _getStyles(): CSSStyleDeclaration;
    _onBackdropClicked($event: Event): boolean;
    private _subscribe;
    private _unsubscribe;
    /** 状态变更时重新计算样式 */
    private _markForCheck;
    private _onToggle;
}
