import { ElementRef, EventEmitter, OnChanges, OnDestroy, OnInit } from '@angular/core';
import { UpdateHostClassService } from 'ngx-weui/core';
export declare type ToptipsType = 'default' | 'warn' | 'info' | 'primary' | 'success';
export declare class ToptipsComponent implements OnInit, OnChanges, OnDestroy {
    private el;
    private uhcs;
    private timer;
    _showd: boolean;
    /**
     * 文本
     */
    text: string;
    /**
     * 显示时长后自动关闭（单位：ms），默认：`2000`
     */
    time: number;
    /**
     * 类型
     */
    type: ToptipsType;
    /**
     * 隐藏后回调
     */
    readonly hide: EventEmitter<any>;
    constructor(el: ElementRef, uhcs: UpdateHostClassService);
    private setClassMap;
    ngOnInit(): void;
    ngOnChanges(): void;
    onShow(): this;
    onHide(): void;
    private destroy;
    ngOnDestroy(): void;
}
